<%--
  Copyright © 2007 Cédric Brun
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Cédric Brun <cedric.brun@obeo.fr>
--%>
<%
metamodel http://www.eclipse.org/emf/2002/Ecore

import org.acceleo.module.pim.ecore.gen.python.services.EcoreServices
import org.acceleo.module.pim.ecore.gen.python.common.name
%>

<%script type="EPackage" name="packageToPythonCommonFile" file="<%ModuleCommon%>"%>
"""

"""

class <%baseClass%>:
  """
  <%baseClass%> is the base class of all elements in the <%moduleName%> module.
  """ 
  def __init__(self):
    #<%startUserCode%> for <%baseClass%> initialization
    pass
    #<%endUserCode%>
    self.__internal_resource__ = None
   
  def __eResource__(self):
    pass 
  
  
class <%resourceClass%>:
  """
   The <%resourceClass%> is responsible for model serialization.
  """
  def __init__(self,uri):
    #<%startUserCode%> for <%resourceClass%> initialization
    # type here your specific code
    #<%endUserCode%>
    self.__content__ = []
    self.__uri__ = uri

  def load(self,options=dict()):
    pass
    
  def save(self,options=dict()):
    pass
    
    
 
class <%resourceFactory%>:
  """
   The <%resourceFactory%> is responsible for creating resource.
  """
  def __init__(self):
    #<%startUserCode%> for <%resourceFactory%> initialization
    # type here your specific code
    pass
    #<%endUserCode%>

  def create(self,uri,options=dict()):
    pass

    
