<%--
  Copyright © 2007 Cédric Brun
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Cédric Brun <cedric.brun@obeo.fr>
--%>
<%
metamodel http://www.eclipse.org/emf/2002/Ecore
import org.acceleo.module.pim.ecore.gen.python.common.name
import org.acceleo.module.pim.ecore.gen.python.common.types
%>

<%script type="ecore.EPackage" name="toModuleInit" file="<%ModuleInit%>"%>
"""

Module <%name%>

Sample usage :

  >>> from <%name.toLowerCase()%> import <%firstClass.ClassName%>
<%firstClass.sampleClassUsage%>

"""

<%if (eSubpackages){%>
#import subpackages
<%for (eSubpackages){%>
import <%moduleName.replaceAll("/",".")%>
<%}%>
<%}%>

from <%moduleName%> import *

from __factory__ import <%factoryClassName%>
"""
Initialize the default instances factory
"""
factory = <%factoryClassName%>()
#<%startUserCode%> <%moduleName%> __init__ 
# here you may redefine the module singletons or do some special tricks
#<%endUserCode%>

from __common__ import <%resourceFactory%>
resourceFactory = <%resourceFactory%>()

<%script type="ecore.EClass" name="sampleClassUsage" %>
  >>> <%ClassName.toLowerCase()%> = <%ClassName%>()  
  <%for (eAttributes){%>
  >>> <%eContainer.ClassName.toLowerCase()%>.<%AttributeName%> = <%eAttributeType.typeInitialisation%>
  <%}%>
<%eReferences.sampleReferenceUsage.sep("\n")%>


<%script type="ecore.EReference" name="sampleReferenceUsage" %>
  >>> <%eContainingClass.ClassName.toLowerCase%>.<%name%>.append(<%eType.name%>())
  >>> <%eType.name.toLowerCase()%>  = <%eContainingClass.ClassName.toLowerCase%>.<%name%>[0]

<%script type="ecore.EPackage" name="firstClass" %>
<%eClassifiers.filter("EClass").nFirst()%>

<%script type="ecore.EClass" name="firstAttribute" %>
<%eAttributes.nFirst()%>