<%--
  Copyright © 2007 Cédric Brun
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Cédric Brun <cedric.brun@obeo.fr>
--%>
<%
metamodel http://www.eclipse.org/emf/2002/Ecore
import org.acceleo.module.pim.ecore.gen.python.common.name
import org.acceleo.module.pim.ecore.gen.python.common.types
import org.acceleo.module.pim.ecore.gen.python.common.filter
import org.acceleo.module.pim.ecore.gen.python.common.documentation
%>


<%script type="EOperation" name="toPythonInstanceMethod"%>
<%if (!eParameters){%>
  def <%operationName%>(self):
<%}else{%>
  def <%operationName%>(self,<%eParameters.parameterName.sep(",")%>):
<%}%>
    """
   <%documentation%>
<%if (eParameters){%>
    Keyword Arguments:
    <%for (eParameters){%>    
       <%parameterPyDoc%>       
    <%}%>    
<%}%>   
    """
    #<%startUserCode%> <%eContainingClass.ClassName%>.<%operationName%> implementation
    #TODO code the function body
    pass  
    #<%endUserCode%>
  

  
<%script type="EOperation" name="documentation"%>
<%if (annotedDocumentation!=null){%>
<%annotedDocumentation%>
<%}else{%>
No documentation found for this method.
<%}%>

