<%--
  Copyright © 2007 Cédric Brun
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Cédric Brun <cedric.brun@obeo.fr>
--%>
<%
metamodel http://www.eclipse.org/emf/2002/Ecore
import org.acceleo.module.pim.ecore.gen.python.common.name
import org.acceleo.module.pim.ecore.gen.python.relation
import org.acceleo.module.pim.ecore.gen.python.common.types
%>

<%script  type="ecore.EPackage" name="toPythonTest" %>

import unittest

class Test<%name%>(unittest.TestCase):

<%eContents().filter("EClass").toPythonTest%>
<%eContents().filter("EClass").eReferences.testReference%>

if __name__ == '__main__':
    unittest.main()
<%script  type="ecore.EClass" name="toPythonTest" %>
  def test<%ClassName%>Attributes(self):
	  <%ClassName.toLowerCase()%> = <%ClassName%>()  
	  <%for (eAttributes){%>
	  <%eContainer.ClassName.toLowerCase()%>.<%AttributeName%> = <%eAttributeType.typeInitialisation%>
	  self.assertEquals(<%eContainer.ClassName.toLowerCase()%>.<%AttributeName%>,<%eType.typeInitialisation%>)
	  <%}%>



<%script  type="ecore.EReference" name="testReference" %>  
  def test<%eContainingClass.ClassName%>Relations<%ReferenceName%>(self):
      <%eContainingClass.ClassName.toLowerCase()%> = <%eContainingClass.ClassName%>()  
      #testing <%ReferenceName%>      
      <%if (unique){%>
      #checking unicity support
      <%eType.name.toLowerCase()%>1 = <%eType.ClassName%>()
      <%eContainingClass.ClassName.toLowerCase%>.<%name%>.append(<%eType.name.toLowerCase()%>1)
      self.assertRaises(Exception,<%eContainingClass.ClassName.toLowerCase%>.<%name%>.append,<%eType.name.toLowerCase()%>1)
	  <%}%>
	  #checking upper_bound limit
	  <%if (upperBound != -1){%>
      <%eContainingClass.ClassName.toLowerCase()%>_limit = <%eContainingClass.ClassName%>()  
      for i in range(0,<%upperBound - 1%>):
        <%eContainingClass.ClassName.toLowerCase%>.<%name%>.append(<%eType.ClassName%>())
      self.assertRaises(Exception,<%eContainingClass.ClassName.toLowerCase%>.<%name%>.append,<%eType.ClassName%>())
	  <%}%>



