<%--
  Author     Pascal Lindelauf
  E-Mail     plindelauf@yellowtail.nl
  Copyright  2007 Yellowtail
  All rights reserved.   This program and the accompanying materials
  are made available under the terms of the GNU Public License v2.0 or any later version
  which accompanies this distribution, and is available at
  http://www.gnu.org/licenses/gpl.txt
    You can apply any license to the files generated with this template
  and Acceleo.
--%>
<%--
  Target project: DomainModel
  This template generates a simple repository interface class for each 
  UML class stereotyped as "entityObject" and whose tagged value 
  "isAggregateRoot" equals "true".
--%>
<%
metamodel http://www.obeo.fr/acceleo/uml14

import com.yellowtail.uml14.gen.csharp.services.ClassService
import com.yellowtail.uml14.gen.csharp.services.NamespaceService
%>

<%script type="core.Class" name="filename"%>
<%if (isAggregateRoot){%>
<%namespace.getRootContainer().name%>/DomainModel/<%namespace.name%>/DomainPersistence/I<%name%>Repository.cs
<%}%>

<%script type="core.Class" name="irepository" file="<%filename%>"%>
using System;
using System.Collections.Generic;
using <%namespace.getRootContainer().name%>.DomainModel.Common;

namespace <%namespace.getRootContainer().name%>.DomainModel.<%namespace.name%>.DomainPersistence
{
    public interface I<%name%>Repository: IRepository
    {
        <%name%> Get(int id);
        IList<<%name%>> GetAll<%pluralName%>();
   }
}