/*
 * Author     Pascal Lindelauf
 * E-Mail     plindelauf@yellowtail.nl
 * Copyright  2007 Yellowtail
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the GNU Public License v2.0 or any later version
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.txt
 */
/*
 * This class contains operations that simplify access to the  
 * UML model element.
 */
package com.yellowtail.uml14.gen.csharp.services;

import java.util.HashSet;

import fr.obeo.acceleo.uml14.foundation.core.Association;

/**
 * @author pli
 *
 */

public class ModelService {
	private static HashSet processedAssociations = new HashSet();
	
	public void addToProcessedAssociations(Association assoc){
		// The nature of the set will make sure we are not stuck with duplicates
		processedAssociations.add(assoc);
	}
}