<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices

import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.ioc
%>

<%script type="Model" name="fullFilePath"%>
/META-INF/spring/component.xml

<%script type="Model" name="springApplicationContext" file="<%fullFilePath%>"%>
<?xml version="1.0" encoding="UTF-8"?>
<beans xmlns="http://www.springframework.org/schema/beans"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xsi:schemaLocation="http://www.springframework.org/schema/beans http://www.springframework.org/schema/beans/spring-beans-2.0.xsd">

<!-- <%startUserCode%> component definition -->
<import resource="classpath:META-INF/spring/<%baseImports%>/layer-controllers.xml"/>
<import resource="classpath:META-INF/spring/<%baseImports%>/layer-uis.xml"/>
<import resource="classpath:META-INF/spring/<%baseImports%>/layer-services.xml"/>
<import resource="classpath:META-INF/spring/<%baseImports%>/layer-daos-hibernate.xml"/>

<!-- technical layers -->
<import resource="classpath:META-INF/spring/layer-hibernate.xml"/>
<import resource="classpath:META-INF/spring/layer-velocity.xml"/>
<!--import resource="classpath:META-INF/spring/layer-xfire.xml"/-->
<!-- <%endUserCode%> component definition -->
	
</beans>