<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML


import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices

import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices

import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure

import org.acceleo.module.pim.uml21.gen.java.dao.api.dao-common
import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.profile
%>

<%script type="Class" name="fullFilePath"%>
<%if (isDao){%><%daoPackage.toPath()%>/I<%name%>.java<%}%>

<%script type="Class" name="generateDao" file="<%fullFilePath%>"%>
package <%daoPackage%>;

<%getAssociatedBusinessObject().put("entity")%>

import org.sharengo.orm.DAO;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;

import org.sharengo.exceptions.TechnicalException;

<%if (operationsParametersTypes.isEmpty()){%>
import <%get("entity").entityPackage%>.<%get("entity").name%>;
<%}else{%>
	<%for (operationsParametersTypes){%>
		<%if (hasStereotype(getProperty("Entity"))){%>
import <%get("entity").entityPackage%>.<%name%>;
		<%}else{%>
import <%getCompleteName()%>;	
		<%}%>
	<%}%>
<%}%>

<%genCollectionImports%>

// <%startUserCode%> for import

// <%endUserCode%> for import

public interface I<%name%> extends DAO<<%get("entity").name%>> {	
	// Custom operations
	<%for (ownedOperation){%>
	<%generateJavadoc%>
	public <%generateReturn%> <%name%>(<%generateParameters%>) throws TechnicalException;
	<%}%>
}
