<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.dao.api.dao-common

import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices

import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.profile
%>

<%script type="Model" name="fullFilePath"%>
<%if (daos){%>/<%testPackage.toPath()%>/DAOAllTests.java<%}%>

<%script type="Model" name="generate" file="<%fullFilePath%>"%>
package <%testPackage%>;

import junit.framework.Test;
import junit.framework.TestSuite;

<%for (daos){%>
import <%daoImplPackage%>.<%name%>Test;
<%}%>

public class DAOAllTests {

	public static Test suite() {
		TestSuite suite = new TestSuite(
				"Test for <%projectName%>");
		//$JUnit-BEGIN$
		<%for (daos){%>
		suite.addTestSuite(<%name%>Test.class);
		<%}%>
		//$JUnit-END$
		return suite;
	}

}
