<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services

import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices
%>

<%script type="Interface" name="fullFilePath"%>
<%if ( isJavaClassifier() ){%>
/<%interfacePackage.toPath()%>/<%name%>.java
<%}%>

<%script type="Interface" name="generateJavaInterface" file="<%fullFilePath%>"%>
package <%interfacePackage%>;

// <%startUserCode%> for import

// <%endUserCode%> for import

/**
 * <%ownedComment.body%>
 */
public interface <%name%><%extensions%> {

<%-- Generate attributes --%>
<%for (attribute){%>
	<%if (isReadOnly){%> final <%}%><%if (isStatic){%> static <%}%><%type.convertToJavaType%> <%name%><%if (default!=null){%> = <%default%><%}%>;
<%}%>

<%-- Generate operations --%>
<%for (ownedOperation){%>
<%generateJavadoc%>
	public <%generateReturn%> <%name%>(<%generateParameters%>);
<%}%>

}

<%script type="Interface" name="extensions"%>
<%-- Manage extensions --%>
<%if (!general.isEmpty){%> extends <%general.name%><%}else{%> <%}%>

<%script type="Property" name="asParameter"%>
<%-- Used to render an attribute as a parameter of a method --%>
<%type.convertToJavaType%> <%name%>
