<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices

import org.acceleo.module.pim.uml21.services.Uml2Services

import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.profile
%>

<%script type="Class" name="fullFilePath"%>
<%if ( isService ){%><%servicePackage.toPath()%>/I<%name%>.java<%}%>

<%script type="Class" name="generateService" file="<%fullFilePath%>"%>
package <%servicePackage%>;

<%for (ownedOperation){%>
	<%for (raisedException){%>
import <%getCompleteName()%>;
	<%}%>
<%}%>

<%genCollectionImports%>

<%for (operationsParametersTypes){%>
	<%if (filter("Classifier").isEntity){%>
import <%entityPackage%>.<%name%>;
	<%}else if (filter("Classifier").isView){%>
import <%viewImplPackage%>.<%name%>;
	<%}else{%>
import <%getCompleteName()%>;	
	<%}%>
<%}%>

<%if (!superClass.isEmpty && superClass.isService){%> 
import <%superClass.servicePackage%>.I<%superClass.name%>;
<%}%>

import org.sharengo.exceptions.TechnicalException;

// <%startUserCode%> for import

// <%endUserCode%> for import

public interface I<%name%><%extensions%> {
	<%for (ownedOperation){%>
	<%generateJavadoc%>
	public <%generateReturn%> <%name%>(<%generateParameters%>) throws TechnicalException<%genExceptions%>;
	<%}%>
}

<%script type="Class" name="extensions"%>
<%if ( !superClass.isEmpty && superClass.isService ){%> extends I<%superClass.name%><%}%>
