<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.Uml2Services

import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices
import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services

import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.ioc
import org.acceleo.module.pim.uml21.gen.java.spring.profile
%>

<%script type="Model" name="fullFilePath"%>
<%if (views){%><%viewFactoryPackage.toPath()%>/ViewFactory.java<%}%>

<%script type="Model" name="generateUi" file="<%fullFilePath%>"%>
package <%viewFactoryPackage%>;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;

<%for (views) {%>
import <%uiImplPackage%>.<%name%>;
<%}%>

// <%startUserCode%> for import

// <%endUserCode%> for import


public class ViewFactory {	
	
	/**
	 * class dedicated logger
 	 */
	private static Log log = LogFactory.getLog(ViewFactory.class.getName());  

	private VelocityContext context = new VelocityContext();

	private VelocityEngine velocityEngine=null;
		
	public VelocityEngine getVelocityEngine() {
		return velocityEngine;
	}

	public void setVelocityEngine(VelocityEngine velocityEngine) {
		this.velocityEngine = velocityEngine;
	}
	
<%for (views) {%>	
	public <%name%> create<%name%>(){
		<%name%> <%name.toL1Case()%> = new <%name%>();
		<%name.toL1Case()%>.setVelocityEngine(velocityEngine);
		VelocityContext velocityContext = new VelocityContext();
		// <%startUserCode%> of create<%name%>() to populate velocityContext

		// <%endUserCode%>
		<%name.toL1Case()%>.setVelocityContext(velocityContext);	
		return <%name.toL1Case()%>;
	}
<%}%>

// <%startUserCode%> of others operations

// <%endUserCode%>
	
}
