<%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Stephane Lacrampe
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.Uml2Services
%>

<%-- 
This template deals with widgets mappings
--%>

<%script type="StructuralFeature" name="convertToJavaTypeFromStereotype"%>
<%-- We call the script below just to trim it --%>
<%StereotypeJavaTypeMapping().trim()%>

<%script type="StructuralFeature" name="StereotypeJavaTypeMapping"%>
<%if (hasStereotype(getProperty("List")) || hasStereotype(getProperty("Table"))){%>
Collection
<%-- TODO : gestion des type java 5.0 ? <<%type.convertToObject%>> --%>
<%}else{%>
String
<%}%>

<%script type="StructuralFeature" name="convertToHTMLUnitTypeFromStereotype"%>
<%StereotypeHTMLUnitTypeMapping.trim()%>

<%script type="StructuralFeature" name="StereotypeHTMLUnitTypeMapping"%>
<%if (hasStereotype(getProperty("Text"))){%>
HtmlTextInput
<%}else{%> 
	<%if (hasStereotype(getProperty("Password"))) {%>
HtmlPasswordInput
	<%}else{%> 
		<%if (hasStereotype(getProperty("Checkbox"))) {%>
HtmlCheckBoxInput
		<%}else{%> 
			<%if (hasStereotype(getProperty("Combobox"))) {%>
HtmlSelect
			<%}else{%> 
				<%if (hasStereotype(getProperty("Radio"))) {%>
HtmlRadioButtonInput
				<%}else{%> 
					<%if (hasStereotype(getProperty("Textarea"))) {%>
List
					<%}%>
				<%}%>
			<%}%>
		<%}%>
	<%}%>
<%}%>

<%script type="StructuralFeature" name="convertToHTMLUnitGetterTypeFromStereotype"%>
<%StereotypeHTMLUnitGetterTypeMapping.trim()%>

<%script type="StructuralFeature" name="StereotypeHTMLUnitGetterTypeMapping"%>
<%if hasStereotype(getProperty("Combobox")){%>
Select
<%}else{%>
	<%if hasStereotype(getProperty("Textarea")){%>
TextAreas
	<%}else{%>
Input
	<%}%>
<%}%>

<%script type="StructuralFeature" name="convertToHTMLStrutsTypeFromStereotype"%>
<%StereotypeToHtmlStrutsTypeMapping.trim()%>

<%script type="StructuralFeature" name="StereotypeToHtmlStrutsTypeMapping"%>
<%if (hasStereotype(getProperty("Text"))){%>
text
<%}else{%>
	<%if (hasStereotype(getProperty("Password"))){%>
password
	<%}else{%>
		<%if (hasStereotype(getProperty("Checkbox"))){%>
checkbox
		<%}else{%>
			<%if (hasStereotype(getProperty("Combobox"))){%>
select
			<%}else{%>
				<%if (hasStereotype(getProperty("Radio"))){%>
radio
				<%}else{%>
					<%if (hasStereotype(getProperty("Textarea"))){%>
textarea
					<%}%>
				<%}%>
			<%}%>
		<%}%>
	<%}%>
<%}%>


<%script type="Type" name="convertToObject"%>
<%if (hasStereotype("Dto")){%><%name%>Dto<%}else{%><%name%><%}%>
