<%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Stephane Lacrampe
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.struts.common.common
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.gen.java.struts.common.widgets_mappings
%>

<%-- 
This template deals with regression tests suite for User Interface
--%>

<%script type="Model" name="generate" file="/<%uiPackage.toPath()%>/test/htmlunit/UiFunctionnalTests.java"%>
<%-- Generate test class--%>
package <%uiPackage%>.test.htmlunit;

import junit.framework.Test;
import junit.framework.TestSuite;
<%for (getAllInstances("Class")){%>
	<%if (hasStereotype(getProperty("Screen"))){%>
import <%scenarioPackage%>.test.htmlunit.Test<%name%>Action;
	<%}%>
<%}%>

/**
 * Junit Suite testing for <%projectName%>
 * Launch all HtmlUnit tests
 *
 */
public class UiFunctionnalTests {

/**
 * Main method
 *
 */
public static Test suite() {
		TestSuite suite = new TestSuite("UI Functionnal Tests");

		// Add one entry for each test class 
		// or test suite.
<%for (getAllInstances("Class")){%>
	<%if (hasStereotype(getProperty("Screen"))){%>
		suite.addTestSuite(Test<%name%>Action.class);
	<%}%>
<%}%>

		//<%startUserCode%> for suite tests
		//<%endUserCode%>

		return suite;
	}

	//<%startUserCode%> for other tests
	//<%endUserCode%>

}

