<%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Stephane Lacrampe
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.struts.common.common
%>

<%-- 
This template deals with Struts actions
--%>

<%script type="Class" name="fullFilePath"%>
<%-- Only Classes with stereotype Screen--%>
<%if (hasStereotype(getProperty("Screen"))){%>
/<%scenarioPackage.toPath()%>/actions/<%name%>Action.java
<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
<%-- Generate Struts actions--%>
package <%scenarioPackage%>.actions;

// <%startUserCode%> for import
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import <%scenarioPackage%>.forms.<%name%>Form;

// <%endUserCode%> for import

/**
 * Implementation of <strong><%name%> Action</strong>
 * Scenario : <%package.name%>
 *
 */
public class <%name%>Action extends org.apache.struts.actions.DispatchAction {
    /**
     * Commons Logging instance.
     */
	private static final Log log = LogFactory.getLog(<%name%>Action.class);

    /**
     * Forward codes.
     */
	public final static String PAGE_SELF = "self"; //$NON-NLS-1$
<%-- class association navigation --%>
<%for (getAssociations().oppositeAttributeOf(current())[isNavigable()]){%>
	public final static String PAGE_<%type.name.toUpperCase()%> = "<%type.name.firstLower()%>"; //$NON-NLS-1$
<%}%>

<%-- init action method generation (Dispach)--%>
    /**
     * Process the specified HTTP request for <strong>init</strong> event.
     * 
     * @param mapping The ActionMapping used to select this instance
     * @param form The optional ActionForm bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     *
     * @exception Exception if an input/output error or servlet exception occurs
     */
	public ActionForward init(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		log.debug("Starting");
		String returnCode = PAGE_SELF;
		<%name%>Form <%name.firstLower()%>Form = (<%name%>Form)form;

		//<%startUserCode%> method init
		// TODO Write here the action code for init
		//<%endUserCode%>
	
		return mapping.findForward(returnCode);
	} 

<%-- actions methods generation (Dispach)--%>
<%for (ownedOperation){%>
    /**
     * Process the specified HTTP request for <strong><%name%></strong> event.
     * 
     * @param mapping The ActionMapping used to select this instance
     * @param form The optional ActionForm bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     *
     * @exception Exception if an input/output error or servlet exception occurs
     */
	public ActionForward <%name%>(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		log.debug("Starting");
		String returnCode = PAGE_SELF;
		<%class.name%>Form <%class.name.firstLower()%>Form = (<%class.name%>Form)form;
		//<%startUserCode%> method <%name%>
		// TODO Write here the action code for <%name%>
		//<%endUserCode%>
		return mapping.findForward(returnCode);
	}
<%}%>

//<%startUserCode%> user methods
//<%endUserCode%>

}

