<%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Stephane Lacrampe
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
%>

<%script type="Class" name="generateValidator"%>
<%for (attribute.filterExistProperty("association",false)){%>
	<%if (!hasStereotype(getProperty("Title")) && !hasStereotype(getProperty("List")) && !hasStereotype(getProperty("Table"))) {%>
		<%if (type.name == "Integer"){%>
            <field property="<%name.firstLower()%>" depends="integer">
                <arg0 key="<%class.name%>.errors.integer.<%name.toLowerCase()%>"/>
            </field>
		<%}%>
		<%if (type.name == "Double"){%>
            <field property="<%name.firstLower()%>" depends="float">
                <arg0 key="<%class.name%>.errors.float.<%name.toLowerCase()%>"/>
            </field>
		<%}%>
		<%if (type.name == "Date"){%>
            <field property="<%name.firstLower()%>" depends="date">
                <arg0 key="<%class.name%>.errors.date.<%name.toLowerCase()%>"/>
		        <var><var-name>datePattern</var-name><var-value>dd/MM/yyyy</var-value></var>
            </field>
		<%}%>
		<%if (type.name == "Email"){%>
            <field property="<%name.firstLower()%>" depends="email">
                <arg0 key="<%class.name%>.errors.email.<%name.toLowerCase()%>"/>
            </field>
		<%}%>
<%-- TODO		<%if (hasStereotype("required")){%>
            <field property="<%name%>" depends="required">
                <arg0 key="<%name%>.display"/>
            </field>
		<%}%>--%>
	<%}%>
<%}%>        
