<%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Stephane Lacrampe
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.struts.common.common
%>

<%-- 
This template generate Struts configuration file
--%>

<%script type="Model" name="generate" file="web.xml"%>
<?xml version="1.0" encoding="ISO-8859-1"?>
<!-- Generated with Acceleo (http://www.obeo.fr)-->

<!-- <%startUserCode%> for top part -->
<web-app id="WebLog" version="2.4" xmlns="http://java.sun.com/xml/ns/j2ee" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://java.sun.com/xml/ns/j2ee http://java.sun.com/xml/ns/j2ee/web-app_2_4.xsd">
	<display-name>exemple.ui.struts1_2.jdk5</display-name>
	<!-- Standard Action Servlet Configuration (with debugging) -->
	<servlet>

		<servlet-name>action</servlet-name>
		<servlet-class>org.apache.struts.action.ActionServlet</servlet-class>
	<!-- <%endUserCode%> for top part -->
		<init-param>
			<param-name>config</param-name>
			<param-value>/WEB-INF/conf/struts-config/struts-config.xml,<%for (eAllContents("Package")[cinematicPackage].sep(",")) {%>/WEB-INF/conf/struts-config/struts-config-<%name%>.xml<%}%></param-value>
		</init-param>
    <!-- <%startUserCode%> for bottom part -->
		<init-param>
			<param-name>debug</param-name>
			<param-value>6</param-value>
		</init-param>
		<init-param>
			<param-name>detail</param-name>
			<param-value>4</param-value>
		</init-param>
		<load-on-startup>2</load-on-startup>
	</servlet>

	<!-- Standard Action Servlet Mapping -->
	<servlet-mapping>
		<servlet-name>action</servlet-name>
		<url-pattern>*.do</url-pattern>
	</servlet-mapping>
	
	<welcome-file-list>
		<welcome-file>index.html</welcome-file>
		<welcome-file>index.htm</welcome-file>
		<welcome-file>index.jsp</welcome-file>
		<welcome-file>default.html</welcome-file>
		<welcome-file>default.htm</welcome-file>
		<welcome-file>default.jsp</welcome-file>
	</welcome-file-list>

</web-app>
<!-- <%endUserCode%> for bottom part -->
<%script type="Package" name="cinematicPackage"%>
<%eContents().filter("Class")[hasStereotype(getProperty("Screen"))].nSize() > 0%>