package org.acceleo.sample.demo.spring.daos.impl;



import java.io.Serializable;
import java.util.Collection;

import org.sharengo.exceptions.TechnicalException;
import org.sharengo.orm.hibernate.AbstractHibernateDAO;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.acceleo.sample.demo.spring.entities.Product;

import java.util.Set;

import org.acceleo.sample.demo.spring.daos.IProductsDao;



// Start of user code for import
import java.util.HashSet;
import java.util.List;

// End of user code for import

public class ProductsDaoImpl extends AbstractHibernateDAO<Product> implements IProductsDao {

	/**
	 * class dedicated logger
 	 */
	private static Log log = LogFactory.getLog(ProductsDaoImpl.class.getName()); 
 	
 	
 	
	// Custom operations
		/**
	 * 
	 * @param color 
	 * @return 
	 */
	public Set<Product> findProductsByColor(String color) throws TechnicalException{
		// Start of user code of Set<Product> findProductsByColor(String color)
		HashSet<Product> products = new HashSet<Product>();
		List l = getHibernateTemplate().find("from Product where color=?",
				color);
		if (l != null && l.size() > 0) {
			products.addAll(l);
		}

		return products;

		// End of user code
	}
	
 	// Associations	
	
}