package org.acceleo.sample.demo.spring;

import org.acceleo.sample.demo.spring.services.IProductsServices;	
import org.acceleo.sample.demo.spring.services.IProductsServicesWebService;	

// Start of user code for import 

// End of user code for import 

public abstract class AbstractBusinessLayerTests extends org.sharengo.tests.AbstractBusinessLayerTests {
	
	protected String[] getDefaultConfigLocations() {
		return new String[] {"classpath:META-INF/spring/component-test.xml"};
	}

	protected String[] getConfigLocations() {
		// Start of user code of getConfigLocations
		return getDefaultConfigLocations();
		// End of user code of getConfigLocations
	}

	@Override
	protected void onSetUp() throws Exception {
		// Start of user code of onSetUp
		super.onSetUp();
		// End of user code of onSetUp
	}

	@Override
	protected void onTearDown() throws Exception {
		// Start of user code of onTearDown
		super.onTearDown();
		// End of user code of onTearDown
	}

	protected IProductsServices getProductsServices() throws Exception {
		IProductsServices productsServices = (IProductsServices) getApplicationContext()
				.getBean("productsServices");
		assertNotNull(productsServices);
		return productsServices;
	}
	protected IProductsServicesWebService getProductsServicesWebService()
			throws Exception {
		IProductsServicesWebService productsServicesWebService = (IProductsServicesWebService) org.acceleo.sample.demo.spring.ws.WSClientFactory
				.getInstance().createProductsServicesWebService(
						"http://localhost:8191/IProductsServicesWebService");
		assertNotNull(productsServicesWebService);
		return productsServicesWebService;
	}
	
	// Start of user code of specific tests code
	// End of user code of specific tests code
}