<%--
  Copyright  2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Yann Mortier
  Contributors :
  	- Pierre Alain Bourdil :  * Management of the inheritance.
  							  * Management of enumerations 
--%>

<%--
 - Generates script to create database.
 --%>

<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.EObjects
import org.acceleo.module.pim.uml21.services.SqlTypeServices
import org.acceleo.module.pim.uml21.services.Strings
import org.acceleo.module.pim.uml21.services.Operations
import org.acceleo.module.pim.uml21.gen.php.common.phpdoc
%>

<%--
 - Main script.
 --%>
<%script type="uml.Model" name="fullFilePath"%>
<%name%>/createTable.sql


<%script type="uml.Model" name="createTableScriptSql" file="<%fullFilePath%>"%>

<%--
 - Enumerations
 --%>

<%for (eAllContents("Enumeration")){%>
	<%current.push()%>
	create table <%name.toSqlNotation()%>_ENUMERATION (
	ID INTEGER AUTO_INCREMENT PRIMARY KEY ,
	VALUE VARCHAR(200)
	);
	<%for ownedLiteral{%>
	INSERT INTO `<%peek().name.toSqlNotation()%>` ( `ID` , `VALUE` ) VALUES ( NULL , '<%name.toU1Case()%>');
	<%}%>
	<%pop()%>
<%}%>


<%--
 - Tables
 --%>

<%for (eAllContents("Class")) {%><%if hasStereotype("Entity") {%>
create table <%name.toSqlNotation()%> (
	ID INTEGER PRIMARY KEY 
<%for (attribute[association == null && type.eClass().name != "Enumeration" && type.filter("PrimitiveType")!=null ]) {%>	,
	<%name.toSqlNotation()%> <%type.getSqlType()%>
<%}%>
<%for (attribute[association == null && type.eClass().name == "Enumeration"]) {%>	,
	<%name.toSqlNotation()%> INTEGER
<%}%>
<%for (getTableRelations().filter("Property")) {%>	,
	ID_<%name.toSqlNotation()%>_FROM_<%inverse().filter("Property").type.name.toSqlNotation()%>	INTEGER
<%}%>
	,
	VERSION INTEGER
<%for (getTableRelations().filter("Property")) {%>	,
	FOREIGN KEY (ID_<%name.toSqlNotation()%>_FROM_<%inverse().filter("Property").type.name.toSqlNotation()%>) REFERENCES <%inverse().type.name.toSqlNotation()%>(ID) <%if (aggregation == "Composite") {%>ON DELETE CASCADE<%}%>
<%}%>
<%if (superClass.nSize() > 0) {%>	,
	FOREIGN KEY (ID) REFERENCES <%general.name.toSqlNotation()%>(ID)
<%}%>
);


<%}%><%}%>

<%--
 - Association tables.
 --%>

<%for (getAssociationsTables().filter("Association")) {%>
create table <%memberEnd.nGet(0).name.toSqlNotation()%>_<%memberEnd.nGet(1).name.toSqlNotation()%> (
	ID INTEGER PRIMARY KEY , 
	ID_<%memberEnd.nGet(0).type.name.toSqlNotation()%> INTEGER,
	ID_<%memberEnd.nGet(1).type.name.toSqlNotation()%> INTEGER
);

<%}%>