<%--
  Copyright  2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Pierre Alain Bourdil
--%>

<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.EObjects
import org.acceleo.module.pim.uml21.services.Operations
import org.acceleo.module.pim.uml21.services.Strings
import org.acceleo.module.pim.uml21.services.SqlTypeServices
import org.acceleo.module.pim.uml21.gen.php.common.phpdoc
import org.acceleo.module.pim.uml21.gen.php.common.lib
%>
<%script type="uml.Enumeration" name="fullFilePath"%>
<%getRootContainer().name%>/dao/enumeration/<%name%>EnumerationDao.php5


<%script type="uml.Enumeration" name="generate" file="<%fullFilePath%>"%>
<?php
/**
* @package enumeration
* @subpackage <%package.name%>
*/
/**
* root class
*/
require_once(dirname(__FILE__)."/../Dao.php5");
/**
* Connections utils
*/
require_once(dirname(__FILE__)."/../Connection.php5");
/**
* @package enumeration
* @subpackage <%package.name%>
* @version $Id$
*/
class <%name%>EnumerationDao extends Dao{

	public function __construct(){
		$this->tableName = "<%name.toSqlNotation()%>_ENUMERATION";
	}
	
	public function create<%name.toU1Case()%>EnumerationLiteralDao($connection, $literal){
		$this->logger->log('enumeration Literal To Be Created [<%name%>:$literal]', PEAR_LOG_DEBUG);
		$qry = 	"INSERT INTO " . $this->getTableName() . " SET VALUE = '". $literal . "'";
		$this->executeQuery($connection, $qry);	
	}
	public function update<%name.toU1Case()%>EnumerationLiteralDao($connection, $literal, $new ){
		$this->logger->log('enumeration Literal To Be Updated [<%name%>:$literal] with [<%name%>:$new]', PEAR_LOG_DEBUG);
		$qry = 	"UPDATE " . $this->getTableName() . " SET VALUE = '". $new . "'"." WHERE VALUE='".$literal."'";
		$this->executeQuery($connection, $qry);	
	}
	public function delete<%name.toU1Case()%>EnumerationLiteralDao($connection, $literal){
		$this->logger->log('enumeration Literal To Be deleted [<%name%>:$literal]', PEAR_LOG_DEBUG);
		$qry = 	"DELETE FROM " . $this->getTableName() . " WHERE VALUE='".$literal."'";
		$this->executeQuery($connection, $qry);	
	}
	
	public function findByValue($connection,$literal){
		$qry= "SELECT VALUE FROM ".$this->getTableName()." WHERE VALUE='".$literal."'";
		
		$res= $this->executeQuery($connection, $qry);
		if ($res->numRows() == 1) {
			$row = array();
			$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		}
		return $row["ID"];
	} 
	public function findById($connection,$id){
		$qry= "SELECT VALUE FROM ".$this->getTableName()." WHERE ID ='".$id."'";
		
		$res= $this->executeQuery($connection, $qry);
		if ($res->numRows() == 1) {
			$row = array();
			$res->fetchInto($row, DB_FETCHMODE_ASSOC);
		}
		return $row["VALUE"];
	}
	
	protected function updateRelations($connection, $child, $memory = array()){
	
	}
}
?>

