<%--
  Copyright  2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Pierre Alain Bourdil
--%>

<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
%>

<%script type="uml.Model" name="filePath" post="trim()"%>
<%name%>/entity/Entity.php5

<%script type="uml.Model" name="abstract_entity" file="<%filePath%>"%>
<?php
/**
*
*/
require_once(dirname(__FILE__)."/IEntity.php5");
/**
* PEAR log.
*/
require_once("Log.php");
	
/**
* PEAR DB
*/
require_once("DB.php");
/**
* root class, manages ID ,debug and define string serialization signature
* @package entity
* @version $Id$
*/
abstract class Entity implements IEntity {

	private $id;
	
	protected $logger;
	
	public function __construct($id = -1) {
		$this->id = $id;
	}
	
	public function getId() {
		return $this->id;
	}
	
	public function setId($id) {
		$this->id = $id;
	}
	
	public abstract function getSimpleString();
	
	/**
	 * Return the factory that has created this object.
	 */
	public abstract function getFactory();
	
	public function debug($message) {
		$this->logger->log("{" . $this->getSimpleString() . "} " . $message, PEAR_LOG_DEBUG);
	}


}


?>