<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.EObjects
import org.acceleo.module.pim.uml21.gen.php.common.lib
%>

<%script type="uml.Class" name="filePath" post="trim()"%>
<%if (hasStereotype("Entity")) {%>
<%getRootContainer().name%>/entity/<%package.name%>/<%name%>Factory.php5
<%}%>

<%script type="uml.Class" name="entity-factory" file="<%filePath%>"%>
<?php
/**
* @package <%package.name%>
*/
/**
* Prowy Class
*/
require_once(dirname(__FILE__)."/proxy/<%name%>Proxy.php5");
require_once(dirname(__FILE__)."/../../dao/<%package.name%>/<%name%>Dao.php5");
/**
 *	Class <%name%>    
 *  <%ownedComment.body%> 
 * @author
 * @version $Id$
 * @package <%package.name%>
 * 
 */
class <%name%>Factory {

	public static function create<%name.toU1Case()%> ($id = -1<%ancestorConstructorParameters%>) {
		return new <%name%>Proxy($id<%ancestorConstructorCall%>);
	}
	
	public static function create($id = -1) {
		return new <%name%>Proxy($id);
	}
	
	public static function getAll<%name.toU1Case()%>s(){
		$connection = new Connection();
		$connection->open(true);
		$<%name.toL1Case()%>Dao = new <%name.toU1Case()%>Dao();
		return $<%name.toL1Case()%>Dao->findAll<%name.toU1Case()%>s($connection);
	}

	public static function get<%name.toU1Case()%>($id){
		$connection = new Connection();
		$connection->open(true);
		$<%name.toL1Case()%>Dao = new <%name.toU1Case()%>Dao();
		$<%name.toL1Case()%>= new <%name.toU1Case()%>Proxy($id);
		return $<%name.toL1Case()%>Dao->findById($connection,$<%name.toL1Case()%>);
	}
	
}

?>