<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.EObjects
import org.acceleo.module.pim.uml21.gen.php.common.phpdoc
import org.acceleo.module.pim.uml21.gen.php.common.lib
import org.acceleo.module.pim.uml21.services.Strings

%>

<%script type="uml.Class" name="filePath" post="trim()"%>
<%if (hasStereotype("Entity")) {%>
<%getRootContainer().name%>/entity/<%package.name%>/proxy/<%name%>Proxy.php5
<%}%>

<%script type="uml.Class" name="entity-proxy" file="<%filePath%>"%>
<?php
/**
*
* @package <%package.name%>
*/
/**
* proxied class
*/
require_once(dirname(__FILE__)."/../<%name%>.php5");
/**
* dao class
*/
require_once(dirname(__FILE__)."/../../../dao/<%package.name%>/<%name%>Dao.php5");
/**
 * The relation manager interface
 */
require_once(dirname(__FILE__)."/../../RelationManager.php5");
<%classDocBlocPhpdoc%>

class <%name%>Proxy extends <%name%> implements RelationManager {

	private $relationLoaded;

	public function __construct($id = -1<%ancestorConstructorParameters%>) {
		parent::__construct($id<%ancestorConstructorCall%>);
		$this->relationLoaded = array();
	}
	
		
	public function isRelationLoaded($relationName) {
		return in_array($relationName, $this->relationLoaded);
	}
	
	public function loadRelation($relationName) {
		switch ($relationName) {
<%for ((getProperties() + getAncestor.getProperties()).filter("Property")[!isStatic && type.hasStereotype("Entity")]) {%>
			case "<%name%>":
				$this->load<%name.toU1Case()%>Relation();
				break;
<%}%>
		}
	}
	
	public function unloadRelation($relationName) {
	switch ($relationName) {
<%for ((getProperties() + getAncestor.getProperties()).filter("Property")[!isStatic && type.hasStereotype("Entity")]) {%>
			case "<%name%>":
				$this->unload<%name.toU1Case()%>Relation();
				break;
<%}%>
		}
	}

	<%for ((getProperties() + getAncestor.getProperties()).filter("Property")[!isStatic && type.hasStereotype("Entity")]) {%>
	
	public function set<%name.toU1Case()%>($<%name.toL1Case()%>) {
		parent::set<%name.toU1Case()%>($<%name.toL1Case()%>);
		if (!$this->isRelationLoaded("<%name%>")) {
			array_push($this->relationLoaded, "<%name%>");
		}
	}
	
	/**
	 * Return <%name%> value.
	 * Type : <%type.name%>
	 *
	 * @return <%ownedComment.body%>
	 */
	public function get<%name.toU1Case()%>($lazyloading = true) {
		$<%name%> = parent::get<%name.toU1Case()%>();
		if (!isset($<%name%>) && $lazyloading) {
			$this->load<%name.toU1Case()%>Relation();
		}
		return  parent::get<%name.toU1Case()%>();
	}
	
	<%if (upper != 1){%>
	<%-- Ajout dans la collection --%>
	/**
	 * Add a <%type.name%> inside <%name%>.
	 *
	 */
	public function add<%name.toU1Case()%>($<%type.name.toL1Case()%>) {
		$<%name%> = parent::get<%name.toU1Case()%>();
		if (!isset($<%name%>)) {
			$this->load<%name.toU1Case()%>Relation();
		}
		parent::add<%name.toU1Case()%>($<%type.name.toL1Case()%>);
	}
	
	<%-- Compte le nombre d'�l�ments dans la collection. --%>
	/**
	 * Return the number of <%type.name%> in <%name%>.
	 *
	 */
	public function getSizeOf<%name.toU1Case()%>() {
		$<%name%> = parent::get<%name.toU1Case()%>();
		if (!isset($<%name%>)) {
			$this->load<%name.toU1Case()%>Relation();
		}
		return parent::getSizeOf<%name.toU1Case()%>();
	}
	
	<%-- Return an element. i() --%>
	/**
	 * Return an element <%type.name%> of <%name%>
	 */
	public function get<%name.toU1Case()%>At($i) {
		$<%name%> = parent::get<%name.toU1Case()%>();
		if (!isset($<%name%>)) {
			$this->load<%name.toU1Case()%>Relation();
		}
		return parent::get<%name.toU1Case()%>At($i);
	}
	<%}%>
	
	private function load<%name.toU1Case()%>Relation() {
		$connection = new Connection();
		$connection->open(true);
		$<%inverse().type.name.toL1Case()%>Dao = new <%inverse().type.name%>Dao();
		$<%name.toLowerCase()%> = $<%inverse().type.name.toL1Case()%>Dao-><%if upper==1 {%>load<%name.toU1Case()%><%}else{%>load<%name.toU1Case().toPluriel()%><%}%>($connection, $this);
		$connection->close();
		$this->set<%name.toU1Case()%>($<%name.toLowerCase()%>);
		if (!$this->isRelationLoaded("<%name%>")) {
			array_push($this->relationLoaded, "<%name%>");
		}
		// $this->debug('lazy loading : ' . $this->get<%name.toU1Case()%>());
	}
	
	private function unload<%name.toU1Case()%>Relation() {
		$this->set<%name.toU1Case()%>(null);
		$index = array_search("<%name%>", $this->loadedRelation, true);
		if ($index != null) {
			array_splice($this->loadedRelation, $index, 1);	
		}
	}
	
	
<%}%>
	



}


?>