<%--
  Copyright  2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Pierre Alain Bourdil
--%>


<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.EObjects
import org.acceleo.module.pim.uml21.services.Strings
import org.acceleo.module.pim.uml21.services.Operations
import org.acceleo.module.pim.uml21.gen.php.common.phpdoc
import org.acceleo.module.pim.uml21.gen.php.common.lib
import org.acceleo.module.pim.uml21.gen.php.common.static
import org.acceleo.module.pim.uml21.gen.php.entity.entity-base
%>
<%script type="Class" name="fullFilePath"%>
<%if (hasStereotype("Entity")){%>
<%getRootContainer().name%>/test/<%package.name%>/<%name%>Test.php5
<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
<?php
/**
* @package test
* @subpackage test.<%name%>
* @version $Id$
*/
/**
* utilise PHPUnit
*/
require_once 'PHPUnit/Framework.php';
require_once 'PHPUnit/Framework/TestCase.php';
/**
* include test class {@see <%name%> <%name%>}
*/
require_once(dirname(__FILE__)."/../../entity/<%package.name%>/<%name.toU1Case()%>.php5");
/**
* Classe de test unitaire de la classe {@link <%name%> <%name%>}
* @package test
* @subpackage test.<%name%>
* @version $Id$
*/
class <%name%>Test extends PHPUnit_Framework_TestCase
{

	var $_fixture;

	function setUp(){ 
        //fill those array with instanciation parameters
		$this->_fixture["__constructParams"][0]=array();
<%for getProperties().filter("Property")[type.filter("PrimitiveType").nSize()==0] {%>		
		$this->_fixture["<%name%>__p"][0]=array();
<%}%>

		$i=0;
<%for getProperties().filter("Property") + getAncestor().getProperties().filter("Property"){%>
	<%if type.filter("PrimitiveType").nSize() != 0 {%>
		$this->_fixture[0]["<%name.toL1Case()%>"]=<%if type.name.equalsIgnoreCase("string") {%><%name.toLowerCase()%><%}else{%>$i<%}%>;
		$i++;
	<%}else{%>
		$this->_fixture[0]["<%name.toL1Case()%>"]=new <%type.name%>();
	<%}%>
<%}%>
<%for getProperties().filter("Property")[type.filter("PrimitiveType").nSize()==0] {%>

	<%if type.filter("Enumeration") != null {%>
			<%instanciateClass(name+"EnumerationDao","$this->_fixture[\""+name+"__p\"][0]",null,type.name+"EnumerationDao")%>
	<%}else{%>
			<%instanciateClass(name,"$this->_fixture[\""+name+"__p\"][0]",null,type.name)%>
	<%}%>
        	$this->_fixture["<%name%>"][0]=$<%name.toL1Case()%>;
<%}%>
         //<%startUserCode%> setUp<%name%>
	 	 //<%endUserCode%> setUp<%name%>
       
         }
	public function test__construct(){
    	$j=0;
		foreach($this->_fixture["__constructParams"] as $params){
			if(count($params)>0){
        		<%instanciateClass(name,"$params","$j", name)%>
       			$j++;
       		}
		}
         	//<%startUserCode%> test__construct
         	//<%endUserCode%> test__construct
     }
 <%--<%for getProperties().filter("Property") - attribute {%>--%>
 <%--	<%test_entity_base_getter_setter(type.name)%>--%>
 <%--<%}%> --%>
 <%for getProperties().filter("Property") + getAncestor().getProperties().filter("Property"){%>
 	<%test_entity_base_getter_setter%>
 <%}%>
 
 <%for (ownedOperation){%>
 		public function test<%name.toU1Case()%>(){
 			//<%startUserCode%> test<%name.toU1Case()%>
	 		//<%endUserCode%> setUp<%name.toU1Case()%>
 		}
 <%}%>
 		public function  test__toString(){
 			//<%startUserCode%> test__toString
	 		//<%endUserCode%> test__toString
 		}
 		
 		public function testGetSimpleString(){
 			//<%startUserCode%> testGetSimpleString
	 		//<%endUserCode%> testGetSimpleString
 		}
 
 }
 
 


