<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.Strings
import org.acceleo.module.pim.uml21.services.EObjects
%>

<%-- 
This template deals with PhpMVC actions
--%>

<%script type="Class" name="fullFilePath"%>
<%-- Only Classes with stereotype Screen--%>
<%if (hasStereotype("Screen")){%>
/<%eContainer().name%>/actions/<%name%>Action.java
<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
<%-- Generate PhpMVC actions--%>
<?php

class <%name%>Action extends Action {

	private $log;

	 // ----- Constructor ---------------------------------------------------- //
	function <%name%>Action() {	
		parent::Action();		
		$this->log = new PhpMVC_Log();
	}

	<%-- Struts return Code--%>
	var $PAGE_SELF = "self";
<%-- class association navigation --%>
<%for (attribute){%>
	var $PAGE_<%type.name.toUpperCase()%> = "<%type.name.toL1Case()%>";
<%}%>

<%-- init action method generation (Dispach)--%>
	function init($mapping, $form, &$request, &$response) {
		$this->log->trace("Starting <%name%>Action");
		
		$returnCode = $this->PAGE_SELF;

		// <%startUserCode%> method init
		// TODO Write here the action code for init
		// <%endUserCode%>
	
		return $mapping->findForward($returnCode);
	} 

<%-- actions methods generation (Dispach)--%>
<%for (ownedOperation){%>
	function <%name%>($mapping, $form, &$request, &$response) {
		$this->log->trace("Starting <%eContainer().name%>Action.<%name%>");
		
		$returnCode = $this->PAGE_SELF;
		
		// <%startUserCode%> method <%name%>
		// TODO Write here the action code for <%name%>
		// <%endUserCode%>
		
		return $mapping->findForward($returnCode);
	}
<%}%>

//<%startUserCode%> user methods
//<%endUserCode%>

}
?>
