<?php
require_once('lib/Wisss/Dto/Abstract.php') ;
/**
 * compare the two variables and returns true if they are the same following
 * the business logic which means :
 * - primitive variables are compared with ===
 * - primitive object variables are compared with ==
 * - Dto are compared with their __sameAs() method
 * @returns boolean
 */
function sameAs($var1, $var2)
{
	if($var1 === $var2) {
		return true ;
	} else {
		if(gettype($var1) == gettype($var2) && gettype($var1) == 'object') {
			if(is_subclass_of($var1,'Wisss_Dto_Abstract') && is_subclass_of($var2,'Wisss_Dto_Abstract')) {
				if($var1->__sameAs($var2)) {
					return true ;
				}
			} else {
				if($var1 == $var2) {
					return true ;
				}
			}
		}
	}
	return false ;
}