<?php
/**
 * testmodule_Dto_Asso1111N1
 * @package data.Module (name: test module)
 */
class testmodule_Dto_Asso1111N1 extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = 'Asso1111N1';
    const MODULE_NAME = 'testmodule';
    
    /**
	 * @var testmodule_Dto_A
	 */
	protected $rolea_in_asso_11_11_n1 ;
    /**
	 * @var testmodule_Dto_B
	 */
	protected $roleb_in_asso_11_11_n1 ;
    /**
	 * @var testmodule_Dto_C
	 */
	protected $rolec_in_asso_11_11_n1 ;
    
	
	/**
 * setRoleaInAsso1111N1
 */
public function setRoleaInAsso1111N1($rolea_in_asso_11_11_n1,$backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_11_11_n1)) {
		$this->rolea_in_asso_11_11_n1->unsetRolebcInAsso1111N1(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_11_11_n1' ;
		$changes['old_value'] = $this->rolea_in_asso_11_11_n1 ;
		$changes['operation'] = 'set' ;
	}
	$this->rolea_in_asso_11_11_n1 = $rolea_in_asso_11_11_n1 ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_11_11_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->rolea_in_asso_11_11_n1->setRolebcInAsso1111N1($this,false) ;
	}
}

	
	/**
	 * getRoleaInAsso1111N1
	 */
	public function getRoleaInAsso1111N1()
	{
		return $this->rolea_in_asso_11_11_n1 ;
	}
	/**
 * setRolebInAsso1111N1
 */
public function setRolebInAsso1111N1($roleb_in_asso_11_11_n1,$backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_11_11_n1)) {
		$this->roleb_in_asso_11_11_n1->unsetRoleacInAsso1111N1(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_11_11_n1' ;
		$changes['old_value'] = $this->roleb_in_asso_11_11_n1 ;
		$changes['operation'] = 'set' ;
	}
	$this->roleb_in_asso_11_11_n1 = $roleb_in_asso_11_11_n1 ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_11_11_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->roleb_in_asso_11_11_n1->setRoleacInAsso1111N1($this,false) ;
	}
}

	
	/**
	 * getRolebInAsso1111N1
	 */
	public function getRolebInAsso1111N1()
	{
		return $this->roleb_in_asso_11_11_n1 ;
	}
	/**
 * setListOfRolecInAsso1111N1
 */
public function setListOfRolecInAsso1111N1($rolec_in_asso_11_11_n1, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_11_11_n1)) {
		foreach($this->rolec_in_asso_11_11_n1 as $item) {
			$item->unsetRoleabInAsso1111N1(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_11_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_11_11_n1 ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolec_in_asso_11_11_n1 = $rolec_in_asso_11_11_n1 ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_11_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolec_in_asso_11_11_n1 as $item) {
			$item->setRoleabInAsso1111N1($this,false) ;
		}
	}
}

/**
 * addRolecInAsso1111N1
 */
public function addRolecInAsso1111N1($rolec_in_asso_11_11_n1, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_11_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_11_11_n1 ;
		$changes['operation'] = 'add' ;
	}
	$this->rolec_in_asso_11_11_n1[] = $rolec_in_asso_11_11_n1 ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_11_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolec_in_asso_11_11_n1->setRoleabInAsso1111N1($this,false) ;
	}
}

/**
 * removeRolecInAsso1111N1
 */
public function removeRolecInAsso1111N1($rolec_in_asso_11_11_n1, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_11_11_n1)) {
		$rolec_in_asso_11_11_n1->unsetRoleabInAsso1111N1(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_11_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_11_11_n1 ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolec_in_asso_11_11_n1 as $key=>$item) {
		if($item->__sameAs($rolec_in_asso_11_11_n1)) {
			unset($this->rolec_in_asso_11_11_n1[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_11_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolecInAsso1111N1
 */
public function unsetRolecInAsso1111N1($backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_11_11_n1)) {
		foreach($this->rolec_in_asso_11_11_n1 as $item) {
			$item->unsetRoleabInAsso1111N1(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_11_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_11_11_n1 ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolec_in_asso_11_11_n1 = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_11_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolecInAsso1111N1
	 */
	public function getRolecInAsso1111N1()
	{
		return $this->rolec_in_asso_11_11_n1 ;
	}
	
}