<?php
/**
 * testmodule_Dto_Asso111nN1
 * @package data.Module (name: test module)
 */
class testmodule_Dto_Asso111nN1 extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = 'Asso111nN1';
    const MODULE_NAME = 'testmodule';
    
    /**
	 * @var testmodule_Dto_A
	 */
	protected $rolea_in_asso_11_1n_n1 ;
    /**
	 * @var testmodule_Dto_B
	 */
	protected $roleb_in_asso_11_1n_n1 ;
    /**
	 * @var testmodule_Dto_C
	 */
	protected $rolec_in_asso_11_1n_n1 ;
    
	
	/**
 * setRoleaInAsso111nN1
 */
public function setRoleaInAsso111nN1($rolea_in_asso_11_1n_n1,$backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_11_1n_n1)) {
		$this->rolea_in_asso_11_1n_n1->unsetRolebcInAsso111nN1(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_11_1n_n1' ;
		$changes['old_value'] = $this->rolea_in_asso_11_1n_n1 ;
		$changes['operation'] = 'set' ;
	}
	$this->rolea_in_asso_11_1n_n1 = $rolea_in_asso_11_1n_n1 ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_11_1n_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->rolea_in_asso_11_1n_n1->setRolebcInAsso111nN1($this,false) ;
	}
}

	
	/**
	 * getRoleaInAsso111nN1
	 */
	public function getRoleaInAsso111nN1()
	{
		return $this->rolea_in_asso_11_1n_n1 ;
	}
	/**
 * setRolebInAsso111nN1
 */
public function setRolebInAsso111nN1($roleb_in_asso_11_1n_n1,$backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_11_1n_n1)) {
		$this->roleb_in_asso_11_1n_n1->removeRoleacInAsso111nN1($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_11_1n_n1' ;
		$changes['old_value'] = $this->roleb_in_asso_11_1n_n1 ;
		$changes['operation'] = 'set' ;
	}
	$this->roleb_in_asso_11_1n_n1 = $roleb_in_asso_11_1n_n1 ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_11_1n_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->roleb_in_asso_11_1n_n1->addRoleacInAsso111nN1($this,false) ;
	}
}

	
	/**
	 * getRolebInAsso111nN1
	 */
	public function getRolebInAsso111nN1()
	{
		return $this->roleb_in_asso_11_1n_n1 ;
	}
	/**
 * setListOfRolecInAsso111nN1
 */
public function setListOfRolecInAsso111nN1($rolec_in_asso_11_1n_n1, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_11_1n_n1)) {
		foreach($this->rolec_in_asso_11_1n_n1 as $item) {
			$item->unsetRoleabInAsso111nN1(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_1n_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_11_1n_n1 ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolec_in_asso_11_1n_n1 = $rolec_in_asso_11_1n_n1 ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_1n_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolec_in_asso_11_1n_n1 as $item) {
			$item->setRoleabInAsso111nN1($this,false) ;
		}
	}
}

/**
 * addRolecInAsso111nN1
 */
public function addRolecInAsso111nN1($rolec_in_asso_11_1n_n1, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_1n_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_11_1n_n1 ;
		$changes['operation'] = 'add' ;
	}
	$this->rolec_in_asso_11_1n_n1[] = $rolec_in_asso_11_1n_n1 ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_1n_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolec_in_asso_11_1n_n1->setRoleabInAsso111nN1($this,false) ;
	}
}

/**
 * removeRolecInAsso111nN1
 */
public function removeRolecInAsso111nN1($rolec_in_asso_11_1n_n1, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_11_1n_n1)) {
		$rolec_in_asso_11_1n_n1->unsetRoleabInAsso111nN1(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_1n_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_11_1n_n1 ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolec_in_asso_11_1n_n1 as $key=>$item) {
		if($item->__sameAs($rolec_in_asso_11_1n_n1)) {
			unset($this->rolec_in_asso_11_1n_n1[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_1n_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolecInAsso111nN1
 */
public function unsetRolecInAsso111nN1($backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_11_1n_n1)) {
		foreach($this->rolec_in_asso_11_1n_n1 as $item) {
			$item->unsetRoleabInAsso111nN1(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_1n_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_11_1n_n1 ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolec_in_asso_11_1n_n1 = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_1n_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolecInAsso111nN1
	 */
	public function getRolecInAsso111nN1()
	{
		return $this->rolec_in_asso_11_1n_n1 ;
	}
	
}