<?php
/**
 * testmodule_Dto_Asso11N1Nn
 * @package data.Module (name: test module)
 */
class testmodule_Dto_Asso11N1Nn extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = 'Asso11N1Nn';
    const MODULE_NAME = 'testmodule';
    
    /**
	 * @var testmodule_Dto_A
	 */
	protected $rolea_in_asso_11_n1_nn ;
    /**
	 * @var testmodule_Dto_B
	 */
	protected $roleb_in_asso_11_n1_nn ;
    /**
	 * @var testmodule_Dto_C
	 */
	protected $rolec_in_asso_11_n1_nn ;
    
	
	/**
 * setRoleaInAsso11N1Nn
 */
public function setRoleaInAsso11N1Nn($rolea_in_asso_11_n1_nn,$backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_11_n1_nn)) {
		$this->rolea_in_asso_11_n1_nn->unsetRolebcInAsso11N1Nn(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_11_n1_nn' ;
		$changes['old_value'] = $this->rolea_in_asso_11_n1_nn ;
		$changes['operation'] = 'set' ;
	}
	$this->rolea_in_asso_11_n1_nn = $rolea_in_asso_11_n1_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_11_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->rolea_in_asso_11_n1_nn->setRolebcInAsso11N1Nn($this,false) ;
	}
}

	
	/**
	 * getRoleaInAsso11N1Nn
	 */
	public function getRoleaInAsso11N1Nn()
	{
		return $this->rolea_in_asso_11_n1_nn ;
	}
	/**
 * setListOfRolebInAsso11N1Nn
 */
public function setListOfRolebInAsso11N1Nn($roleb_in_asso_11_n1_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_11_n1_nn)) {
		foreach($this->roleb_in_asso_11_n1_nn as $item) {
			$item->unsetRoleacInAsso11N1Nn(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_11_n1_nn' ;
		$changes['old_value'] = $this->roleb_in_asso_11_n1_nn ;
		$changes['operation'] = 'setlist' ;
	}
	$this->roleb_in_asso_11_n1_nn = $roleb_in_asso_11_n1_nn ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_11_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->roleb_in_asso_11_n1_nn as $item) {
			$item->setRoleacInAsso11N1Nn($this,false) ;
		}
	}
}

/**
 * addRolebInAsso11N1Nn
 */
public function addRolebInAsso11N1Nn($roleb_in_asso_11_n1_nn, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_11_n1_nn' ;
		$changes['old_value'] = $this->roleb_in_asso_11_n1_nn ;
		$changes['operation'] = 'add' ;
	}
	$this->roleb_in_asso_11_n1_nn[] = $roleb_in_asso_11_n1_nn ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_11_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$roleb_in_asso_11_n1_nn->setRoleacInAsso11N1Nn($this,false) ;
	}
}

/**
 * removeRolebInAsso11N1Nn
 */
public function removeRolebInAsso11N1Nn($roleb_in_asso_11_n1_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_11_n1_nn)) {
		$roleb_in_asso_11_n1_nn->unsetRoleacInAsso11N1Nn(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_11_n1_nn' ;
		$changes['old_value'] = $this->roleb_in_asso_11_n1_nn ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->roleb_in_asso_11_n1_nn as $key=>$item) {
		if($item->__sameAs($roleb_in_asso_11_n1_nn)) {
			unset($this->roleb_in_asso_11_n1_nn[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_11_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolebInAsso11N1Nn
 */
public function unsetRolebInAsso11N1Nn($backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_11_n1_nn)) {
		foreach($this->roleb_in_asso_11_n1_nn as $item) {
			$item->unsetRoleacInAsso11N1Nn(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_11_n1_nn' ;
		$changes['old_value'] = $this->roleb_in_asso_11_n1_nn ;
		$changes['operation'] = 'unset' ;
	}
	$this->roleb_in_asso_11_n1_nn = array() ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_11_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolebInAsso11N1Nn
	 */
	public function getRolebInAsso11N1Nn()
	{
		return $this->roleb_in_asso_11_n1_nn ;
	}
	/**
 * setListOfRolecInAsso11N1Nn
 */
public function setListOfRolecInAsso11N1Nn($rolec_in_asso_11_n1_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_11_n1_nn)) {
		foreach($this->rolec_in_asso_11_n1_nn as $item) {
			$item->removeRoleabInAsso11N1Nn($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_n1_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_11_n1_nn ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolec_in_asso_11_n1_nn = $rolec_in_asso_11_n1_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolec_in_asso_11_n1_nn as $item) {
			$item->addRoleabInAsso11N1Nn($this,false) ;
		}
	}
}

/**
 * addRolecInAsso11N1Nn
 */
public function addRolecInAsso11N1Nn($rolec_in_asso_11_n1_nn, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_n1_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_11_n1_nn ;
		$changes['operation'] = 'add' ;
	}
	$this->rolec_in_asso_11_n1_nn[] = $rolec_in_asso_11_n1_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolec_in_asso_11_n1_nn->addRoleabInAsso11N1Nn($this,false) ;
	}
}

/**
 * removeRolecInAsso11N1Nn
 */
public function removeRolecInAsso11N1Nn($rolec_in_asso_11_n1_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_11_n1_nn)) {
		$rolec_in_asso_11_n1_nn->removeRoleabInAsso11N1Nn($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_n1_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_11_n1_nn ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolec_in_asso_11_n1_nn as $key=>$item) {
		if($item->__sameAs($rolec_in_asso_11_n1_nn)) {
			unset($this->rolec_in_asso_11_n1_nn[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolecInAsso11N1Nn
 */
public function unsetRolecInAsso11N1Nn($backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_11_n1_nn)) {
		foreach($this->rolec_in_asso_11_n1_nn as $item) {
			$item->removeRoleabInAsso11N1Nn($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_n1_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_11_n1_nn ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolec_in_asso_11_n1_nn = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolecInAsso11N1Nn
	 */
	public function getRolecInAsso11N1Nn()
	{
		return $this->rolec_in_asso_11_n1_nn ;
	}
	
}