<?php
/**
 * testmodule_Dto_Asso1NWithAttributes
 * @package data.Module (name: test module)
 */
class testmodule_Dto_Asso1NWithAttributes extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = 'Asso1NWithAttributes';
    const MODULE_NAME = 'testmodule';
    
    /**
	 * @var testmodule_Dto_A
	 */
	protected $rolea_in_asso_1_n_wa ;
    /**
	 * @var testmodule_Dto_B
	 */
	protected $roleb_in_asso_1_n_wa ;
    
	/**
	 * @var String
	 */
	protected $attr ;
	
	/**
 * setRoleaInAsso1NWa
 */
public function setRoleaInAsso1NWa($rolea_in_asso_1_n_wa, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_1_n_wa' ;
		$changes['old_value'] = $this->rolea_in_asso_1_n_wa ;
		$changes['operation'] = Wisss_Change::OPERATION_SET ;
	}
	$this->rolea_in_asso_1_n_wa = $rolea_in_asso_1_n_wa ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_1_n_wa ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}
	
	/**
	 * getRoleaInAsso1NWa
	 */
	public function getRoleaInAsso1NWa()
	{
		return $this->rolea_in_asso_1_n_wa ;
	}
	/**
 * setRolebInAsso1NWa
 */
public function setRolebInAsso1NWa($roleb_in_asso_1_n_wa, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_1_n_wa' ;
		$changes['old_value'] = $this->roleb_in_asso_1_n_wa ;
		$changes['operation'] = Wisss_Change::OPERATION_SET ;
	}
	$this->roleb_in_asso_1_n_wa = $roleb_in_asso_1_n_wa ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_1_n_wa ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}
	
	/**
	 * getRolebInAsso1NWa
	 */
	public function getRolebInAsso1NWa()
	{
		return $this->roleb_in_asso_1_n_wa ;
	}
	
	/**
 * setAttr
 */
public function setAttr($attr, $notify=true)
{
	if($notify) {
		$changes = new Wisss_Change() ;
		$changes->setAttribute('attr') ;
		$changes->setOld($this->attr) ;
		$changes->setOperation(Wisss_Change::OPERATION_SET) ;
	}
	$this->attr = $attr ;
	if($notify) {
		$changes->setNew($attr) ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getAttr
	 */
	public function getAttr()
	{
		return $this->attr ;
	}

}