<?php
/**
 * testmodule_Dto_Asso1n1nN1
 * @package data.Module (name: test module)
 */
class testmodule_Dto_Asso1n1nN1 extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = 'Asso1n1nN1';
    const MODULE_NAME = 'testmodule';
    
    /**
	 * @var testmodule_Dto_A
	 */
	protected $rolea_in_asso_1n_1n_n1 ;
    /**
	 * @var testmodule_Dto_B
	 */
	protected $roleb_in_asso_1n_1n_n1 ;
    /**
	 * @var testmodule_Dto_C
	 */
	protected $rolec_in_asso_1n_1n_n1 ;
    
	
	/**
 * setRoleaInAsso1n1nN1
 */
public function setRoleaInAsso1n1nN1($rolea_in_asso_1n_1n_n1,$backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_1n_1n_n1)) {
		$this->rolea_in_asso_1n_1n_n1->removeRolebcInAsso1n1nN1($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_1n_1n_n1' ;
		$changes['old_value'] = $this->rolea_in_asso_1n_1n_n1 ;
		$changes['operation'] = 'set' ;
	}
	$this->rolea_in_asso_1n_1n_n1 = $rolea_in_asso_1n_1n_n1 ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_1n_1n_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->rolea_in_asso_1n_1n_n1->addRolebcInAsso1n1nN1($this,false) ;
	}
}

	
	/**
	 * getRoleaInAsso1n1nN1
	 */
	public function getRoleaInAsso1n1nN1()
	{
		return $this->rolea_in_asso_1n_1n_n1 ;
	}
	/**
 * setRolebInAsso1n1nN1
 */
public function setRolebInAsso1n1nN1($roleb_in_asso_1n_1n_n1,$backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_1n_1n_n1)) {
		$this->roleb_in_asso_1n_1n_n1->removeRoleacInAsso1n1nN1($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_1n_1n_n1' ;
		$changes['old_value'] = $this->roleb_in_asso_1n_1n_n1 ;
		$changes['operation'] = 'set' ;
	}
	$this->roleb_in_asso_1n_1n_n1 = $roleb_in_asso_1n_1n_n1 ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_1n_1n_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->roleb_in_asso_1n_1n_n1->addRoleacInAsso1n1nN1($this,false) ;
	}
}

	
	/**
	 * getRolebInAsso1n1nN1
	 */
	public function getRolebInAsso1n1nN1()
	{
		return $this->roleb_in_asso_1n_1n_n1 ;
	}
	/**
 * setListOfRolecInAsso1n1nN1
 */
public function setListOfRolecInAsso1n1nN1($rolec_in_asso_1n_1n_n1, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_1n_1n_n1)) {
		foreach($this->rolec_in_asso_1n_1n_n1 as $item) {
			$item->unsetRoleabInAsso1n1nN1(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_1n_1n_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_1n_1n_n1 ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolec_in_asso_1n_1n_n1 = $rolec_in_asso_1n_1n_n1 ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_1n_1n_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolec_in_asso_1n_1n_n1 as $item) {
			$item->setRoleabInAsso1n1nN1($this,false) ;
		}
	}
}

/**
 * addRolecInAsso1n1nN1
 */
public function addRolecInAsso1n1nN1($rolec_in_asso_1n_1n_n1, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_1n_1n_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_1n_1n_n1 ;
		$changes['operation'] = 'add' ;
	}
	$this->rolec_in_asso_1n_1n_n1[] = $rolec_in_asso_1n_1n_n1 ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_1n_1n_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolec_in_asso_1n_1n_n1->setRoleabInAsso1n1nN1($this,false) ;
	}
}

/**
 * removeRolecInAsso1n1nN1
 */
public function removeRolecInAsso1n1nN1($rolec_in_asso_1n_1n_n1, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_1n_1n_n1)) {
		$rolec_in_asso_1n_1n_n1->unsetRoleabInAsso1n1nN1(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_1n_1n_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_1n_1n_n1 ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolec_in_asso_1n_1n_n1 as $key=>$item) {
		if($item->__sameAs($rolec_in_asso_1n_1n_n1)) {
			unset($this->rolec_in_asso_1n_1n_n1[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_1n_1n_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolecInAsso1n1nN1
 */
public function unsetRolecInAsso1n1nN1($backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_1n_1n_n1)) {
		foreach($this->rolec_in_asso_1n_1n_n1 as $item) {
			$item->unsetRoleabInAsso1n1nN1(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_1n_1n_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_1n_1n_n1 ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolec_in_asso_1n_1n_n1 = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_1n_1n_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolecInAsso1n1nN1
	 */
	public function getRolecInAsso1n1nN1()
	{
		return $this->rolec_in_asso_1n_1n_n1 ;
	}
	
}