<?php
/**
 * testmodule_Dto_Asso1nN1Nn
 * @package data.Module (name: test module)
 */
class testmodule_Dto_Asso1nN1Nn extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = 'Asso1nN1Nn';
    const MODULE_NAME = 'testmodule';
    
    /**
	 * @var testmodule_Dto_A
	 */
	protected $rolea_in_asso_1n_n1_nn ;
    /**
	 * @var testmodule_Dto_B
	 */
	protected $roleb_in_asso_1n_n1_nn ;
    /**
	 * @var testmodule_Dto_C
	 */
	protected $rolec_in_asso_1n_n1_nn ;
    
	
	/**
 * setRoleaInAsso1nN1Nn
 */
public function setRoleaInAsso1nN1Nn($rolea_in_asso_1n_n1_nn,$backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_1n_n1_nn)) {
		$this->rolea_in_asso_1n_n1_nn->removeRolebcInAsso1nN1Nn($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_1n_n1_nn' ;
		$changes['old_value'] = $this->rolea_in_asso_1n_n1_nn ;
		$changes['operation'] = 'set' ;
	}
	$this->rolea_in_asso_1n_n1_nn = $rolea_in_asso_1n_n1_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_1n_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->rolea_in_asso_1n_n1_nn->addRolebcInAsso1nN1Nn($this,false) ;
	}
}

	
	/**
	 * getRoleaInAsso1nN1Nn
	 */
	public function getRoleaInAsso1nN1Nn()
	{
		return $this->rolea_in_asso_1n_n1_nn ;
	}
	/**
 * setListOfRolebInAsso1nN1Nn
 */
public function setListOfRolebInAsso1nN1Nn($roleb_in_asso_1n_n1_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_1n_n1_nn)) {
		foreach($this->roleb_in_asso_1n_n1_nn as $item) {
			$item->unsetRoleacInAsso1nN1Nn(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_1n_n1_nn' ;
		$changes['old_value'] = $this->roleb_in_asso_1n_n1_nn ;
		$changes['operation'] = 'setlist' ;
	}
	$this->roleb_in_asso_1n_n1_nn = $roleb_in_asso_1n_n1_nn ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_1n_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->roleb_in_asso_1n_n1_nn as $item) {
			$item->setRoleacInAsso1nN1Nn($this,false) ;
		}
	}
}

/**
 * addRolebInAsso1nN1Nn
 */
public function addRolebInAsso1nN1Nn($roleb_in_asso_1n_n1_nn, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_1n_n1_nn' ;
		$changes['old_value'] = $this->roleb_in_asso_1n_n1_nn ;
		$changes['operation'] = 'add' ;
	}
	$this->roleb_in_asso_1n_n1_nn[] = $roleb_in_asso_1n_n1_nn ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_1n_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$roleb_in_asso_1n_n1_nn->setRoleacInAsso1nN1Nn($this,false) ;
	}
}

/**
 * removeRolebInAsso1nN1Nn
 */
public function removeRolebInAsso1nN1Nn($roleb_in_asso_1n_n1_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_1n_n1_nn)) {
		$roleb_in_asso_1n_n1_nn->unsetRoleacInAsso1nN1Nn(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_1n_n1_nn' ;
		$changes['old_value'] = $this->roleb_in_asso_1n_n1_nn ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->roleb_in_asso_1n_n1_nn as $key=>$item) {
		if($item->__sameAs($roleb_in_asso_1n_n1_nn)) {
			unset($this->roleb_in_asso_1n_n1_nn[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_1n_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolebInAsso1nN1Nn
 */
public function unsetRolebInAsso1nN1Nn($backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_1n_n1_nn)) {
		foreach($this->roleb_in_asso_1n_n1_nn as $item) {
			$item->unsetRoleacInAsso1nN1Nn(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_1n_n1_nn' ;
		$changes['old_value'] = $this->roleb_in_asso_1n_n1_nn ;
		$changes['operation'] = 'unset' ;
	}
	$this->roleb_in_asso_1n_n1_nn = array() ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_1n_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolebInAsso1nN1Nn
	 */
	public function getRolebInAsso1nN1Nn()
	{
		return $this->roleb_in_asso_1n_n1_nn ;
	}
	/**
 * setListOfRolecInAsso1nN1Nn
 */
public function setListOfRolecInAsso1nN1Nn($rolec_in_asso_1n_n1_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_1n_n1_nn)) {
		foreach($this->rolec_in_asso_1n_n1_nn as $item) {
			$item->removeRoleabInAsso1nN1Nn($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_1n_n1_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_1n_n1_nn ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolec_in_asso_1n_n1_nn = $rolec_in_asso_1n_n1_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_1n_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolec_in_asso_1n_n1_nn as $item) {
			$item->addRoleabInAsso1nN1Nn($this,false) ;
		}
	}
}

/**
 * addRolecInAsso1nN1Nn
 */
public function addRolecInAsso1nN1Nn($rolec_in_asso_1n_n1_nn, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_1n_n1_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_1n_n1_nn ;
		$changes['operation'] = 'add' ;
	}
	$this->rolec_in_asso_1n_n1_nn[] = $rolec_in_asso_1n_n1_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_1n_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolec_in_asso_1n_n1_nn->addRoleabInAsso1nN1Nn($this,false) ;
	}
}

/**
 * removeRolecInAsso1nN1Nn
 */
public function removeRolecInAsso1nN1Nn($rolec_in_asso_1n_n1_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_1n_n1_nn)) {
		$rolec_in_asso_1n_n1_nn->removeRoleabInAsso1nN1Nn($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_1n_n1_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_1n_n1_nn ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolec_in_asso_1n_n1_nn as $key=>$item) {
		if($item->__sameAs($rolec_in_asso_1n_n1_nn)) {
			unset($this->rolec_in_asso_1n_n1_nn[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_1n_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolecInAsso1nN1Nn
 */
public function unsetRolecInAsso1nN1Nn($backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_1n_n1_nn)) {
		foreach($this->rolec_in_asso_1n_n1_nn as $item) {
			$item->removeRoleabInAsso1nN1Nn($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_1n_n1_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_1n_n1_nn ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolec_in_asso_1n_n1_nn = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_1n_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolecInAsso1nN1Nn
	 */
	public function getRolecInAsso1nN1Nn()
	{
		return $this->rolec_in_asso_1n_n1_nn ;
	}
	
}