<?php
/**
 * testmodule_Dto_AssoN1N111
 * @package data.Module (name: test module)
 */
class testmodule_Dto_AssoN1N111 extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = 'AssoN1N111';
    const MODULE_NAME = 'testmodule';
    
    /**
	 * @var testmodule_Dto_A
	 */
	protected $rolea_in_asso_n1_n1_11 ;
    /**
	 * @var testmodule_Dto_B
	 */
	protected $roleb_in_asso_n1_n1_11 ;
    /**
	 * @var testmodule_Dto_C
	 */
	protected $rolec_in_asso_n1_n1_11 ;
    
	
	/**
 * setListOfRoleaInAssoN1N111
 */
public function setListOfRoleaInAssoN1N111($rolea_in_asso_n1_n1_11, $backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_n1_n1_11)) {
		foreach($this->rolea_in_asso_n1_n1_11 as $item) {
			$item->unsetRolebcInAssoN1N111(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_n1_n1_11' ;
		$changes['old_value'] = $this->rolea_in_asso_n1_n1_11 ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolea_in_asso_n1_n1_11 = $rolea_in_asso_n1_n1_11 ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_n1_n1_11 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolea_in_asso_n1_n1_11 as $item) {
			$item->setRolebcInAssoN1N111($this,false) ;
		}
	}
}

/**
 * addRoleaInAssoN1N111
 */
public function addRoleaInAssoN1N111($rolea_in_asso_n1_n1_11, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_n1_n1_11' ;
		$changes['old_value'] = $this->rolea_in_asso_n1_n1_11 ;
		$changes['operation'] = 'add' ;
	}
	$this->rolea_in_asso_n1_n1_11[] = $rolea_in_asso_n1_n1_11 ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_n1_n1_11 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolea_in_asso_n1_n1_11->setRolebcInAssoN1N111($this,false) ;
	}
}

/**
 * removeRoleaInAssoN1N111
 */
public function removeRoleaInAssoN1N111($rolea_in_asso_n1_n1_11, $backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_n1_n1_11)) {
		$rolea_in_asso_n1_n1_11->unsetRolebcInAssoN1N111(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_n1_n1_11' ;
		$changes['old_value'] = $this->rolea_in_asso_n1_n1_11 ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolea_in_asso_n1_n1_11 as $key=>$item) {
		if($item->__sameAs($rolea_in_asso_n1_n1_11)) {
			unset($this->rolea_in_asso_n1_n1_11[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_n1_n1_11 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRoleaInAssoN1N111
 */
public function unsetRoleaInAssoN1N111($backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_n1_n1_11)) {
		foreach($this->rolea_in_asso_n1_n1_11 as $item) {
			$item->unsetRolebcInAssoN1N111(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_n1_n1_11' ;
		$changes['old_value'] = $this->rolea_in_asso_n1_n1_11 ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolea_in_asso_n1_n1_11 = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_n1_n1_11 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRoleaInAssoN1N111
	 */
	public function getRoleaInAssoN1N111()
	{
		return $this->rolea_in_asso_n1_n1_11 ;
	}
	/**
 * setListOfRolebInAssoN1N111
 */
public function setListOfRolebInAssoN1N111($roleb_in_asso_n1_n1_11, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_n1_n1_11)) {
		foreach($this->roleb_in_asso_n1_n1_11 as $item) {
			$item->unsetRoleacInAssoN1N111(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_n1_n1_11' ;
		$changes['old_value'] = $this->roleb_in_asso_n1_n1_11 ;
		$changes['operation'] = 'setlist' ;
	}
	$this->roleb_in_asso_n1_n1_11 = $roleb_in_asso_n1_n1_11 ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_n1_n1_11 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->roleb_in_asso_n1_n1_11 as $item) {
			$item->setRoleacInAssoN1N111($this,false) ;
		}
	}
}

/**
 * addRolebInAssoN1N111
 */
public function addRolebInAssoN1N111($roleb_in_asso_n1_n1_11, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_n1_n1_11' ;
		$changes['old_value'] = $this->roleb_in_asso_n1_n1_11 ;
		$changes['operation'] = 'add' ;
	}
	$this->roleb_in_asso_n1_n1_11[] = $roleb_in_asso_n1_n1_11 ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_n1_n1_11 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$roleb_in_asso_n1_n1_11->setRoleacInAssoN1N111($this,false) ;
	}
}

/**
 * removeRolebInAssoN1N111
 */
public function removeRolebInAssoN1N111($roleb_in_asso_n1_n1_11, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_n1_n1_11)) {
		$roleb_in_asso_n1_n1_11->unsetRoleacInAssoN1N111(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_n1_n1_11' ;
		$changes['old_value'] = $this->roleb_in_asso_n1_n1_11 ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->roleb_in_asso_n1_n1_11 as $key=>$item) {
		if($item->__sameAs($roleb_in_asso_n1_n1_11)) {
			unset($this->roleb_in_asso_n1_n1_11[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_n1_n1_11 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolebInAssoN1N111
 */
public function unsetRolebInAssoN1N111($backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_n1_n1_11)) {
		foreach($this->roleb_in_asso_n1_n1_11 as $item) {
			$item->unsetRoleacInAssoN1N111(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_n1_n1_11' ;
		$changes['old_value'] = $this->roleb_in_asso_n1_n1_11 ;
		$changes['operation'] = 'unset' ;
	}
	$this->roleb_in_asso_n1_n1_11 = array() ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_n1_n1_11 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolebInAssoN1N111
	 */
	public function getRolebInAssoN1N111()
	{
		return $this->roleb_in_asso_n1_n1_11 ;
	}
	/**
 * setRolecInAssoN1N111
 */
public function setRolecInAssoN1N111($rolec_in_asso_n1_n1_11,$backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_n1_n1_11)) {
		$this->rolec_in_asso_n1_n1_11->unsetRoleabInAssoN1N111(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_n1_n1_11' ;
		$changes['old_value'] = $this->rolec_in_asso_n1_n1_11 ;
		$changes['operation'] = 'set' ;
	}
	$this->rolec_in_asso_n1_n1_11 = $rolec_in_asso_n1_n1_11 ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_n1_n1_11 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->rolec_in_asso_n1_n1_11->setRoleabInAssoN1N111($this,false) ;
	}
}

	
	/**
	 * getRolecInAssoN1N111
	 */
	public function getRolecInAssoN1N111()
	{
		return $this->rolec_in_asso_n1_n1_11 ;
	}
	
}