<?php
/**
 * testmodule_Dto_AssoN1N11n
 * @package data.Module (name: test module)
 */
class testmodule_Dto_AssoN1N11n extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = 'AssoN1N11n';
    const MODULE_NAME = 'testmodule';
    
    /**
	 * @var testmodule_Dto_A
	 */
	protected $rolea_in_asso_n1_n1_1n ;
    /**
	 * @var testmodule_Dto_B
	 */
	protected $roleb_in_asso_n1_n1_1n ;
    /**
	 * @var testmodule_Dto_C
	 */
	protected $rolec_in_asso_n1_n1_1n ;
    
	
	/**
 * setListOfRoleaInAssoN1N11n
 */
public function setListOfRoleaInAssoN1N11n($rolea_in_asso_n1_n1_1n, $backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_n1_n1_1n)) {
		foreach($this->rolea_in_asso_n1_n1_1n as $item) {
			$item->unsetRolebcInAssoN1N11n(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_n1_n1_1n' ;
		$changes['old_value'] = $this->rolea_in_asso_n1_n1_1n ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolea_in_asso_n1_n1_1n = $rolea_in_asso_n1_n1_1n ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_n1_n1_1n ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolea_in_asso_n1_n1_1n as $item) {
			$item->setRolebcInAssoN1N11n($this,false) ;
		}
	}
}

/**
 * addRoleaInAssoN1N11n
 */
public function addRoleaInAssoN1N11n($rolea_in_asso_n1_n1_1n, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_n1_n1_1n' ;
		$changes['old_value'] = $this->rolea_in_asso_n1_n1_1n ;
		$changes['operation'] = 'add' ;
	}
	$this->rolea_in_asso_n1_n1_1n[] = $rolea_in_asso_n1_n1_1n ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_n1_n1_1n ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolea_in_asso_n1_n1_1n->setRolebcInAssoN1N11n($this,false) ;
	}
}

/**
 * removeRoleaInAssoN1N11n
 */
public function removeRoleaInAssoN1N11n($rolea_in_asso_n1_n1_1n, $backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_n1_n1_1n)) {
		$rolea_in_asso_n1_n1_1n->unsetRolebcInAssoN1N11n(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_n1_n1_1n' ;
		$changes['old_value'] = $this->rolea_in_asso_n1_n1_1n ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolea_in_asso_n1_n1_1n as $key=>$item) {
		if($item->__sameAs($rolea_in_asso_n1_n1_1n)) {
			unset($this->rolea_in_asso_n1_n1_1n[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_n1_n1_1n ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRoleaInAssoN1N11n
 */
public function unsetRoleaInAssoN1N11n($backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_n1_n1_1n)) {
		foreach($this->rolea_in_asso_n1_n1_1n as $item) {
			$item->unsetRolebcInAssoN1N11n(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_n1_n1_1n' ;
		$changes['old_value'] = $this->rolea_in_asso_n1_n1_1n ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolea_in_asso_n1_n1_1n = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_n1_n1_1n ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRoleaInAssoN1N11n
	 */
	public function getRoleaInAssoN1N11n()
	{
		return $this->rolea_in_asso_n1_n1_1n ;
	}
	/**
 * setListOfRolebInAssoN1N11n
 */
public function setListOfRolebInAssoN1N11n($roleb_in_asso_n1_n1_1n, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_n1_n1_1n)) {
		foreach($this->roleb_in_asso_n1_n1_1n as $item) {
			$item->unsetRoleacInAssoN1N11n(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_n1_n1_1n' ;
		$changes['old_value'] = $this->roleb_in_asso_n1_n1_1n ;
		$changes['operation'] = 'setlist' ;
	}
	$this->roleb_in_asso_n1_n1_1n = $roleb_in_asso_n1_n1_1n ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_n1_n1_1n ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->roleb_in_asso_n1_n1_1n as $item) {
			$item->setRoleacInAssoN1N11n($this,false) ;
		}
	}
}

/**
 * addRolebInAssoN1N11n
 */
public function addRolebInAssoN1N11n($roleb_in_asso_n1_n1_1n, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_n1_n1_1n' ;
		$changes['old_value'] = $this->roleb_in_asso_n1_n1_1n ;
		$changes['operation'] = 'add' ;
	}
	$this->roleb_in_asso_n1_n1_1n[] = $roleb_in_asso_n1_n1_1n ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_n1_n1_1n ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$roleb_in_asso_n1_n1_1n->setRoleacInAssoN1N11n($this,false) ;
	}
}

/**
 * removeRolebInAssoN1N11n
 */
public function removeRolebInAssoN1N11n($roleb_in_asso_n1_n1_1n, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_n1_n1_1n)) {
		$roleb_in_asso_n1_n1_1n->unsetRoleacInAssoN1N11n(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_n1_n1_1n' ;
		$changes['old_value'] = $this->roleb_in_asso_n1_n1_1n ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->roleb_in_asso_n1_n1_1n as $key=>$item) {
		if($item->__sameAs($roleb_in_asso_n1_n1_1n)) {
			unset($this->roleb_in_asso_n1_n1_1n[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_n1_n1_1n ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolebInAssoN1N11n
 */
public function unsetRolebInAssoN1N11n($backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_n1_n1_1n)) {
		foreach($this->roleb_in_asso_n1_n1_1n as $item) {
			$item->unsetRoleacInAssoN1N11n(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_n1_n1_1n' ;
		$changes['old_value'] = $this->roleb_in_asso_n1_n1_1n ;
		$changes['operation'] = 'unset' ;
	}
	$this->roleb_in_asso_n1_n1_1n = array() ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_n1_n1_1n ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolebInAssoN1N11n
	 */
	public function getRolebInAssoN1N11n()
	{
		return $this->roleb_in_asso_n1_n1_1n ;
	}
	/**
 * setRolecInAssoN1N11n
 */
public function setRolecInAssoN1N11n($rolec_in_asso_n1_n1_1n,$backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_n1_n1_1n)) {
		$this->rolec_in_asso_n1_n1_1n->removeRoleabInAssoN1N11n($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_n1_n1_1n' ;
		$changes['old_value'] = $this->rolec_in_asso_n1_n1_1n ;
		$changes['operation'] = 'set' ;
	}
	$this->rolec_in_asso_n1_n1_1n = $rolec_in_asso_n1_n1_1n ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_n1_n1_1n ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->rolec_in_asso_n1_n1_1n->addRoleabInAssoN1N11n($this,false) ;
	}
}

	
	/**
	 * getRolecInAssoN1N11n
	 */
	public function getRolecInAssoN1N11n()
	{
		return $this->rolec_in_asso_n1_n1_1n ;
	}
	
}