<?php
/**
 * testmodule_Dto_AssoN1N1N1
 * @package data.Module (name: test module)
 */
class testmodule_Dto_AssoN1N1N1 extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = 'AssoN1N1N1';
    const MODULE_NAME = 'testmodule';
    
    /**
	 * @var testmodule_Dto_A
	 */
	protected $rolea_in_asso_n1_n1_n1 ;
    /**
	 * @var testmodule_Dto_B
	 */
	protected $roleb_in_asso_n1_n1_n1 ;
    /**
	 * @var testmodule_Dto_C
	 */
	protected $rolec_in_asso_n1_n1_n1 ;
    
	
	/**
 * setListOfRoleaInAssoN1N1N1
 */
public function setListOfRoleaInAssoN1N1N1($rolea_in_asso_n1_n1_n1, $backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_n1_n1_n1)) {
		foreach($this->rolea_in_asso_n1_n1_n1 as $item) {
			$item->unsetRolebcInAssoN1N1N1(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_n1_n1_n1' ;
		$changes['old_value'] = $this->rolea_in_asso_n1_n1_n1 ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolea_in_asso_n1_n1_n1 = $rolea_in_asso_n1_n1_n1 ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_n1_n1_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolea_in_asso_n1_n1_n1 as $item) {
			$item->setRolebcInAssoN1N1N1($this,false) ;
		}
	}
}

/**
 * addRoleaInAssoN1N1N1
 */
public function addRoleaInAssoN1N1N1($rolea_in_asso_n1_n1_n1, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_n1_n1_n1' ;
		$changes['old_value'] = $this->rolea_in_asso_n1_n1_n1 ;
		$changes['operation'] = 'add' ;
	}
	$this->rolea_in_asso_n1_n1_n1[] = $rolea_in_asso_n1_n1_n1 ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_n1_n1_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolea_in_asso_n1_n1_n1->setRolebcInAssoN1N1N1($this,false) ;
	}
}

/**
 * removeRoleaInAssoN1N1N1
 */
public function removeRoleaInAssoN1N1N1($rolea_in_asso_n1_n1_n1, $backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_n1_n1_n1)) {
		$rolea_in_asso_n1_n1_n1->unsetRolebcInAssoN1N1N1(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_n1_n1_n1' ;
		$changes['old_value'] = $this->rolea_in_asso_n1_n1_n1 ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolea_in_asso_n1_n1_n1 as $key=>$item) {
		if($item->__sameAs($rolea_in_asso_n1_n1_n1)) {
			unset($this->rolea_in_asso_n1_n1_n1[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_n1_n1_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRoleaInAssoN1N1N1
 */
public function unsetRoleaInAssoN1N1N1($backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_n1_n1_n1)) {
		foreach($this->rolea_in_asso_n1_n1_n1 as $item) {
			$item->unsetRolebcInAssoN1N1N1(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_n1_n1_n1' ;
		$changes['old_value'] = $this->rolea_in_asso_n1_n1_n1 ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolea_in_asso_n1_n1_n1 = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_n1_n1_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRoleaInAssoN1N1N1
	 */
	public function getRoleaInAssoN1N1N1()
	{
		return $this->rolea_in_asso_n1_n1_n1 ;
	}
	/**
 * setListOfRolebInAssoN1N1N1
 */
public function setListOfRolebInAssoN1N1N1($roleb_in_asso_n1_n1_n1, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_n1_n1_n1)) {
		foreach($this->roleb_in_asso_n1_n1_n1 as $item) {
			$item->unsetRoleacInAssoN1N1N1(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_n1_n1_n1' ;
		$changes['old_value'] = $this->roleb_in_asso_n1_n1_n1 ;
		$changes['operation'] = 'setlist' ;
	}
	$this->roleb_in_asso_n1_n1_n1 = $roleb_in_asso_n1_n1_n1 ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_n1_n1_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->roleb_in_asso_n1_n1_n1 as $item) {
			$item->setRoleacInAssoN1N1N1($this,false) ;
		}
	}
}

/**
 * addRolebInAssoN1N1N1
 */
public function addRolebInAssoN1N1N1($roleb_in_asso_n1_n1_n1, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_n1_n1_n1' ;
		$changes['old_value'] = $this->roleb_in_asso_n1_n1_n1 ;
		$changes['operation'] = 'add' ;
	}
	$this->roleb_in_asso_n1_n1_n1[] = $roleb_in_asso_n1_n1_n1 ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_n1_n1_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$roleb_in_asso_n1_n1_n1->setRoleacInAssoN1N1N1($this,false) ;
	}
}

/**
 * removeRolebInAssoN1N1N1
 */
public function removeRolebInAssoN1N1N1($roleb_in_asso_n1_n1_n1, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_n1_n1_n1)) {
		$roleb_in_asso_n1_n1_n1->unsetRoleacInAssoN1N1N1(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_n1_n1_n1' ;
		$changes['old_value'] = $this->roleb_in_asso_n1_n1_n1 ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->roleb_in_asso_n1_n1_n1 as $key=>$item) {
		if($item->__sameAs($roleb_in_asso_n1_n1_n1)) {
			unset($this->roleb_in_asso_n1_n1_n1[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_n1_n1_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolebInAssoN1N1N1
 */
public function unsetRolebInAssoN1N1N1($backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_n1_n1_n1)) {
		foreach($this->roleb_in_asso_n1_n1_n1 as $item) {
			$item->unsetRoleacInAssoN1N1N1(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_n1_n1_n1' ;
		$changes['old_value'] = $this->roleb_in_asso_n1_n1_n1 ;
		$changes['operation'] = 'unset' ;
	}
	$this->roleb_in_asso_n1_n1_n1 = array() ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_n1_n1_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolebInAssoN1N1N1
	 */
	public function getRolebInAssoN1N1N1()
	{
		return $this->roleb_in_asso_n1_n1_n1 ;
	}
	/**
 * setListOfRolecInAssoN1N1N1
 */
public function setListOfRolecInAssoN1N1N1($rolec_in_asso_n1_n1_n1, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_n1_n1_n1)) {
		foreach($this->rolec_in_asso_n1_n1_n1 as $item) {
			$item->unsetRoleabInAssoN1N1N1(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_n1_n1_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_n1_n1_n1 ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolec_in_asso_n1_n1_n1 = $rolec_in_asso_n1_n1_n1 ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_n1_n1_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolec_in_asso_n1_n1_n1 as $item) {
			$item->setRoleabInAssoN1N1N1($this,false) ;
		}
	}
}

/**
 * addRolecInAssoN1N1N1
 */
public function addRolecInAssoN1N1N1($rolec_in_asso_n1_n1_n1, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_n1_n1_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_n1_n1_n1 ;
		$changes['operation'] = 'add' ;
	}
	$this->rolec_in_asso_n1_n1_n1[] = $rolec_in_asso_n1_n1_n1 ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_n1_n1_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolec_in_asso_n1_n1_n1->setRoleabInAssoN1N1N1($this,false) ;
	}
}

/**
 * removeRolecInAssoN1N1N1
 */
public function removeRolecInAssoN1N1N1($rolec_in_asso_n1_n1_n1, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_n1_n1_n1)) {
		$rolec_in_asso_n1_n1_n1->unsetRoleabInAssoN1N1N1(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_n1_n1_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_n1_n1_n1 ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolec_in_asso_n1_n1_n1 as $key=>$item) {
		if($item->__sameAs($rolec_in_asso_n1_n1_n1)) {
			unset($this->rolec_in_asso_n1_n1_n1[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_n1_n1_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolecInAssoN1N1N1
 */
public function unsetRolecInAssoN1N1N1($backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_n1_n1_n1)) {
		foreach($this->rolec_in_asso_n1_n1_n1 as $item) {
			$item->unsetRoleabInAssoN1N1N1(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_n1_n1_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_n1_n1_n1 ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolec_in_asso_n1_n1_n1 = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_n1_n1_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolecInAssoN1N1N1
	 */
	public function getRolecInAssoN1N1N1()
	{
		return $this->rolec_in_asso_n1_n1_n1 ;
	}
	
}