<?php
/**
 * testmodule_Dto_AssoNnNn1n
 * @package data.Module (name: test module)
 */
class testmodule_Dto_AssoNnNn1n extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = 'AssoNnNn1n';
    const MODULE_NAME = 'testmodule';
    
    /**
	 * @var testmodule_Dto_A
	 */
	protected $rolea_in_asso_nn_nn_1n ;
    /**
	 * @var testmodule_Dto_B
	 */
	protected $roleb_in_asso_nn_nn_1n ;
    /**
	 * @var testmodule_Dto_C
	 */
	protected $rolec_in_asso_nn_nn_1n ;
    
	
	/**
 * setListOfRoleaInAssoNnNn1n
 */
public function setListOfRoleaInAssoNnNn1n($rolea_in_asso_nn_nn_1n, $backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_nn_nn_1n)) {
		foreach($this->rolea_in_asso_nn_nn_1n as $item) {
			$item->removeRolebcInAssoNnNn1n($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_nn_nn_1n' ;
		$changes['old_value'] = $this->rolea_in_asso_nn_nn_1n ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolea_in_asso_nn_nn_1n = $rolea_in_asso_nn_nn_1n ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_nn_nn_1n ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolea_in_asso_nn_nn_1n as $item) {
			$item->addRolebcInAssoNnNn1n($this,false) ;
		}
	}
}

/**
 * addRoleaInAssoNnNn1n
 */
public function addRoleaInAssoNnNn1n($rolea_in_asso_nn_nn_1n, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_nn_nn_1n' ;
		$changes['old_value'] = $this->rolea_in_asso_nn_nn_1n ;
		$changes['operation'] = 'add' ;
	}
	$this->rolea_in_asso_nn_nn_1n[] = $rolea_in_asso_nn_nn_1n ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_nn_nn_1n ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolea_in_asso_nn_nn_1n->addRolebcInAssoNnNn1n($this,false) ;
	}
}

/**
 * removeRoleaInAssoNnNn1n
 */
public function removeRoleaInAssoNnNn1n($rolea_in_asso_nn_nn_1n, $backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_nn_nn_1n)) {
		$rolea_in_asso_nn_nn_1n->removeRolebcInAssoNnNn1n($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_nn_nn_1n' ;
		$changes['old_value'] = $this->rolea_in_asso_nn_nn_1n ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolea_in_asso_nn_nn_1n as $key=>$item) {
		if($item->__sameAs($rolea_in_asso_nn_nn_1n)) {
			unset($this->rolea_in_asso_nn_nn_1n[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_nn_nn_1n ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRoleaInAssoNnNn1n
 */
public function unsetRoleaInAssoNnNn1n($backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_nn_nn_1n)) {
		foreach($this->rolea_in_asso_nn_nn_1n as $item) {
			$item->removeRolebcInAssoNnNn1n($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_nn_nn_1n' ;
		$changes['old_value'] = $this->rolea_in_asso_nn_nn_1n ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolea_in_asso_nn_nn_1n = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_nn_nn_1n ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRoleaInAssoNnNn1n
	 */
	public function getRoleaInAssoNnNn1n()
	{
		return $this->rolea_in_asso_nn_nn_1n ;
	}
	/**
 * setListOfRolebInAssoNnNn1n
 */
public function setListOfRolebInAssoNnNn1n($roleb_in_asso_nn_nn_1n, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_nn_nn_1n)) {
		foreach($this->roleb_in_asso_nn_nn_1n as $item) {
			$item->removeRoleacInAssoNnNn1n($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_nn_nn_1n' ;
		$changes['old_value'] = $this->roleb_in_asso_nn_nn_1n ;
		$changes['operation'] = 'setlist' ;
	}
	$this->roleb_in_asso_nn_nn_1n = $roleb_in_asso_nn_nn_1n ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_nn_nn_1n ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->roleb_in_asso_nn_nn_1n as $item) {
			$item->addRoleacInAssoNnNn1n($this,false) ;
		}
	}
}

/**
 * addRolebInAssoNnNn1n
 */
public function addRolebInAssoNnNn1n($roleb_in_asso_nn_nn_1n, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_nn_nn_1n' ;
		$changes['old_value'] = $this->roleb_in_asso_nn_nn_1n ;
		$changes['operation'] = 'add' ;
	}
	$this->roleb_in_asso_nn_nn_1n[] = $roleb_in_asso_nn_nn_1n ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_nn_nn_1n ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$roleb_in_asso_nn_nn_1n->addRoleacInAssoNnNn1n($this,false) ;
	}
}

/**
 * removeRolebInAssoNnNn1n
 */
public function removeRolebInAssoNnNn1n($roleb_in_asso_nn_nn_1n, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_nn_nn_1n)) {
		$roleb_in_asso_nn_nn_1n->removeRoleacInAssoNnNn1n($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_nn_nn_1n' ;
		$changes['old_value'] = $this->roleb_in_asso_nn_nn_1n ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->roleb_in_asso_nn_nn_1n as $key=>$item) {
		if($item->__sameAs($roleb_in_asso_nn_nn_1n)) {
			unset($this->roleb_in_asso_nn_nn_1n[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_nn_nn_1n ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolebInAssoNnNn1n
 */
public function unsetRolebInAssoNnNn1n($backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_nn_nn_1n)) {
		foreach($this->roleb_in_asso_nn_nn_1n as $item) {
			$item->removeRoleacInAssoNnNn1n($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_nn_nn_1n' ;
		$changes['old_value'] = $this->roleb_in_asso_nn_nn_1n ;
		$changes['operation'] = 'unset' ;
	}
	$this->roleb_in_asso_nn_nn_1n = array() ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_nn_nn_1n ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolebInAssoNnNn1n
	 */
	public function getRolebInAssoNnNn1n()
	{
		return $this->roleb_in_asso_nn_nn_1n ;
	}
	/**
 * setRolecInAssoNnNn1n
 */
public function setRolecInAssoNnNn1n($rolec_in_asso_nn_nn_1n,$backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_nn_nn_1n)) {
		$this->rolec_in_asso_nn_nn_1n->removeRoleabInAssoNnNn1n($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_nn_nn_1n' ;
		$changes['old_value'] = $this->rolec_in_asso_nn_nn_1n ;
		$changes['operation'] = 'set' ;
	}
	$this->rolec_in_asso_nn_nn_1n = $rolec_in_asso_nn_nn_1n ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_nn_nn_1n ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->rolec_in_asso_nn_nn_1n->addRoleabInAssoNnNn1n($this,false) ;
	}
}

	
	/**
	 * getRolecInAssoNnNn1n
	 */
	public function getRolecInAssoNnNn1n()
	{
		return $this->rolec_in_asso_nn_nn_1n ;
	}
	
}