<?php
/**
 * testmodule_Dto_AssoNnNnNn
 * @package data.Module (name: test module)
 */
class testmodule_Dto_AssoNnNnNn extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = 'AssoNnNnNn';
    const MODULE_NAME = 'testmodule';
    
    /**
	 * @var testmodule_Dto_A
	 */
	protected $rolea_in_asso_nn_nn_nn ;
    /**
	 * @var testmodule_Dto_B
	 */
	protected $roleb_in_asso_nn_nn_nn ;
    /**
	 * @var testmodule_Dto_C
	 */
	protected $rolec_in_asso_nn_nn_nn ;
    
	
	/**
 * setListOfRoleaInAssoNnNnNn
 */
public function setListOfRoleaInAssoNnNnNn($rolea_in_asso_nn_nn_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_nn_nn_nn)) {
		foreach($this->rolea_in_asso_nn_nn_nn as $item) {
			$item->removeRolebcInAssoNnNnNn($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_nn_nn_nn' ;
		$changes['old_value'] = $this->rolea_in_asso_nn_nn_nn ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolea_in_asso_nn_nn_nn = $rolea_in_asso_nn_nn_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_nn_nn_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolea_in_asso_nn_nn_nn as $item) {
			$item->addRolebcInAssoNnNnNn($this,false) ;
		}
	}
}

/**
 * addRoleaInAssoNnNnNn
 */
public function addRoleaInAssoNnNnNn($rolea_in_asso_nn_nn_nn, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_nn_nn_nn' ;
		$changes['old_value'] = $this->rolea_in_asso_nn_nn_nn ;
		$changes['operation'] = 'add' ;
	}
	$this->rolea_in_asso_nn_nn_nn[] = $rolea_in_asso_nn_nn_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_nn_nn_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolea_in_asso_nn_nn_nn->addRolebcInAssoNnNnNn($this,false) ;
	}
}

/**
 * removeRoleaInAssoNnNnNn
 */
public function removeRoleaInAssoNnNnNn($rolea_in_asso_nn_nn_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_nn_nn_nn)) {
		$rolea_in_asso_nn_nn_nn->removeRolebcInAssoNnNnNn($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_nn_nn_nn' ;
		$changes['old_value'] = $this->rolea_in_asso_nn_nn_nn ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolea_in_asso_nn_nn_nn as $key=>$item) {
		if($item->__sameAs($rolea_in_asso_nn_nn_nn)) {
			unset($this->rolea_in_asso_nn_nn_nn[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_nn_nn_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRoleaInAssoNnNnNn
 */
public function unsetRoleaInAssoNnNnNn($backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_nn_nn_nn)) {
		foreach($this->rolea_in_asso_nn_nn_nn as $item) {
			$item->removeRolebcInAssoNnNnNn($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_nn_nn_nn' ;
		$changes['old_value'] = $this->rolea_in_asso_nn_nn_nn ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolea_in_asso_nn_nn_nn = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_nn_nn_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRoleaInAssoNnNnNn
	 */
	public function getRoleaInAssoNnNnNn()
	{
		return $this->rolea_in_asso_nn_nn_nn ;
	}
	/**
 * setListOfRolebInAssoNnNnNn
 */
public function setListOfRolebInAssoNnNnNn($roleb_in_asso_nn_nn_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_nn_nn_nn)) {
		foreach($this->roleb_in_asso_nn_nn_nn as $item) {
			$item->removeRoleacInAssoNnNnNn($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_nn_nn_nn' ;
		$changes['old_value'] = $this->roleb_in_asso_nn_nn_nn ;
		$changes['operation'] = 'setlist' ;
	}
	$this->roleb_in_asso_nn_nn_nn = $roleb_in_asso_nn_nn_nn ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_nn_nn_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->roleb_in_asso_nn_nn_nn as $item) {
			$item->addRoleacInAssoNnNnNn($this,false) ;
		}
	}
}

/**
 * addRolebInAssoNnNnNn
 */
public function addRolebInAssoNnNnNn($roleb_in_asso_nn_nn_nn, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_nn_nn_nn' ;
		$changes['old_value'] = $this->roleb_in_asso_nn_nn_nn ;
		$changes['operation'] = 'add' ;
	}
	$this->roleb_in_asso_nn_nn_nn[] = $roleb_in_asso_nn_nn_nn ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_nn_nn_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$roleb_in_asso_nn_nn_nn->addRoleacInAssoNnNnNn($this,false) ;
	}
}

/**
 * removeRolebInAssoNnNnNn
 */
public function removeRolebInAssoNnNnNn($roleb_in_asso_nn_nn_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_nn_nn_nn)) {
		$roleb_in_asso_nn_nn_nn->removeRoleacInAssoNnNnNn($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_nn_nn_nn' ;
		$changes['old_value'] = $this->roleb_in_asso_nn_nn_nn ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->roleb_in_asso_nn_nn_nn as $key=>$item) {
		if($item->__sameAs($roleb_in_asso_nn_nn_nn)) {
			unset($this->roleb_in_asso_nn_nn_nn[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_nn_nn_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolebInAssoNnNnNn
 */
public function unsetRolebInAssoNnNnNn($backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_nn_nn_nn)) {
		foreach($this->roleb_in_asso_nn_nn_nn as $item) {
			$item->removeRoleacInAssoNnNnNn($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_nn_nn_nn' ;
		$changes['old_value'] = $this->roleb_in_asso_nn_nn_nn ;
		$changes['operation'] = 'unset' ;
	}
	$this->roleb_in_asso_nn_nn_nn = array() ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_nn_nn_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolebInAssoNnNnNn
	 */
	public function getRolebInAssoNnNnNn()
	{
		return $this->roleb_in_asso_nn_nn_nn ;
	}
	/**
 * setListOfRolecInAssoNnNnNn
 */
public function setListOfRolecInAssoNnNnNn($rolec_in_asso_nn_nn_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_nn_nn_nn)) {
		foreach($this->rolec_in_asso_nn_nn_nn as $item) {
			$item->removeRoleabInAssoNnNnNn($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_nn_nn_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_nn_nn_nn ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolec_in_asso_nn_nn_nn = $rolec_in_asso_nn_nn_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_nn_nn_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolec_in_asso_nn_nn_nn as $item) {
			$item->addRoleabInAssoNnNnNn($this,false) ;
		}
	}
}

/**
 * addRolecInAssoNnNnNn
 */
public function addRolecInAssoNnNnNn($rolec_in_asso_nn_nn_nn, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_nn_nn_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_nn_nn_nn ;
		$changes['operation'] = 'add' ;
	}
	$this->rolec_in_asso_nn_nn_nn[] = $rolec_in_asso_nn_nn_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_nn_nn_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolec_in_asso_nn_nn_nn->addRoleabInAssoNnNnNn($this,false) ;
	}
}

/**
 * removeRolecInAssoNnNnNn
 */
public function removeRolecInAssoNnNnNn($rolec_in_asso_nn_nn_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_nn_nn_nn)) {
		$rolec_in_asso_nn_nn_nn->removeRoleabInAssoNnNnNn($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_nn_nn_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_nn_nn_nn ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolec_in_asso_nn_nn_nn as $key=>$item) {
		if($item->__sameAs($rolec_in_asso_nn_nn_nn)) {
			unset($this->rolec_in_asso_nn_nn_nn[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_nn_nn_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolecInAssoNnNnNn
 */
public function unsetRolecInAssoNnNnNn($backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_nn_nn_nn)) {
		foreach($this->rolec_in_asso_nn_nn_nn as $item) {
			$item->removeRoleabInAssoNnNnNn($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_nn_nn_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_nn_nn_nn ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolec_in_asso_nn_nn_nn = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_nn_nn_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolecInAssoNnNnNn
	 */
	public function getRolecInAssoNnNnNn()
	{
		return $this->rolec_in_asso_nn_nn_nn ;
	}
	
}