<?php
require_once('lib/Wisss/Dto/Abstract.php') ;
require_once('lib/Wisss/array_func.php') ;
/**
 * testmodule_Dto_E
 * @package data.Module (name: test module)
 */
class testmodule_Dto_E extends testmodule_Dto_C
{
	/**
     * information from model
     */
    const CLASS_NAME = 'E';
    const MODULE_NAME = 'testmodule';
    
	/**
	 * @var Integer
	 */
	protected $atte ;
	
	public function __construct()
	{
		parent::__construct() ;
		$this->__setToLoaded() ;
	}
	
	public function __destruct()
	{
		parent::__destruct() ;
	}
	
	public function __setToLoaded()
	{
	}
	
	public function __setToNotLoaded()
	{
	}
	
	public function setId($id,$reset_loading=true)
	{
		parent::setId($id) ;
		if($reset_loading) {
			$this->__setToNotLoaded() ;
		}
	}
	
	/**
 * setAtte
 */
public function setAtte($atte, $notify=true)
{
	if($notify) {
		$changes = new Wisss_Change() ;
		$changes->setAttribute('atte') ;
		$changes->setOld($this->atte) ;
		$changes->setOperation(Wisss_Change::OPERATION_SET) ;
	}
	$this->atte = $atte ;
	if($notify) {
		$changes->setNew($atte) ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getAtte
	 */
	public function getAtte()
	{
		return $this->atte ;
	}

	
}