package fr.obeo.weblog.ui.test.htmlunit;

import junit.framework.Test;
import junit.framework.TestSuite;
import fr.obeo.weblog.ui.users.test.htmlunit.TestCreateAccountAction;
import fr.obeo.weblog.ui.users.test.htmlunit.TestEditAccountAction;
import fr.obeo.weblog.ui.users.test.htmlunit.TestLoginAction;
import fr.obeo.weblog.ui.main.test.htmlunit.TestCreateLogAction;
import fr.obeo.weblog.ui.main.test.htmlunit.TestViewLogsAction;

/**
 * Junit Suite testing for weblog
 * Launch all HtmlUnit tests
 *
 */
public class UiFunctionnalTests {

/**
 * Main method
 *
 */
public static Test suite() {
		TestSuite suite = new TestSuite("UI Functionnal Tests");

		// Add one entry for each test class 
		// or test suite.
		suite.addTestSuite(TestCreateAccountAction.class);
		suite.addTestSuite(TestEditAccountAction.class);
		suite.addTestSuite(TestLoginAction.class);
		suite.addTestSuite(TestCreateLogAction.class);
		suite.addTestSuite(TestViewLogsAction.class);

		//Start of user code for suite tests
		//End of user code

		return suite;
	}

	//Start of user code for other tests
	//End of user code

}