""" This module is used to represents the relations between entities and 
their cardinalities
"""
class _rel_Database_Schema_2(list):
  """ Class used to represent the relation between Database
      and Schema"""
  def __init__(self,parent=None):
    list.__init__(self)
    self.upper_bound = -1
    self.lower_bound = 0
    self.is_unique = True
    self._parent_ = parent

    
  def append(self,schema):
    if schema in self:
      raise Exception("Element is already in the set")
    schema._parent_ = self._parent_
    list.append(self,schema)
    
       
class _rel_Schema_Table_1(list):
  """ Class used to represent the relation between Schema
      and Table"""
  def __init__(self,parent=None):
    list.__init__(self)
    self.upper_bound = -1
    self.lower_bound = 0
    self.is_unique = True
    self._parent_ = parent

    
  def append(self,table):
    if table in self:
      raise Exception("Element is already in the set")
    table._parent_ = self._parent_
    list.append(self,table)
    
       
class _rel_Table_Column_1(list):
  """ Class used to represent the relation between Table
      and Column"""
  def __init__(self,parent=None):
    list.__init__(self)
    self.upper_bound = 5
    self.lower_bound = 0
    self.is_unique = True
    self._parent_ = parent

    
  def append(self,column):
    if len(self) == 5:
      raise Exception("The relation upper bound is caught")
    if column in self:
      raise Exception("Element is already in the set")
    column._parent_ = self._parent_
    list.append(self,column)
    
       
class _rel_Table_ForeignKey_2(list):
  """ Class used to represent the relation between Table
      and ForeignKey"""
  def __init__(self,parent=None):
    list.__init__(self)
    self.upper_bound = -1
    self.lower_bound = 0
    self.is_unique = True
    self._parent_ = parent

    
  def append(self,foreignkey):
    if foreignkey in self:
      raise Exception("Element is already in the set")
    foreignkey._parent_ = self._parent_
    list.append(self,foreignkey)
    
       
class _rel_ForeignKey_Table_1(list):
  """ Class used to represent the relation between ForeignKey
      and Table"""
  def __init__(self,parent=None):
    list.__init__(self)
    self.upper_bound = 1
    self.lower_bound = 1
    self.is_unique = True
    self._parent_ = parent

    
  def append(self,table):
    if len(self) == 1:
      raise Exception("The relation upper bound is caught")
    if table in self:
      raise Exception("Element is already in the set")
    list.append(self,table)
  def remove(self,table):
    if len(self) == 1:
      raise Exception("The relation lower bound is caught")
    list.remove(self,table)
    
       
class _rel_ForeignKey_Table_2(list):
  """ Class used to represent the relation between ForeignKey
      and Table"""
  def __init__(self,parent=None):
    list.__init__(self)
    self.upper_bound = 1
    self.lower_bound = 1
    self.is_unique = True
    self._parent_ = parent

    
  def append(self,table):
    if len(self) == 1:
      raise Exception("The relation upper bound is caught")
    if table in self:
      raise Exception("Element is already in the set")
    list.append(self,table)
  def remove(self,table):
    if len(self) == 1:
      raise Exception("The relation lower bound is caught")
    list.remove(self,table)
    
       
