<%--
  Copyright © 2007 Cédric Brun
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Cédric Brun <cedric.brun@obeo.fr>
--%>
<%
metamodel http://www.eclipse.org/emf/2002/Ecore
import org.acceleo.module.pim.ecore.gen.python.common.name
%>

<%script type="EModelElement" name="annotedDocumentation" %>
<%eAnnotations.details[key=="documentation"].value%>

<%script type="EModelElement" name="hasAnnotedDocumentation" %>
<%eAnnotations[details.key=="documentation"].nSize() > 0%>

<%script type="EParameter" name="parameterPyDoc" post="trim"%>
 <%if (annotedDocumentation!=null){%>
       <%parameterName%> -- <%cardinalityMarker%> <%annotedDocumentation%> 
<%}else{%>
       <%parameterName%> -- <%cardinalityMarker%> No documentation found
 <%}%>       
 
<%script type="EParameter" name="cardinalityMarker" post="trim"%>
<%if (lowerBound == 0){%>** optional **  <%}%>
<%if (upperBound > 1){%>** collection ** <%}%>

<%script type="EPackage" name="documentation"%>
<%if (annotedDocumentation!=null){%>
<%annotedDocumentation%>
<%}else{%>
No documentation found for this module.
<%}%>

<%script type="EEnumLiteral" name="documentation" post="trim"%>
<%if (annotedDocumentation!=null){%>
<%annotedDocumentation%>
<%}else{%>
No documentation found for this literal
<%}%>
