<%--
  Copyright © 2007 Cédric Brun
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Cédric Brun <cedric.brun@obeo.fr>
--%>
<%
metamodel http://www.eclipse.org/emf/2002/Ecore

import org.acceleo.module.pim.ecore.gen.python.services.EcoreServices
%>

<%script type="EOperation" name="operationName" post="trim"%>
<%name.javaMethodToPythonMethod.toLowerCase%>

<%script type="EParameter" name="parameterName"%>
<%metamodel::name.replaceAll(" ","").toLowerCase()%>

<%script  type="EPackage" name="moduleName" post="trim"%>
<%name.javaMethodToPythonMethod()%>
<%script  type="EPackage" name="moduleFullName" post="trim"%>
<%(ancestor.reverse + self).filter("EPackage").moduleName.sep("/")%>

<%script  type="EPackage" name="ModulePath" post="trim"%>
<%moduleFullName%>/<%name.javaMethodToPythonMethod()%>

<%script  type="EPackage" name="ParserName"%>
<%moduleFullName%>/__parser__.py

<%script  type="EPackage" name="ModuleInit"%>
<%moduleFullName%>/__init__.py

<%script  type="EPackage" name="ModuleRelations"%>
<%moduleFullName%>/__rels__.py

<%script  type="EPackage" name="ModuleFactory"%>
<%moduleFullName%>/__factory__.py

<%script  type="EPackage" name="ModuleCommon"%>
<%moduleFullName%>/__common__.py  

<%script  type="EPackage" name="baseClass"%>
<%(name + "Base").javaMethodToPythonMethod().toU1Case()%>

<%script  type="EPackage" name="resourceClass"%>
<%(name + "Resource").javaMethodToPythonMethod().toU1Case()%>

<%script  type="EPackage" name="resourceFactory"%>
<%(name + "ResourceFactory").javaMethodToPythonMethod().toU1Case()%>

<%script  type="EPackage" name="factoryClassName"%>
<%(name + "Factory").javaMethodToPythonMethod().toU1Case()%>

<%script  type="EClassifier" name="ClassName"%>
<%name%>

<%script  type="ecore.EAttribute" name="AttributeName"%>
<%name%>

<%script type="EEnumLiteral" name="enumLiteralName"%>
<%name.replaceAll(" ","").toUpperCase()%>

<%script  type="ecore.EReference" name="ReferenceName" post="trim" %>
<%if (name == "from"){%>
from_
<%}else{%>
<%name%>
<%}%>


<%script  type="ecore.EReference" name="ReferenceTypeName" %>
_rel_<%eContainingClass.ClassName%>_<%eType.ClassName%>_<%precedingSibling().nSize()%>

<%script  type="ecore.EClassifier" name="ClassName"%>
<%name%>


