<%--
  Author     Pascal Lindelauf
  E-Mail     plindelauf@yellowtail.nl
  Copyright  2007 Yellowtail
  All rights reserved.   This program and the accompanying materials
  are made available under the terms of the GNU Public License v2.0 or any later version
  which accompanies this distribution, and is available at
  http://www.gnu.org/licenses/gpl.txt
    You can apply any license to the files generated with this template
  and Acceleo.
--%>
<%--
  Target project: none
  This template generates a single Visual Studio 2005 solution file, which
  bundles the generated projects. Use this solution file to open all generated
  projects and their elements in Visual Studio 2005.
--%>
<%
metamodel http://www.obeo.fr/acceleo/uml14

import com.yellowtail.uml14.gen.csharp.utils.config
%>

<%script type="uml14.Model" name="vs-solution" file="<%name%>/<%name%>.sln"%>
Microsoft Visual Studio Solution File, Format Version 9.00
# Visual Studio 2005
Project("<%solutionGuid%>") = "<%name%>PresentationConsoleUI", "Presentation\ConsoleUI\<%name%>PresentationConsoleUI.csproj", "<%projectGuidPresentationConsoleUI%>"
EndProject
Project("<%solutionGuid%>") = "<%name%>DomainModel", "DomainModel\<%name%>DomainModel.csproj", "<%projectGuidDomainModel%>"
EndProject
Project("<%solutionGuid%>") = "<%name%>DomainPersistenceImpl", "DomainPersistenceImpl\<%name%>DomainPersistenceImpl.csproj", "<%projectGuidDomainPersistenceImpl%>"
EndProject
Global
	GlobalSection(SolutionConfigurationPlatforms) = preSolution
		Debug|.NET = Debug|.NET
		Debug|Any CPU = Debug|Any CPU
		Debug|Mixed Platforms = Debug|Mixed Platforms
		Release|.NET = Release|.NET
		Release|Any CPU = Release|Any CPU
		Release|Mixed Platforms = Release|Mixed Platforms
	EndGlobalSection
	GlobalSection(ProjectConfigurationPlatforms) = postSolution
		{B163348B-6F26-425A-9C1D-205BD7595F01}.Debug|.NET.ActiveCfg = Debug|Any CPU
		{B163348B-6F26-425A-9C1D-205BD7595F01}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
		{B163348B-6F26-425A-9C1D-205BD7595F01}.Debug|Any CPU.Build.0 = Debug|Any CPU
		{B163348B-6F26-425A-9C1D-205BD7595F01}.Debug|Mixed Platforms.ActiveCfg = Debug|Any CPU
		{B163348B-6F26-425A-9C1D-205BD7595F01}.Debug|Mixed Platforms.Build.0 = Debug|Any CPU
		{B163348B-6F26-425A-9C1D-205BD7595F01}.Release|.NET.ActiveCfg = Release|Any CPU
		{B163348B-6F26-425A-9C1D-205BD7595F01}.Release|Any CPU.ActiveCfg = Release|Any CPU
		{B163348B-6F26-425A-9C1D-205BD7595F01}.Release|Any CPU.Build.0 = Release|Any CPU
		{B163348B-6F26-425A-9C1D-205BD7595F01}.Release|Mixed Platforms.ActiveCfg = Release|Any CPU
		{B163348B-6F26-425A-9C1D-205BD7595F01}.Release|Mixed Platforms.Build.0 = Release|Any CPU
		{5A8CC3E4-AB9D-4998-A89B-7EE80DC4D182}.Debug|.NET.ActiveCfg = Debug|Any CPU
		{5A8CC3E4-AB9D-4998-A89B-7EE80DC4D182}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
		{5A8CC3E4-AB9D-4998-A89B-7EE80DC4D182}.Debug|Any CPU.Build.0 = Debug|Any CPU
		{5A8CC3E4-AB9D-4998-A89B-7EE80DC4D182}.Debug|Mixed Platforms.ActiveCfg = Debug|Any CPU
		{5A8CC3E4-AB9D-4998-A89B-7EE80DC4D182}.Debug|Mixed Platforms.Build.0 = Debug|Any CPU
		{5A8CC3E4-AB9D-4998-A89B-7EE80DC4D182}.Release|.NET.ActiveCfg = Release|Any CPU
		{5A8CC3E4-AB9D-4998-A89B-7EE80DC4D182}.Release|Any CPU.ActiveCfg = Release|Any CPU
		{5A8CC3E4-AB9D-4998-A89B-7EE80DC4D182}.Release|Any CPU.Build.0 = Release|Any CPU
		{5A8CC3E4-AB9D-4998-A89B-7EE80DC4D182}.Release|Mixed Platforms.ActiveCfg = Release|Any CPU
		{5A8CC3E4-AB9D-4998-A89B-7EE80DC4D182}.Release|Mixed Platforms.Build.0 = Release|Any CPU
		{C2D2B1FB-52AA-4407-8C5C-2BFC723CDC03}.Debug|.NET.ActiveCfg = Debug|Any CPU
		{C2D2B1FB-52AA-4407-8C5C-2BFC723CDC03}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
		{C2D2B1FB-52AA-4407-8C5C-2BFC723CDC03}.Debug|Any CPU.Build.0 = Debug|Any CPU
		{C2D2B1FB-52AA-4407-8C5C-2BFC723CDC03}.Debug|Mixed Platforms.ActiveCfg = Debug|Any CPU
		{C2D2B1FB-52AA-4407-8C5C-2BFC723CDC03}.Debug|Mixed Platforms.Build.0 = Debug|Any CPU
		{C2D2B1FB-52AA-4407-8C5C-2BFC723CDC03}.Release|.NET.ActiveCfg = Release|Any CPU
		{C2D2B1FB-52AA-4407-8C5C-2BFC723CDC03}.Release|Any CPU.ActiveCfg = Release|Any CPU
		{C2D2B1FB-52AA-4407-8C5C-2BFC723CDC03}.Release|Any CPU.Build.0 = Release|Any CPU
		{C2D2B1FB-52AA-4407-8C5C-2BFC723CDC03}.Release|Mixed Platforms.ActiveCfg = Release|Any CPU
		{C2D2B1FB-52AA-4407-8C5C-2BFC723CDC03}.Release|Mixed Platforms.Build.0 = Release|Any CPU
		{153F3816-2F26-4E15-80B0-200AB193B244}.Debug|.NET.ActiveCfg = Debug|Any CPU
		{153F3816-2F26-4E15-80B0-200AB193B244}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
		{153F3816-2F26-4E15-80B0-200AB193B244}.Debug|Any CPU.Build.0 = Debug|Any CPU
		{153F3816-2F26-4E15-80B0-200AB193B244}.Debug|Mixed Platforms.ActiveCfg = Debug|Any CPU
		{153F3816-2F26-4E15-80B0-200AB193B244}.Debug|Mixed Platforms.Build.0 = Debug|Any CPU
		{153F3816-2F26-4E15-80B0-200AB193B244}.Release|.NET.ActiveCfg = Release|Any CPU
		{153F3816-2F26-4E15-80B0-200AB193B244}.Release|Any CPU.ActiveCfg = Release|Any CPU
		{153F3816-2F26-4E15-80B0-200AB193B244}.Release|Any CPU.Build.0 = Release|Any CPU
		{153F3816-2F26-4E15-80B0-200AB193B244}.Release|Mixed Platforms.ActiveCfg = Release|Any CPU
		{153F3816-2F26-4E15-80B0-200AB193B244}.Release|Mixed Platforms.Build.0 = Release|Any CPU
		{C7576548-AFB2-4325-8494-9262689AAC86}.Debug|.NET.ActiveCfg = Debug|.NET
		{C7576548-AFB2-4325-8494-9262689AAC86}.Debug|.NET.Build.0 = Debug|.NET
		{C7576548-AFB2-4325-8494-9262689AAC86}.Debug|Any CPU.ActiveCfg = Debug|.NET
		{C7576548-AFB2-4325-8494-9262689AAC86}.Debug|Mixed Platforms.ActiveCfg = Debug|.NET
		{C7576548-AFB2-4325-8494-9262689AAC86}.Debug|Mixed Platforms.Build.0 = Debug|.NET
		{C7576548-AFB2-4325-8494-9262689AAC86}.Release|.NET.ActiveCfg = Debug|.NET
		{C7576548-AFB2-4325-8494-9262689AAC86}.Release|.NET.Build.0 = Debug|.NET
		{C7576548-AFB2-4325-8494-9262689AAC86}.Release|Any CPU.ActiveCfg = Debug|.NET
		{C7576548-AFB2-4325-8494-9262689AAC86}.Release|Mixed Platforms.ActiveCfg = Debug|.NET
		{C7576548-AFB2-4325-8494-9262689AAC86}.Release|Mixed Platforms.Build.0 = Debug|.NET
	EndGlobalSection
	GlobalSection(SolutionProperties) = preSolution
		HideSolutionNode = FALSE
	EndGlobalSection
EndGlobal