<%--
  Author     Pascal Lindelauf
  E-Mail     plindelauf@yellowtail.nl
  Copyright  2007 Yellowtail
  All rights reserved.   This program and the accompanying materials
  are made available under the terms of the GNU Public License v2.0 or any later version
  which accompanies this distribution, and is available at
  http://www.gnu.org/licenses/gpl.txt
    You can apply any license to the files generated with this template
  and Acceleo.
--%>
<%--
  Target project: DomainModel
  This template generates a single generic repository interface class,
  that will be used as a base class for all specific repository interfaces.
--%>
<%
metamodel http://www.obeo.fr/acceleo/uml14

import com.yellowtail.uml14.gen.csharp.services.Uml14Service
%>

<%script type="uml14.Model" name="irepository" file="<%name%>/DomainModel/Common/IRepository.cs"%>
using System;

namespace <%name%>.DomainModel.Common
{
    public interface IRepository
    {
        bool IsOpen { get ; }
        Object Get(Type entityType, object id);
        void SaveOrUpdate(Object entity);
        void Persist();
   }
}
