<%--
  Author     Pascal Lindelauf
  E-Mail     plindelauf@yellowtail.nl
  Copyright  2007 Yellowtail
  All rights reserved.   This program and the accompanying materials
  are made available under the terms of the GNU Public License v2.0 or any later version
  which accompanies this distribution, and is available at
  http://www.gnu.org/licenses/gpl.txt
    You can apply any license to the files generated with this template
  and Acceleo.
--%>
<%--
  Target project: DomainModel
  This template generates a C# enuration class for each UML class
  stereotyped as "enumeration", that is located in a package that 
  is stereotyped as "domainModule".
--%>
<%
metamodel http://www.obeo.fr/acceleo/uml14

import com.yellowtail.uml14.gen.csharp.services.ClassService
import com.yellowtail.uml14.gen.csharp.services.NamespaceService
import com.yellowtail.uml14.gen.csharp.services.AttributeService
import com.yellowtail.uml14.gen.csharp.services.Uml14Service
%>

<%-- TO DO: containsCollectionRef around using System.Collection: get it to work for associationEnds as well, Abstract keyword --%>
<%script type="core.Class" name="filename"%>
<%if (hasStereotype("enumeration")){%>
<%getRootContainer().name%>/DomainModel/<%XLevelAndDownClassPath(2,"/")%>/<%name%>.cs
<%}%>

<%script type="core.Class" name="domain-class-enumeration" file="<%filename%>"%>
using System;
using System.Text;

namespace <%getRootContainer().name%>.DomainModel.<%XLevelAndDownClassPath(2,".")%>
{
    public enum <%name%>
    { 
		<%for (attribute){%><%if (i>0){%>,<%}%>
		<%propertyName%> = <%initialValue.body%><%}%> 
	
	}
}
