package org.acceleo.demo.jee.spring.plugin.wizard;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.acceleo.demo.common.AbstractDemoWizard;
import org.acceleo.demo.jee.spring.plugin.SpringDemoPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;

public class SpringDemoWizard extends AbstractDemoWizard {
		
	protected Collection getProjectDescriptors() {
		List projects = new ArrayList(1);
		projects.add(new ProjectDescriptor("org.acceleo.demo.jee.spring.plugin", "zips/org.acceleo.sample.demo.spring.zip", "org.acceleo.sample.demo.spring"));
		
		return projects;
	}
	
	protected void log(Exception e) {
		if (e instanceof CoreException) {
			SpringDemoPlugin.getDefault().getLog().log(((CoreException)e).getStatus());
		} else {
			SpringDemoPlugin.getDefault().getLog().log(new Status(IStatus.ERROR, SpringDemoPlugin.getDefault().getBundle().getSymbolicName(),IStatus.ERROR, e.getMessage(),e));
		}
	}

}
