<%--
  Copyright  2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.Uml2Services

import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.structure
%>

<%script type="Type" name="entityPackage"%>
<%if (getProperty("useEntityPackage")=="no"){%>
<%package.getCompleteName()%><%}else{%>
<%baseImports%>.<%projectName%>.business.<%package.normalizedName%><%}%>

<%script type="Type" name="dtoPackage"%>
<%if (getProperty("useDtoPackage")=="no"){%>
<%package.getCompleteName()%><%}else{%>
<%baseImports%>.<%projectName%>.dto.<%package.normalizedName%><%}%>

<%script type="Type" name="dtoName"%>
<%if (getProperty("useDtoPackage")=="no"){%>
<%name%><%}else{%>
<%name%>Dto<%}%>

<%--
/**
 * <p>Get Full Qualified Name</p>
 * 
 * @param clazz class
 * @return FQN
 */
--%>
<%script type="NamedElement" name="getCompleteName"%>
<%qualifiedName.replaceAll("::",".")%>

<%script type="Element" name="getCompleteName"%>
<%self().getCompleteName()%>