<%--
  Copyright  2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Etienne Juliot
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.Uml2Services
%>

<%-- 
This template deals with structural aspects
--%>
<%script type="Class" name="classAttributes"%>
<%ownedAttribute + getAssociations().oppositeAttributeOf(current())[isNavigable]%>

<%script type="Class" name="generateImports"%>
<%for (classAttributes){%>	
	<%if (type.package.name!="UMLPrimitiveTypes" && type.name!="String" && type.name!="Integer" && type.name!="Float" && type.name!="Long" && type.name!="Boolean" && type.name!="Date"){%>
import <%type.qualifiedName.replaceAll("::",".")%>;
	<%}%>
<%}%>


<%script type="Operation" name="generateParameters"%>
<%-- Generates parameters with types for a method --%>
<%getRealParameters().genDeclare().sep(", ")%>

<%script type="Parameter" name="genDeclare"%>
<%convertToJavaType%> <%name%>

<%script type="Operation" name="generateReturn"%>
<%-- Generates return name for a method --%>
<%-- if (returnResult == null){%>void<%}else{%><%returnResult.type.convertToJavaType%><%}--%>
<%if (type == null){%>void<%}else{%><%returnResult.convertToJavaType%><%}%>

<%script type="Operation" name="generateParameterNames"%>
<%-- Generates parameters names for a method --%>
<%getRealParameters().name.sep(", ")%>

<%script type="Operation" name="generateJavadoc"%>
<%-- Generates Javadoc for a method --%>
	/**
	 * <%ownedComment.body%>
<%for (getRealParameters()){%>
	 * @param <%name%> <%ownedComment.body%>
<%}%> 
<%if (type != null){%>
	 * @return <%type.ownedComment.body%>
<%}%>
	 */

<%script type="Class" name="extensions"%>
<%-- Manage extensions --%>
<%if (!general.isEmpty){%>extends <%general.name%><%}%>

<%script type="Package" name="normalizedName"%>
<%name.toStandardNotation().toLowerCase()%>
<%--FIXME if (isModel()){%><%name.toStandardNotation().toLowerCase()%><%}--%>
