<%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Etienne Juliot
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.dao.api.dao-common
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
%>


<%script type="Model" name="fullFilePath"%>
/<%testPackage.toPath()%>/All<%projectName.firstUpper()%>DaoTests.java

<%script type="Model" name="testPackage"%>
<%baseImports%>.<%projectName%>.dao.test

<%script type="Model" name="generate" file="<%fullFilePath%>"%>
package <%testPackage%>;

import junit.framework.Test;
import junit.framework.TestSuite;

<%for (getAllInstances("Class")){%><%if (hasStereotype(getProperty("Entity"))){%>
import <%baseImports%>.<%projectName%>.dao.<%package.normalizedName%>.test.I<%name%>DaoTest;
<%}%><%}%>

public class All<%projectName.firstUpper()%>DaoTests {

	public static Test suite() {
		TestSuite suite = new TestSuite(
				"Test for <%projectName%>");
		//$JUnit-BEGIN$
		<%for (getAllInstances("Class")){%><%if (hasStereotype(getProperty("Entity"))){%>
		suite.addTestSuite(I<%name%>DaoTest.class);
		<%}%><%}%>
		//$JUnit-END$
		return suite;
	}

}
