<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML


import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices

import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices

import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.spring.common
%>

<%script type="Class" name="iocImport" post="trim"%>
<%for (clientDependency){%>
	<%if ( supplier.hasStereotype(getProperty(args(0))) == "true" ){%>
		<%if (args(0) == "Config" ){%>
			import <%supplier.daoPackage%>.<%supplier.name%>;
		<%}else{%>
			import <%supplier.daoPackage%>.I<%supplier.name%>;
		<%}%>	
	<%}%>	
<%}%>

<%script type="Class" name="iocAccessors" %>
<%for (clientDependency){%>
	<%if ( supplier.hasStereotype(getProperty(args(0))) == "true" ){%>
private I<%supplier.name%> <%supplier.name.firstLower()%> = null;

	public void set<%supplier.name%>(I<%supplier.name%> <%supplier.name.firstLower()%>) {
		this.<%supplier.name.firstLower()%> = <%supplier.name.firstLower()%>;
	}
	
	public I<%supplier.name%> get<%supplier.name%>() {
		return this.<%supplier.name.firstLower()%>;
	}
	<%}%>
<%}%>

<%-- TODO refactor pour l'appeler en chaînant un serviceDependencies.genIocAccessors("I") ou viewDependencies.genIocAccessors() --%>
<%script type="Class" name="iocAccessors2" %>
<%for (clientDependency){%>
	<%if ( supplier.hasStereotype(getProperty(args(0))) == "true" ){%>
private <%supplier.name%> <%supplier.name.firstLower()%> = null;

	public void set<%supplier.name%>(<%supplier.name%> <%supplier.name.firstLower()%>) {
		this.<%supplier.name.firstLower()%> = <%supplier.name.firstLower()%>;
	}
	
	public <%supplier.name%> get<%supplier.name%>() {
		return this.<%supplier.name.firstLower()%>;
	}
	<%}%>
<%}%>

<%script type="Class" name="iocInjectors" %>
<%for (clientDependency){%>
	<%if ( supplier.hasStereotype(getProperty(args(0))) == "true" ){%>
	 	<property name="<%supplier.name.firstLower()%>" ref="<%supplier.computeBeanId()%>"/>			
	<%}%>
<%}%>
