<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.services.StringServices

import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices

import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.profile
import org.acceleo.module.pim.uml21.gen.java.dao.api.dao-common
%>

<%script type="Class" name="fullFilePath"%>
<%if ( isService ){%><%serviceImplPackage.toPath()%>/<%name%>Test.java<%}%>

<%script type="Class" name="generateService" file="<%fullFilePath%>"%>
package <%serviceImplPackage%>;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.junit.Test;
import <%baseImports%>.AbstractBusinessLayerTests;

import <%servicePackage%>.I<%name%>;	

<%for (operationsParametersTypes){%>
	<%if (filter("Classifier").isEntity){%>
import <%entityPackage%>.<%name%>;
import <%daoImplPackage%>.<%name%>Helper;
	<%}else if (filter("Classifier").isView){%>
import <%viewImplPackage%>.<%name%>;
	<%}else{%>
import <%getCompleteName()%>;	
	<%}%>
<%}%>

// <%startUserCode%> for import 
import java.util.Collection;
// <%endUserCode%> for import 

public class <%name%>Test extends AbstractBusinessLayerTests {

	/**
	 * class dedicated logger
 	 */
	private static Log log = LogFactory.getLog(<%name%>Test.class.getName()); 
	
	<%for (ownedOperation){%>
	@Test
	public void test<%name.firstUpper()%>() throws Exception {
		// <%startUserCode%> of test<%name.firstUpper()%>()
		
		// <%endUserCode%> of test<%name.firstUpper()%>()
	}	
	<%}%>
	
	// <%startUserCode%> of specific tests
	
	// <%endUserCode%> of specific tests
}
