<%--
  Copyright © 2007 Thierry TEMPLIER & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Thierry Templier <templth@gmail.com> 
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.services.StringServices

import org.acceleo.module.pim.uml21.gen.java.spring.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices

import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.profile
%>

<%script type="Model" name="fullFilePath"%>
<%if ( (services+daos).nSize()>0){%><%baseImports.toPath()%>/AbstractBusinessLayerTests.java<%}%>

<%script type="Model" name="generateAbstractBusinessLayerTests" file="<%fullFilePath%>"%>
package <%baseImports%>;

<%for (services) {%>
import <%servicePackage%>.I<%name%>;	
<%}%>
<%for (webservices) {%>
import <%servicePackage%>.I<%name%>WebService;	
<%}%>

// <%startUserCode%> for import 

// <%endUserCode%> for import 

public abstract class AbstractBusinessLayerTests extends org.sharengo.tests.AbstractBusinessLayerTests {
	
	protected String[] getDefaultConfigLocations() {
		return new String[] {"classpath:META-INF/spring/component-test.xml"};
	}

	protected String[] getConfigLocations() {
		// <%startUserCode%> of getConfigLocations
		return getDefaultConfigLocations();
		// <%endUserCode%> of getConfigLocations
	}

	@Override
	protected void onSetUp() throws Exception {
		// <%startUserCode%> of onSetUp
		super.onSetUp();
		// <%endUserCode%> of onSetUp
	}

	@Override
	protected void onTearDown() throws Exception {
		// <%startUserCode%> of onTearDown
		super.onTearDown();
		// <%endUserCode%> of onTearDown
	}

	<%-- add getter for all services --%>
	<%for (services) {%>		
	protected I<%name%> get<%name%>() throws Exception {
		I<%name%> <%name.toL1Case()%> = (I<%name%>) getApplicationContext()
				.getBean("<%name.toL1Case()%>");
		assertNotNull(<%name.toL1Case()%>);
		return <%name.toL1Case()%>;
	}
	<%}%>
	<%for (webservices){%>							
	protected I<%name%>WebService get<%name%>WebService()
			throws Exception {
		I<%name%>WebService <%name.toL1Case()%>WebService = (I<%name%>WebService) <%baseImports%>.ws.WSClientFactory
				.getInstance().create<%name%>WebService(
						"http://localhost:8191/I<%name%>WebService");
		assertNotNull(<%name.toL1Case()%>WebService);
		return <%name.toL1Case()%>WebService;
	}
	<%}%>
	
	// <%startUserCode%> of specific tests code
	// <%endUserCode%> of specific tests code
}
