<%--
  Copyright © 2007 Laurent BELMONTE & Jerome BENOIS
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
--%>

<%--
@author  Laurent Belmonte <laurent.belmonte@gmail.com>  
@author  Jerome Benois <jerome.benois@gmail.com> 
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.spring.services.SpringServices

import org.acceleo.module.pim.uml21.gen.java.common.common
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.common.structure
import org.acceleo.module.pim.uml21.gen.java.spring.common
import org.acceleo.module.pim.uml21.gen.java.spring.ioc
import org.acceleo.module.pim.uml21.gen.java.spring.profile
%>

<%script type="Class" name="fullFilePath"%>
<%if (isController){%>
	<%controllerPackage.toPath()%>/<%name%>.java
<%}%>

<%script type="Class" name="generateUi" file="<%fullFilePath%>"%>
package <%controllerPackage%>;


import java.io.IOException;
import java.io.OutputStreamWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.sharengo.exceptions.TechnicalException;
<%iocImport("Ui")%>

// <%startUserCode%> for import
import java.io.OutputStreamWriter;
// <%endUserCode%> for import

public class <%name%> {

	/**
	 * Default serial version ID
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * class dedicated logger
	 */
	 private static Log log = LogFactory.getLog(<%name%>.class.getName()); 

	
	<%iocAccessors("Ui")%>


	<%for (ownedOperation){%>
	<%generateJavadoc%>
	public void <%name%>(HttpServletRequest request, HttpServletResponse response) throws TechnicalException {
		try{
			// <%startUserCode%> of void <%name%>(HttpServletRequest request, HttpServletResponse response)
			OutputStreamWriter osw = new OutputStreamWriter(response.getOutputStream(),"UTF-8");
			osw.write("TODO implement showMainView action !");
			//ui.<%name%>(osw);
			osw.flush();			
			// <%endUserCode%>
		} catch (Exception e) {
			throw new TechnicalException(e);
		}		
	}
	<%}%>
	
	// <%startUserCode%> of others operations
	// <%endUserCode%>

}