[%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Stephane Lacrampe
--%]
[%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.gen.java.struts.common.widgets_mappings
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.struts.xml.validation_mapping
%]

[%script type="Class" name="fullFilePath"%]
[%if (hasStereotype(getProperty("Screen"))){%]
/[%package.name%]/[%name%].jsp
[%}%]

[%script type="Class" name="generate" file="[%fullFilePath%]"%]
<%@ taglib
        uri="http://struts.apache.org/tags-html"
        prefix="html" %>
<%@ taglib
        uri="http://struts.apache.org/tags-bean"
        prefix="bean" %>
<%@ taglib
        uri="http://struts.apache.org/tags-logic"
        prefix="logic" %>

<logic:messagesPresent>
   <bean:message key="errors.header"/>
   <ul>
   <html:messages id="error">
      <li><bean:write name="error"/></li>
   </html:messages>
   </ul>
   <bean:message key="errors.footer"/>
   <hr />
</logic:messagesPresent>

[%-- We generate javascript validation only if there is a need --%]
[%-- else Struts crashes at runtime... --%]
[%if (generateValidator.trim() != ""){%]
<html:javascript formName="[%name%]Form" staticJavascript="false" />
<html:form action="[%name%]Action" method="POST" onsubmit="return validate[%name%]Form(this)">
[%}else{%]
<html:form action="[%name%]Action" method="POST">
[%}%]

<html:hidden property="event" value=""/>

<table>
[%for (attribute.filterExistProperty("association",false)){%]
	[%if (!hasStereotype(getProperty("Title")) && !hasStereotype(getProperty("List")) && !hasStereotype(getProperty("Table")) && !hasStereotype(getProperty("Combobox"))) {%]
	<tr>
		<td><bean:message key="[%class.name%].[%name.toLowerCase()%]"/> :</td>
		<td><html:[%convertToHTMLStrutsTypeFromStereotype%] property="[%name.firstLower()%]" [%if (hasStereotype(getProperty("Radio"))){%]value="[%name.firstLower()%]"[%}%]/></td>
	</tr>
	[%}else if (hasStereotype(getProperty("Combobox"))){%]
	<tr>
		<td><bean:message key="[%class.name%].[%name.toLowerCase()%]"/> :</td>
		<td>
			<html:[%convertToHTMLStrutsTypeFromStereotype%] property="[%name.firstLower()%]">
				<html:options property="[%name.firstLower()%]Values"/>
			</html:[%convertToHTMLStrutsTypeFromStereotype%]>
		</td>
	</tr>
	[%}else{%]
		[%if (!hasStereotype(getProperty("Title"))) {%]
		[%-- Tables or List --%]
	<tr>
		<td>[%name%] :</td>
		<td><logic:iterate name="[%class.name%]Form" id="[%name.firstLower()%]_id" property="[%name.firstLower()%]" /></td>
	</tr>
		[%}%]
	[%}%]
[%}%]
[%for (ownedOperation){%]
	<tr>
		<td>
			<html:submit property="[%name.firstLower()%]" value="[%name.firstLower()%]" onclick="bCancel=false;[%class.name%]Form.event.value = '[%name.firstLower()%]';"/>
		</td>
	</tr>
[%}%]
</table>

</html:form>
