<%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Stephane Lacrampe
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
%>

<%-- 
This template deals with internationalization
--%>


<%script type="Model" name="generateCommonResources"%>
<%-- Generate common internationalization file--%>
<%for (eAllContents("Package")[cinematicPackage]){%>

                                #####################
                                # scenario <%name%>
                                #####################
			<%for (ownedElement.filter("Class")){%>
				<%if (hasStereotype(getProperty("Screen"))) {%>
################################# Page <%name%>.jsp #################################
#Label and text
					<%for (attribute.filterExistProperty("association",false)){%>
						<%if (!hasStereotype(getProperty("Title"))) {%>
<%class.name%>.<%name.toLowerCase()%>=<%name.firstUpper()%>
						<%}%>
					<%}%>
#Error Messages
					<%for (attribute.filterExistProperty("association",false)){%>
						<%if (!hasStereotype(getProperty("Title")) && !hasStereotype(getProperty("List")) && !hasStereotype(getProperty("Table"))) {%>
							<%if (type.name == "Integer"){%>
<%class.name%>.errors.integer.<%name.toLowerCase()%>=<%name.firstUpper()%>
							<%}%>
							<%if (type.name == "Double"){%>
<%class.name%>.errors.float.<%name.toLowerCase()%>=<%name.firstUpper()%>
							<%}%>
							<%if (type.name == "Date"){%>
<%class.name%>.errors.date.<%name.toLowerCase()%>=<%name.firstUpper()%>
							<%}%>
							<%if (type.name == "Email"){%>
<%class.name%>.errors.email.<%name.toLowerCase()%>=<%name.firstUpper()%>
							<%}%>
						<%}%>
					<%}%>
				<%}%>
			<%}%>
<%}%>
<%script type="Package" name="cinematicPackage"%>
<%eContents().filter("Class")[hasStereotype(getProperty("Screen"))].nSize() > 0%>