<%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Stephane Lacrampe
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.struts.common.common
%>

<%-- 
This template generate Struts configuration file
--%>

<%script type="Package" name="file"%>
<%if (nestingPackage.name == "cinematic" && name != ""){%>struts-config/struts-config-<%name%>.xml<%}%>

<%script type="Package" name="generate" file="<%file%>"%>
<%-- Generate struts-config.xml file --%>
<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE struts-config PUBLIC "-//Apache Software Foundation//DTD Struts Configuration 1.1//EN" "http://jakarta.apache.org/struts/dtds/struts-config_1_1.dtd">

<struts-config>

    <!-- ========== Form Bean Definitions ================================== -->
    <form-beans type="org.apache.struts.action.ActionFormBean">
<%for (ownedElement.filter("Class")){%>
	<%if (hasStereotype(getProperty("Screen"))) {%>
		<form-bean name="<%name%>Form" type="<%scenarioPackage%>.forms.<%name%>Form" />
	<%}%>
<%}%>
	</form-beans>

	<!-- ========== Action Mapping Definitions =============================== -->
    <action-mappings >
<%for (ownedElement.filter("Class")){%>
	<%if (hasStereotype(getProperty("Screen"))) {%>
		<action	path="/<%name%>Action" 
				type="<%scenarioPackage%>.actions.<%name%>Action" 
				parameter="event" 
				name="<%name%>Form" 
				scope="request" 
				validate="true" 
				input=".view.<%name%>">
			<forward name="self" path=".view.<%name%>" />
		<%for (getAssociations().oppositeAttributeOf(current())[isNavigable()]){%>
			<forward name="<%type.name.firstLower()%>" path="/<%type.name%>Action.do?event=init" /> 
		<%}%>
		</action>
	<%}%>
<%}%>
	</action-mappings>

</struts-config>

