<%--
  Copyright © 2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Stephane Lacrampe
--%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.gen.java.common.specifics
import org.acceleo.module.pim.uml21.gen.java.common.dataTypes
import org.acceleo.module.pim.uml21.services.StringServices
import org.acceleo.module.pim.uml21.services.ListServices
import org.acceleo.module.pim.uml21.services.Uml2Services
import org.acceleo.module.pim.uml21.gen.java.struts.common.common
%>

<%-- 
This template generate Struts configuration file
--%>

<%script type="Model" name="generate" file="struts-config/struts-config.xml"%>
<%-- Generate struts-config.xml file --%>
<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE struts-config PUBLIC "-//Apache Software Foundation//DTD Struts Configuration 1.1//EN" "http://jakarta.apache.org/struts/dtds/struts-config_1_1.dtd">

<struts-config>
    <!-- <%startUserCode%> for top part -->
    <!-- <%endUserCode%> for top part -->
    
    <!-- ========== Global Exceptions Definitions ================================== -->
	<global-exceptions>
	  <exception 
	    key="error.database.failure"
        path="/error.jsp"
        scope="request"
        type="fr.obeo.dao.exception.DaoException" />

	</global-exceptions>

	<!-- ========== Action Mapping Definitions =============================== -->
    <action-mappings >
		<action path="/Navigation" scope="request" forward=".view.Navigation" validate="false"/>
  		<!-- <%startUserCode%> for action mappings -->
    	<!-- <%endUserCode%> for action mappings -->
	</action-mappings>
	
	<!-- ========== Controller Config Definitions =============================== -->
    <!-- <%startUserCode%> for controller -->
    <!-- <%endUserCode%> for controller -->
	
	<!-- ========== Message Resources Definitions =========================== -->

  	<message-resources parameter="<%uiPackage%>.<%projectName.firstUpper()%>Resources" null="false"/>

	<plug-in className="org.apache.struts.tiles.TilesPlugin">
		<set-property property="definitions-config" value="/WEB-INF/conf/tiles-defs/tiles-defs.xml,<%for (eAllContents("Package")[cinematicPackage].sep(",")) {%>/WEB-INF/conf/tiles-defs/tiles-defs-<%name%>.xml<%}%>"/>
	</plug-in>

	<plug-in className="org.apache.struts.validator.ValidatorPlugIn">
		<set-property property="pathnames"	value="/WEB-INF/conf/validation/validator-rules.xml,<%for (eAllContents("Package")[cinematicPackage].sep(",")) {%>/WEB-INF/conf/validation/validation-<%name%>.xml<%}%>"/>
		<set-property property="stopOnFirstError" value="false"/>
	</plug-in>

    <!-- <%startUserCode%> for bottom part -->
    <!-- <%endUserCode%> for bottom part -->


</struts-config>
<%script type="Package" name="cinematicPackage"%>
<%eContents().filter("Class")[hasStereotype(getProperty("Screen"))].nSize() > 0%>