package org.acceleo.sample.demo.spring.services.impl;

import org.acceleo.sample.demo.spring.entities.Product;


import org.acceleo.sample.demo.spring.services.IProductsServices;
import org.acceleo.sample.demo.spring.services.IProductsServicesWebService;

import org.sharengo.exceptions.TechnicalException;

// Start of user code for import
import java.util.Collection;

// End of user code for import

public class MockProductsServicesWebService implements IProductsServices {
	IProductsServicesWebService productsServicesWebService = null;
		
	public MockProductsServicesWebService(IProductsServicesWebService process) {
		this.productsServicesWebService=process;
	}	

	
	/**
	 * 
	 * @param product 
	 */
public void removeProduct(Product product) throws TechnicalException{
		throw new UnsupportedOperationException("WebService Mock cannot support non remote operation");
}
	/**
	 * 
	 * @param product 
	 */
public void updateProduct(Product product) throws TechnicalException{
		throw new UnsupportedOperationException("WebService Mock cannot support non remote operation");
}
	/**
	 * 
	 * @return 
	 */
public Collection<Product> getListOfProducts() throws TechnicalException{
		throw new UnsupportedOperationException("WebService Mock cannot support non remote operation");
}
	/**
	 * 
	 * @param product 
	 * @return 
	 */
public Product addProduct(Product product) throws TechnicalException{
		return productsServicesWebService.addProduct(product);
}
	/**
	 * 
	 * @param id 
	 * @return 
	 */
public Product getProduct(String id) throws TechnicalException{
		return productsServicesWebService.getProduct(id);
}	
	
}