<%--
  Copyright  2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Yann Mortier
--%>

<%--
 - Generates imports.
 --%>

<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.EObjects
import org.acceleo.module.pim.uml21.services.Strings
import org.acceleo.module.pim.uml21.services.Operations
%>



<%--
 - Main script.
 --%>
<%script type="Model" name="fullFilePath"%>
<%getRootContainer().name%>/common/common.php5

<%script type="Model" name="generate" file="<%fullFilePath%>"%>
<?php
/**
* define configurations
* @package <%if (name != null) {%><%name%><%}else{%><default><%}%>  
*/
	/**
	* include global configuration
	*/
	require_once("config.php5");
	
	/**
	* PEAR log.
	*/
	require_once("Log.php");
	
	/**
	* PEAR DB
	*/
	require_once("DB.php");

	/**
	* include file for Smarty
	*/
  	require_once('smarty/Smarty.class.php');  
  	
  	/**
  	* other imports
  	*/
  	require_once("../entity/IEntity.php5");
  		/**
  	* other imports
  	*/
	require_once("../entity/Entity.php5");
		/**
  	* other imports
  	*/
	require_once("../dao/Connection.php5");

	
<%for (eAllContents("Class")){%>
	<%if (hasStereotype("Dto") || hasStereotype("Entity")){%>
	/**
	* include files for business class and controlers
	*/ 
	require_once("../entity/<%package.name%>/<%name.toU1Case()%>.php5");
	/**
	* include files for business class and controlers
	*/ 
	require_once("../entity/<%package.name%>/<%name.toU1Case()%>Factory.php5");
	/**
	* include files for business class and controlers
	*/ 
	require_once("../entity/<%package.name%>/proxy/<%name.toU1Case()%>Proxy.php5");
	<%}%>
	<%if (hasStereotype("Entity")) {%>
	/**
	* include <%name%>
	*/
	require_once("../dao/<%package.name%>/<%name.toU1Case()%>Dao.php5");
	<%}%>
	<%if (hasStereotype("Screen")) {%>
	/**
	* include <%name%>
	*/
	require_once("../navigation/controler/<%package.name%>/<%name.toU1Case()%>Ctrl.php5");
	<%}%>
	
<%}%>	

	
?>