<%--
  Copyright  2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Obeo - Yann Mortier
--%>

<%--
 - Generates configuration file.
 --%>
<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.EObjects
import org.acceleo.module.pim.uml21.services.Strings
import org.acceleo.module.pim.uml21.services.Operations
import org.acceleo.module.pim.uml21.gen.php.common.phpdoc
%>

<%--
 - Main script.
 --%>
<%script type="Model" name="fullFilePath"%>
<%getRootContainer().name%>/common/config.php5

<%script type="Model" name="generate" file="<%fullFilePath%>"%>
<?php
/**
* @package <%if (name != null) {%><%name%><%}else{%><default><%}%>
*/

/**
 *	Class Config    
 *  Dynamic configuration manager 
 * @author tmp
 * @version $Id$
 * @package <%if (name != null) {%><%name%><%}else{%><default><%}%>
 * 
 */
class Config {
	
	private $dsn;					// DSN of database.
	private $dbtype;
	private $dbhost;
	private $dbname;
	private $dbuser;
	private $dbpwd;
	
	private $defaultCtrl;			// default controller
	
	public function __construct() {
		// <%startUserCode%> for configuration
		$this->dbhost = "localhost";
		$this->dbtype = "mysqli";
		$this->dbname = "MDA";
		$this->dbuser = "root";
		$this->dbpwd = "";
		$this->defaultCtrl = "<%--eAllContents("Class").select("hasStereotype('Screen')").nGet(0).name--%>Ctrl";
		// <%endUserCode%> configuration
		$this->dsn = $this->dbtype . "://" . $this->dbuser . ":" . $this->dbpwd . "@" . $this->dbhost . "/" . $this->dbname;
		
		
	}
	
	/**
	 * Returns DSN.
	 * @return string $dsn {@link dsn $this->dsn}
	 */
	public function getDsn() {
		return $this->dsn;
	}
	
	/**
	 * Returns default controller.
	 * @return Smarty $defaultCtrl  the {@link defaultCtrl default} app controler
	 */
	public function getDefaultCtrl() {
		return $this->defaultCtrl;
	}
}
?>