<%--
  Copyright  2007 Pierre Alain Bourdil
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Pierre Alain Bourdil
--%>

<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.EObjects
import org.acceleo.module.pim.uml21.services.Strings
import org.acceleo.module.pim.uml21.services.Operations
%>

<%script type="Class" name="parentClassFile"%>
<%if (superClass.nSize()==1){%>
require_once(dirname(__FILE__).'/<%general.name%>.php5');
<%}else{%>
require_once(dirname(__FILE__).'/../Entity.php5');
<%}%>

<%script type="Class" name="ancestorConstructorParameters"%>
<%for (getAncestor()) {%>
		<%for getProperties.filter("Property") {%><%if visibility != "private"{%>,$<%name%> = null<%}%><%}%>
<%}%>

<%script type="Class" name="constructorParameters"%>
<%for (getAncestor()) {%>
		<%for getProperties.filter("Property") {%><%if visibility != "private"{%>,$<%name%> = null<%}%><%}%>
<%}%>

<%script type="Class" name="ancestorConstructorCall"%>
<%for (getAncestor()) {%>
		<%for getProperties.filter("Property") {%><%if visibility != "private"{%>,$<%name%><%}%><%}%>
<%}%>


<%script type="Class" name="ancestorIdGetterSetter"%>
<%for (getAncestor()) {%> 
	/**
	* foreign key on <%name%>
	* @var integer
	*/
	protected $<%name.toL1Case()%>Id;
	/**
	 * Return <%name%>Id value.
	 *
	 * @return integer $<%name%>Id {@link <%name%> <%name%>} <%ownedComment.body%>
	 */
	public function get<%name.toU1Case()%>Id(){
		return $this-><%name.toL1Case()%>Id;
	}

	/**
	 * Setting of <%name%>Id value.
	 *
	 * @param integer $<%name%>Id {@link <%name%> <%name%>} <%ownedComment.body%>
	 */
	public function set<%name.toU1Case()%>Id($<%name.toL1Case()%>Id) {
	 	$this-><%name.toL1Case()%>Id=$<%name.toL1Case()%>Id;
	}
<%}%>

<%script type="Property" name="getId"%>
<%if inverse().type.name.equalsIgnoreCase(args(0).name){%>getId()<%}else{%>get<%inverse().type.name.toU1Case%>Id()<%}%>

<%script type="Class" name="ancestorId"%>
" SET <%name.toUpperCase()%>_ID = '". <%name%>- . "', " .

<%script type="Property" name="phpType"%>
<%if args(0)=="String" {%>
	"<%args(1)%>"
<%}else{%>
<%if args(0)=="Enumeration" {%>
	1
<%}else{%>
	1
<%}%> 
<%}%>

<%script type="Class" name="relationParameters"%>
<%for getProperties().filter("Property")[association.memberEnd.nGet(1).aggregation=="shared"]{%>
,$<%type.name.toL1Case()%>=null <%}%>

<%script type="uml.NamedElement" name="instanciateClass"%>
<%-- make a constructor call --%>
$str="";
for($i=0;$i<count(<%args(1)%>);$i++){
	$str.='<%args(1)%>['.$i.'],';
}
$str=substr($str,0,-1);
if($str==''){
	eval('$<%args(0).toL1Case()%>'<%if args(2) != null {%>."_<%args(2)%>"<%}%>.'=new <%args(3)%>();');
}else{
	eval('$<%args(0).toL1Case()%>'<%if args(2) != null {%>."_<%args(2)%>"<%}%>.'=new <%args(3)%>('.$str.');');
}

<%script type="uml.Class" name="getAncestor"%>
<%(superClass + superClass.getAncestor())%>
