<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.EObjects
%>

<%script type="uml.Model" name="filePath"%>
<%name%>/dao/DaoFactory.php5

<%script type="uml.Model" name="generate" file="<%filePath%>" post="trim()"%>
<?php

/**
 * @package dao
 */

class DaoFactory {

	/**
	 * Create a DAO for the specified entity.
	 */
	public function createDaoFromEntity($entity) {
		$refObject = new ReflectionObject($entity);
		return $this->createDaoFromClass($refObject);
	}
	
	/**
	 * Create a DAO for the specified entity.
	 */
	public function createDaoFromClass($entityClass) {
		<%for (eAllContents("uml.Class")[hasStereotype("Entity")]) {%>
		if ("<%name%>" == $entityClass->getName()) {
			return new <%name%>Dao();
		}
		<%}%>
	}
}

?>


