<%--
  Copyright  2007 Obeo
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the Eclipse Public License 1.0
  
  You can apply any license to the files generated with this template
  and Acceleo.
  
  Original contributor : Pierre Alain Bourdil
--%>

<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.EObjects
import org.acceleo.module.pim.uml21.services.Strings
import org.acceleo.module.pim.uml21.services.Operations
import org.acceleo.module.pim.uml21.gen.php.common.static
import org.acceleo.module.pim.uml21.gen.php.common.lib
%>

<%script type="uml.Property" name="entity_base_getter_setter"%>
	
	/**
	 * Return <%name%> value.
	 *
<%if type.eClass().name == "Enumeration"{%>
	 * @return <%type.name%>EnumerationDao $<%name%>EnumerationLiteral {@link <%name%>EnumerationDao <%name%>EnumerationDao} <%ownedComment.body%>
<%}else{%>
	 * @return <%type.name%> $<%name%> {@link <%name%> <%name%>} <%ownedComment.body%><%}%>
	 */
	public <%setStatic%> function get<%name.toU1Case()%>(){
		//<%startUserCode%> get<%name.toU1Case()%>()
		//<%endUserCode%> get<%name.toU1Case()%>()
		return <%preventStatic%>;
	}

	/**
	 * Setting of <%name%> value.
	 *
<%if type.eClass().name == "Enumeration"{%>
	* @param <%type.name%>EnumerationDao $<%name%>EnumerationLiteral {@link <%name%>EnumerationDao <%name%>EnumerationDao} <%ownedComment.body%>
<%}else{%>
	 * @param <%type.name%> $<%name%> {@link <%name%> <%name%>} <%ownedComment.body%><%}%>
	 */
<%if type.eClass().name == "Enumeration"{%>
	<%if (!isReadOnly()) {%>public<%}else{%>protected<%}%> <%setStatic%> function set<%name.toU1Case()%>($<%name%>EnumerationLiteral) {
		<%preventStatic%>=$<%name%>EnumerationLiteral;
<%}else{%>
	<%if (!isReadOnly()) {%>public<%}else{%>protected<%}%> <%setStatic%> function set<%name.toU1Case()%>($<%name%>) {
	 	<%preventStatic%>=<%if (type.filter("PrimitiveType") != null){%>(<%type.name%>)<%}%>$<%name%>;
<%}%>
	 	//<%startUserCode%> set<%name.toU1Case()%>()
		//<%endUserCode%> set<%name.toU1Case()%>()
	}
	
<%if (upper != 1){%>
	<%-- Ajout dans la collection --%>
	/**
	 * Add a <%type.name%> inside <%name%>.
	 *
	 * @param <%type.name%> $<%type.name.toL1Case()%> {@link <%name%> <%name%>} 
	 */
	public <%setStatic%> function add<%name.toU1Case()%>($<%type.name.toL1Case()%>) {
		if(!is_array(<%preventStatic%>)){	
			<%preventStatic%>=array();
		}
		array_push(<%preventStatic%>, $<%type.name.toL1Case()%>);
		//<%startUserCode%> add<%name.toU1Case()%>()
		//<%endUserCode%> add<%name.toU1Case()%>()
	}
	<%-- Compte le nombre d'�l�ments dans la collection. --%>
	/**
	 * Return the number of <%type.name%> in <%name%>.
	 *
	 * @return number $count number of <%type.name%> in {@link <%name%> <%name%>}    
	 */
	public <%setStatic%> function getSizeOf<%name.toU1Case()%>() {
		//<%startUserCode%> getSizeOf()
		//<%endUserCode%> getSizeOf()
		return count(<%preventStatic%>);
	}
	
	<%-- Return an element. i() --%>
	/**
	 * Return an element <%type.name%> of <%name%>
	 * @return <%type.name%> $<%type.name%> <%ownedComment.body%>
	 */
	public  function get<%name.toU1Case()%>At($i) {
		//<%startUserCode%> get<%name.toU1Case()%>At()
		//<%endUserCode%> get<%name.toU1Case()%>At()
		return <%preventStatic%>[$i];
	}
<%}%>


<%script type="uml.Property" name="test_entity_base_getter_setter"%>
<%if (!isReadOnly()){%> function testSet<%name.toU1Case()%>() {
	<%if type.filter("PrimitiveType") != null {%>
			
				<%instanciateClass(eContainer().name,"$this->_fixture[\"__constructParams\"][0]",null,eContainer().name)%>
				$tmp=<%phpType(type.name,name).trim()%>;
				$<%eContainer().name.toL1Case()%>->set<%name.toU1Case()%>($tmp);
	 			$this->assertSame($tmp,$<%eContainer().name.toL1Case()%>-><%name.toL1Case()%>);
	<%}%>
	<%if type.filter("Enumeration") != null {%>
			
				<%instanciateClass(eContainer().name,"$this->_fixture[\"__constructParams\"][0]",null,eContainer().name)%>
				$tmp=<%phpType("Enumeration",name).trim()%>;
				$<%eContainer().name.toL1Case()%>->set<%name.toU1Case()%>($tmp);
	 			$this->assertAttributeSame($tmp,"<%name%>",$<%eContainer().name.toL1Case()%>);
	<%}else{%>
	<%if type.filter("PrimitiveType") == null{%>
			
				<%instanciateClass(inverse().type.name,"$this->_fixture[\"__constructParams\"][0]",null,inverse().type.name)%>
				<%instanciateClass(name,"$this->_fixture[\""+name+"__p\"][0]",null,type.name)%>
				$<%inverse().type.name.toL1Case()%>->set<%name.toU1Case()%>($<%name.toL1Case()%>);
					
				$this->assertSame($<%name.toL1Case()%>,"<%name%>",$<%inverse().type.name.toL1Case()%>);
	<%}%>	
	<%}%>
	  		//<%startUserCode%> testSet<%name%>
			//<%endUserCode%> testSet<%name%>
		}
<%}%>
	function testGet<%name.toU1Case()%>(){
	<%if type.filter("PrimitiveType") != null {%>
			
				<%instanciateClass(eContainer().name,"$this->_fixture[\"__constructParams\"][0]",null,eContainer().name)%>
				$tmp=<%phpType(type.name,name).trim()%>;
				$<%eContainer().name.toL1Case()%>->set<%name.toU1Case()%>($tmp);
				$tmp=$<%eContainer().name.toL1Case()%>->get<%name.toU1Case()%>();
	 			$this->assertSame($tmp,$<%eContainer().name.toL1Case()%>-><%name.toL1Case()%>);
	<%}%>
	<%if type.filter("Enumeration") != null {%>
			
				<%instanciateClass(eContainer().name,"$this->_fixture[\"__constructParams\"][0]",null,eContainer().name)%>
				$tmp=<%phpType("Enumeration",name).trim()%>;
				$<%eContainer().name.toL1Case()%>->set<%name.toU1Case()%>($tmp);
	 			$this->assertAttributeSame($tmp,"<%name%>",$<%eContainer().name.toL1Case()%>);
	<%}else{%>
	<%if type.filter("PrimitiveType") == null{%>
			
				<%instanciateClass(inverse().type.name,"$this->_fixture[\"__constructParams\"][0]",null,inverse().type.name)%>
				<%instanciateClass(name,"$this->_fixture[\""+name+"__p\"][0]",null,type.name)%>
				$<%inverse().type.name.toL1Case()%>->set<%name.toU1Case()%>($<%name.toL1Case()%>);
				$tmp=$<%inverse().type.name.toL1Case()%>->get<%name.toU1Case()%>();
				$this->assertAttributeSame($tmp,"<%name%>",$<%inverse().type.name.toL1Case()%>);
	<%}%>
	<%}%>
	  		//<%startUserCode%> testGet<%name%>
			//<%endUserCode%> testGet<%name%>
		}

