<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML
import org.acceleo.module.pim.uml21.services.EObjects
import org.acceleo.module.pim.uml21.services.Strings
import org.acceleo.module.pim.uml21.services.Operations
%>

<%script type="Class" name="fullFilePath"%>
<%if (hasStereotype("Screen")){%>
/ui/<%name%>Form.php5
<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
<?php

class <%name%>Form extends ActionForm {

	// ----- Instance Variables --------------------------------------------- //
	var $pmr = NULL;
	var $locale = NULL;
	
<%for (attribute){%>
	<%if (!hasStereotype("title")) {%>
	var $<%name%>;
	<%}%>
<%}%>
	
	// ----- Constructor ---------------------------------------------------- //
	function <%name%>Form() {
	
		$config = 'MyAppResources';
		$returnNull = False;
		$defaultLocale =& new Locale();
		$factory = NULL;
		$pmr =& new PropertyMessageResources($factory, $config, $returnNull);
		$pmr->setDefaultLocale($defaultLocale);
		$this->pmr = $pmr;
	}
	
	<%-- getters and setters generation --%>
	// ----- Form Properties ------------------------------------------------ //
<%for (attribute){%>
	<%if (!hasStereotype("title")) {%>
	/**
	 * Return <%name%>
	 * @return <%ownedComment.body%>
	 */
	 function get<%name.toU1Case()%>() {
		return $this-><%name%>;
	}
	
	/**
	 * Set a value to parameter <%name%>.
	 * @param <%name%> <%ownedComment.body%>
	 */
	 function set<%name.toU1Case()%>($<%name%>) {
		$this-><%name%> = $<%name%>;
	}
	<%}%>
<%}%>
	
	// ----- Public Methods ------------------------------------------------- //
	
	function reset(&$mapping, &$request) {
		 parent::reset($mapping, $request);
		 // <%startUserCode%> of reset
		 // <%endUserCode%>
	}
	
	function validate(&$mapping, &$request) {
		$actionErrors =& new ActionErrors();
		
<%for (attribute){%>
	<%if (!hasStereotype("title")) {%>
		$<%name%> = $request->getParameter('<%name%>');
	<%}%>
<%}%>
		// <%startUserCode%> of form verification
		// <%endUserCode%> of form verification

		if($actionErrors->isEmpty() == False) {
<%for (attribute){%>
	<%if (!hasStereotype("title")) {%>
			$this->set<%name.toU1Case()%>($<%name%>);
	<%}%>
<%}%>
			//$this->setUserRole($request->getParameter('urole'));
		}

		$request->setAttribute( 'ACTION_FORM', $this );
		
		return $actionErrors;
	}

}
?>
