<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.EObjects
import org.acceleo.module.pim.uml21.services.Strings
import org.acceleo.module.pim.uml21.services.Operations
%>

<%--
	Gnre les fichiers contrleurs !
--%>

<%script type="Class" name="fullFilePath"%>
<%-- Only Classes with stereotype Screen--%>
<%if (hasStereotype("Screen")){%>
navigation/controler/<%package.name%>/<%name.toU1Case()%>Ctrl.php5
<%}%>

<%script type="Class" name="generate" file="<%fullFilePath%>"%>
<?php
class <%name.toU1Case()%>Ctrl extends Smarty {

	<%-- Labels de la page--%>
<%for (attribute) {%>
	// Widget <%stereotype()%> <%name%><%if (type){%> with type <%type.name%><%}%>.
	<%if (ownedComment){%>
	// <%ownedComment.body%>
	<%}%>
	protected $<%name.toL1Case()%>;
		
<%}%>

	/** Le logger */
	private $logger;

	/**
	 * Constroler constructor, initialize widgets.
	 *
	 */
	public function __construct() {
<%for (attribute){%>
		<%if (type == null || type.filter("PrimitiveType")!=null) {%>
		$this-><%name.toL1Case()%> = "variable <%name%> (<%ownedComment.body%>)";
		<%}else if (!type.hasStereotype("Screen")){%>
		$this-><%name.toL1Case()%> = array();
		<%}%>
<%}%>
		$this->logger =& Log::singleton('file', '../log/controler.log', '<%name%>Ctrl.class');
	}

<%--
	Operations :
--%>

	/**
	 * This function initialize the controler.
	 */
	protected function init() {
		// <%startUserCode%> __init
		$this->logger->log('executing init action ...', PEAR_LOG_DEBUG);
		
		// TODO action code for <%name%> controler init.



		$this->assign_smarty();
		$this->display("<%package.name%>/<%name%>.tpl");
		
		// <%endUserCode%> __init
	}

	<%-- Getters des labels. --%>
	// Getters
<%for (attribute) {%>
	/**
	 * Return <%name%>
	 *
	 * @return <%ownedComment.body%>
	 */
	public function get<%name.toU1Case()%>() {
		return $this-><%name.toL1Case()%>;
	}
	
	<%if (type.hasStereotype("Entity")) {%>
	
	public function getSelected<%name.toU1Case()%>() {
		$checked = $_POST['b<%type.name%>'];
		if (!is_array($checked)) {
			$checked = array($checked);
		}
		$values = array();
		$connection = new Connection();
		$<%type.name.toL1Case()%>Dao = new <%type.name%>Dao();
		$<%type.name.toL1Case()%>Factory = new <%type.name%>Factory();
		$connection->open();
		foreach ($checked as $currentId) {
			$<%type.name.toL1Case()%> = $<%type.name.toL1Case()%>Factory->create<%type.name%>($currentId);
			$<%type.name.toL1Case()%> = $<%type.name.toL1Case()%>Dao->findById($connection, $<%type.name.toL1Case()%>);
			array_push($values, $<%type.name.toL1Case()%>);
		}
		$connection->close();
		return $values;
	}
	
	<%}%>
	
<%}%>
	
	// Events : 

<%for (ownedOperation){%>
	/**
	 * Action : <%name%>
	 *
	 * <%ownedComment.body%>
	 */
	protected function <%name%>() {
		$connection = new Connection(false);
		// <%startUserCode%> <%name%>
		$this->logger->log('executing <%name%> action ...', PEAR_LOG_DEBUG);
		// TODO Ecrivez ici le code de l'action.

<%if (returnResult != null){%>
<%if (returnResult.type.name!=class.name){%>
		forward("<%returnResult.type.name.toU1Case()%>Ctrl");
<%}else{%>
		$this->assign_smarty();
		$this->display('<%returnResult.type.package.name%>/<%returnResult.type.name%>.tpl');
<%}%><%}%>
		// <%endUserCode%> <%name%>
	}
<%}%>

<%--
	Branchements :
--%>
	
	/**
	 * Manage the request, event dispatcher.
	 */
	public function execute() {
		// Form's values
		<%for (attribute.select("association == null && !hasStereotype('Label')")){%>
		if (isset($_POST['<%name%>'])) {
			$this-><%name.toL1Case()%> = addslashes($_POST['<%name%>']);
		}
		<%}%>
	
		if (!isset($_POST['event'])) {
			$this->init();
		} 
<%for (ownedOperation){%>
		elseif ("<%name%>" == $_POST['event']) {
			$this-><%name%>();
		}<%}%>
		else {
			$this->init();
		}
	}	
	/**
	 * Smarty Assignments
	 */
	public function assign_smarty() {
		// <%startUserCode%> smarty
		parent::Smarty();
      	$this->template_dir = 'view/';
      	$this->compile_dir = 'C:/Program Files/xampp/php/pear/libs/smart_docs/templates_c';
      	$this->config_dir = 'C:/Program Files/xampp/php/pear/libs/smart_docs/configs/';
     	$this->cache_dir = 'C:/Program Files/xampp/php/pear/libs/smart_docs/cache/';
<%for (getProperties()){%>
	<%if (association==null){%>
		<%if (hasStereotype("Label")){%>
			<%if (type.filter("Class") != null && type.hasStereotype("Entity")){%>
		// <%startUserCode%> smarty_label_content_<%name%>
		$this->assign('<%name%>s', $this-><%name.toL1Case()%>);
		$this->assign('use<%type.name%>Chk', false);
		$this->assign('use<%type.name%>Radio', false);
		// <%endUserCode%> smarty_label_content_<%name%>
			<%}else{%>
		// <%startUserCode%> smarty_label_content_<%name%>
		$this->assign('label_content_<%name%>', "<%name%> : <%ownedComment.body%>");
		// <%endUserCode%> smarty_label_content_<%name%>
			<%}%>
		<%}else{%>
		// <%startUserCode%> smarty_entry_desc_<%name%>
		$this->assign('entry_desc_<%name%>', "<%name%> : <%ownedComment.body%>");
		$this->assign('<%name%>_value', $this->get<%name.toU1Case()%>());
		// <%endUserCode%> smarty_entry_desc_<%name%>
		<%}%>
	<%}else{%>
		// <%startUserCode%> smarty_link_<%name%>
		$this->assign('link_<%name%>', "<i><%name%></i> : <%ownedComment.body%>");
		// <%endUserCode%> smarty_link_<%name%>
	<%}%>
<%}%>
<%for (ownedOperation){%>
		// <%startUserCode%> smarty_op_<%name.toL1Case()%>
		$this->assign('op_<%name.toL1Case()%>', "<%name%>");
		// <%endUserCode%> smarty_op_<%name.toL1Case()%>
<%}%>
		// <%startUserCode%> smarty_page_title
		$this->assign('page_title', "<%name%>");
		// <%endUserCode%> smarty_page_title
		
	}
}
?>