<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.acceleo.module.pim.uml21.services.EObjects
import org.acceleo.module.pim.uml21.services.Strings
import org.acceleo.module.pim.uml21.services.Operations
%>

<%--
 - Generates the main controller for MVC2.	
 --%>

<%--
 - Main script.
 --%>
<%script type="Model" name="generate" file="navigation/index.php5"%>
<?php

	include("../common/common.php5");
	
	session_start();

	if( isset($_GET['ctrl'])) {
		$ctrl = $_GET['ctrl'];
	} else {
		$config = new Config();
		$ctrl = $config->getDefaultCtrl();
	}	
	forward($ctrl);
		
	/** 
	 * Redirect request to controler
	 */
	function forward($ctrlName) {
		$control = getCtrlForName($ctrlName);
		// enregistrement du controleur.
		$_SESSIONS['control']=$control;
		// dispatch la requte.
		$control->execute();
	}
	
	/**
	 * Return controler found by its name
	 */
	function getCtrlForName($name) {
		global $db;
		switch($name) {
<%for (eAllContents("Class").select("hasStereotype('Screen')")) {%>
		case "<%name.toU1Case()%>Ctrl":
			return new <%name.toU1Case()%>Ctrl($db);
<%}%>
		}
	}
	
?>