package org.acceleo.module.pim.uml21.services;

import java.util.Arrays;

import fr.obeo.acceleo.gen.template.eval.ENodeCastException;
import fr.obeo.acceleo.tools.log.Trace;

public class Strings {

	public Strings() {
		Trace.TRACE = true;
	}

	public static char[] voyelles = { 'a', 'e', 'i', 'o', 'u', 'y' };
	static {
		Arrays.sort(voyelles);
	}

	public String toPluriel(String string) {
		if (string.endsWith("y") && string.length() >= 2) {
			char toTest = string.charAt(string.length() - 2);
			if (Arrays.binarySearch(voyelles, toTest) < 0) {
				return string.substring(0, string.length() - 2) + "ies";
			}
		}
		return string + "s";
	}

	public String replaceAll(String text, String arg1, String arg2)
			throws ENodeCastException {
		return text.replaceAll(arg1, arg2);
	}

	public String toPath(String packageName) throws ENodeCastException {
		return packageName.trim().replaceAll("\\.", "/");
	}

	public int hashCode(String s) {
		return s.hashCode();
	}

}
