package org.acceleo.module.pim.uml21.services;

import org.eclipse.uml2.uml.Class;

/**
 * Services for the UML2 meta model.
 * 
 * @author ymortier
 */
public class UmlServices {

	public Class getSuperClassOfHierarchy(Class subClass) {
		Class result = subClass;
		while (!result.getGenerals().isEmpty()) {
			result = (Class) result.getGenerals().get(0);
		}
		return result;
	}

}
