SET FOREIGN_KEY_CHECKS=0 ;

CREATE TABLE wisss_dto (
	`__id` INT(11) UNSIGNED AUTO_INCREMENT PRIMARY KEY
) ENGINE=InnoDB DEFAULT CHARSET=latin1;;

CREATE TABLE testmodule_a (
	`atta` VARCHAR(255) UNIQUE ,
	`roleb_in_asso_1_1` INT(11) UNSIGNED, FOREIGN KEY (`roleb_in_asso_1_1`) REFERENCES `testmodule_b`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`roleb_in_asso_1_1_wa` INT(11) UNSIGNED, FOREIGN KEY (`roleb_in_asso_1_1_wa`) REFERENCES `testmodule_b`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`rolebc_in_asso_11_11_11` INT(11) UNSIGNED, FOREIGN KEY (`rolebc_in_asso_11_11_11`) REFERENCES `testmodule_asso_11_11_11`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`rolebc_in_asso_n1_n1_n1` INT(11) UNSIGNED, FOREIGN KEY (`rolebc_in_asso_n1_n1_n1`) REFERENCES `testmodule_asso_n1_n1_n1`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`rolebc_in_asso_11_11_1n` INT(11) UNSIGNED, FOREIGN KEY (`rolebc_in_asso_11_11_1n`) REFERENCES `testmodule_asso_11_11_1n`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`rolebc_in_asso_11_11_n1` INT(11) UNSIGNED, FOREIGN KEY (`rolebc_in_asso_11_11_n1`) REFERENCES `testmodule_asso_11_11_n1`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`rolebc_in_asso_11_11_nn` INT(11) UNSIGNED, FOREIGN KEY (`rolebc_in_asso_11_11_nn`) REFERENCES `testmodule_asso_11_11_nn`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`rolebc_in_asso_n1_n1_11` INT(11) UNSIGNED, FOREIGN KEY (`rolebc_in_asso_n1_n1_11`) REFERENCES `testmodule_asso_n1_n1_11`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`rolebc_in_asso_n1_n1_1n` INT(11) UNSIGNED, FOREIGN KEY (`rolebc_in_asso_n1_n1_1n`) REFERENCES `testmodule_asso_n1_n1_1n`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`rolebc_in_asso_n1_n1_nn` INT(11) UNSIGNED, FOREIGN KEY (`rolebc_in_asso_n1_n1_nn`) REFERENCES `testmodule_asso_n1_n1_nn`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`rolebc_in_asso_11_1n_n1` INT(11) UNSIGNED, FOREIGN KEY (`rolebc_in_asso_11_1n_n1`) REFERENCES `testmodule_asso_11_1n_n1`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`rolebc_in_asso_11_1n_nn` INT(11) UNSIGNED, FOREIGN KEY (`rolebc_in_asso_11_1n_nn`) REFERENCES `testmodule_asso_11_1n_nn`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`rolebc_in_asso_11_n1_nn` INT(11) UNSIGNED, FOREIGN KEY (`rolebc_in_asso_11_n1_nn`) REFERENCES `testmodule_asso_11_n1_nn`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`__subclass` VARCHAR(255),
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_b (
	`attb` BIGINT  NOT NULL,
	`rolea_in_asso_1_n` INT(11) UNSIGNED, FOREIGN KEY (`rolea_in_asso_1_n`) REFERENCES `testmodule_a`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`rolea_in_compo_1_1` INT(11) UNSIGNED, FOREIGN KEY (`rolea_in_compo_1_1`) REFERENCES `testmodule_a`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`rolea_in_compo_1_n` INT(11) UNSIGNED, FOREIGN KEY (`rolea_in_compo_1_n`) REFERENCES `testmodule_a`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`roleac_in_asso_n1_n1_n1` INT(11) UNSIGNED, FOREIGN KEY (`roleac_in_asso_n1_n1_n1`) REFERENCES `testmodule_asso_n1_n1_n1`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`roleac_in_asso_n1_n1_11` INT(11) UNSIGNED, FOREIGN KEY (`roleac_in_asso_n1_n1_11`) REFERENCES `testmodule_asso_n1_n1_11`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`roleac_in_asso_n1_n1_1n` INT(11) UNSIGNED, FOREIGN KEY (`roleac_in_asso_n1_n1_1n`) REFERENCES `testmodule_asso_n1_n1_1n`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`roleac_in_asso_n1_n1_nn` INT(11) UNSIGNED, FOREIGN KEY (`roleac_in_asso_n1_n1_nn`) REFERENCES `testmodule_asso_n1_n1_nn`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`roleac_in_asso_11_n1_nn` INT(11) UNSIGNED, FOREIGN KEY (`roleac_in_asso_11_n1_nn`) REFERENCES `testmodule_asso_11_n1_nn`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`roleac_in_asso_1n_n1_nn` INT(11) UNSIGNED, FOREIGN KEY (`roleac_in_asso_1n_n1_nn`) REFERENCES `testmodule_asso_1n_n1_nn`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_c (
	`attc` BLOB  ,
	`roleab_in_asso_n1_n1_n1` INT(11) UNSIGNED, FOREIGN KEY (`roleab_in_asso_n1_n1_n1`) REFERENCES `testmodule_asso_n1_n1_n1`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`roleab_in_asso_11_11_n1` INT(11) UNSIGNED, FOREIGN KEY (`roleab_in_asso_11_11_n1`) REFERENCES `testmodule_asso_11_11_n1`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`roleab_in_asso_1n_1n_n1` INT(11) UNSIGNED, FOREIGN KEY (`roleab_in_asso_1n_1n_n1`) REFERENCES `testmodule_asso_1n_1n_n1`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`roleab_in_asso_nn_nn_n1` INT(11) UNSIGNED, FOREIGN KEY (`roleab_in_asso_nn_nn_n1`) REFERENCES `testmodule_asso_nn_nn_n1`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`roleab_in_asso_11_1n_n1` INT(11) UNSIGNED, FOREIGN KEY (`roleab_in_asso_11_1n_n1`) REFERENCES `testmodule_asso_11_1n_n1`(`__id`) ON UPDATE CASCADE ON DELETE SET NULL,
	`__subclass` VARCHAR(255),
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_d (
	`attrd` DATETIME  ,
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `testmodule_a`(`__id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_e (
	`atte` BIGINT  ,
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `testmodule_c`(`__id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


CREATE TABLE testmodule_asso_n_n (
	`rolea_in_asso_n_n` INT(11) UNSIGNED , FOREIGN KEY (`rolea_in_asso_n_n`) REFERENCES `testmodule_a`(`__id`) ON DELETE CASCADE,
	`roleb_in_asso_n_n` INT(11) UNSIGNED , FOREIGN KEY (`roleb_in_asso_n_n`) REFERENCES `testmodule_b`(`__id`) ON DELETE CASCADE 	
	
	,UNIQUE (rolea_in_asso_n_n,roleb_in_asso_n_n)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_1_1_with_attributes (
	`rolea_in_asso_1_1_wa` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`rolea_in_asso_1_1_wa`) REFERENCES `testmodule_a`(`__id`) ON DELETE CASCADE,
	`roleb_in_asso_1_1_wa` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`roleb_in_asso_1_1_wa`) REFERENCES `testmodule_b`(`__id`) ON DELETE CASCADE ,	
	`attr` VARCHAR(255)  
	,UNIQUE (rolea_in_asso_1_1_wa,roleb_in_asso_1_1_wa)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_1_n_with_attributes (
	`rolea_in_asso_1_n_wa` INT(11) UNSIGNED , FOREIGN KEY (`rolea_in_asso_1_n_wa`) REFERENCES `testmodule_a`(`__id`) ON DELETE CASCADE,
	`roleb_in_asso_1_n_wa` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`roleb_in_asso_1_n_wa`) REFERENCES `testmodule_b`(`__id`) ON DELETE CASCADE ,	
	`attr` VARCHAR(255)  
	,UNIQUE (rolea_in_asso_1_n_wa,roleb_in_asso_1_n_wa)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_n_n_with_attributes (
	`rolea_in_asso_n_n_wa` INT(11) UNSIGNED , FOREIGN KEY (`rolea_in_asso_n_n_wa`) REFERENCES `testmodule_a`(`__id`) ON DELETE CASCADE,
	`roleb_in_asso_n_n_wa` INT(11) UNSIGNED , FOREIGN KEY (`roleb_in_asso_n_n_wa`) REFERENCES `testmodule_b`(`__id`) ON DELETE CASCADE ,	
	`attr` VARCHAR(255)  
	,UNIQUE (rolea_in_asso_n_n_wa,roleb_in_asso_n_n_wa)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


CREATE TABLE testmodule_asso_11_11_11 (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	,`rolea_in_asso_11_11_11` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`rolea_in_asso_11_11_11`) REFERENCES `testmodule_a`(`__id`) ON DELETE CASCADE
	,`roleb_in_asso_11_11_11` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`roleb_in_asso_11_11_11`) REFERENCES `testmodule_b`(`__id`) ON DELETE CASCADE
	,`rolec_in_asso_11_11_11` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`rolec_in_asso_11_11_11`) REFERENCES `testmodule_c`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_1n_1n_1n (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	,`rolea_in_asso_1n_1n_1n` INT(11) UNSIGNED , FOREIGN KEY (`rolea_in_asso_1n_1n_1n`) REFERENCES `testmodule_a`(`__id`) ON DELETE CASCADE
	,`roleb_in_asso_1n_1n_1n` INT(11) UNSIGNED , FOREIGN KEY (`roleb_in_asso_1n_1n_1n`) REFERENCES `testmodule_b`(`__id`) ON DELETE CASCADE
	,`rolec_in_asso_1n_1n_1n` INT(11) UNSIGNED , FOREIGN KEY (`rolec_in_asso_1n_1n_1n`) REFERENCES `testmodule_c`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_n1_n1_n1 (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_nn_nn_nn (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_11_11_1n (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	,`rolea_in_asso_11_11_1n` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`rolea_in_asso_11_11_1n`) REFERENCES `testmodule_a`(`__id`) ON DELETE CASCADE
	,`roleb_in_asso_11_11_1n` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`roleb_in_asso_11_11_1n`) REFERENCES `testmodule_b`(`__id`) ON DELETE CASCADE
	,`rolec_in_asso_11_11_1n` INT(11) UNSIGNED , FOREIGN KEY (`rolec_in_asso_11_11_1n`) REFERENCES `testmodule_c`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_11_11_n1 (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	,`rolea_in_asso_11_11_n1` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`rolea_in_asso_11_11_n1`) REFERENCES `testmodule_a`(`__id`) ON DELETE CASCADE
	,`roleb_in_asso_11_11_n1` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`roleb_in_asso_11_11_n1`) REFERENCES `testmodule_b`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_11_11_nn (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	,`rolea_in_asso_11_11_nn` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`rolea_in_asso_11_11_nn`) REFERENCES `testmodule_a`(`__id`) ON DELETE CASCADE
	,`roleb_in_asso_11_11_nn` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`roleb_in_asso_11_11_nn`) REFERENCES `testmodule_b`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_1n_1n_11 (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	,`rolea_in_asso_1n_1n_11` INT(11) UNSIGNED , FOREIGN KEY (`rolea_in_asso_1n_1n_11`) REFERENCES `testmodule_a`(`__id`) ON DELETE CASCADE
	,`roleb_in_asso_1n_1n_11` INT(11) UNSIGNED , FOREIGN KEY (`roleb_in_asso_1n_1n_11`) REFERENCES `testmodule_b`(`__id`) ON DELETE CASCADE
	,`rolec_in_asso_1n_1n_11` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`rolec_in_asso_1n_1n_11`) REFERENCES `testmodule_c`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_1n_1n_n1 (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	,`rolea_in_asso_1n_1n_n1` INT(11) UNSIGNED , FOREIGN KEY (`rolea_in_asso_1n_1n_n1`) REFERENCES `testmodule_a`(`__id`) ON DELETE CASCADE
	,`roleb_in_asso_1n_1n_n1` INT(11) UNSIGNED , FOREIGN KEY (`roleb_in_asso_1n_1n_n1`) REFERENCES `testmodule_b`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_1n_1n_nn (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	,`rolea_in_asso_1n_1n_nn` INT(11) UNSIGNED , FOREIGN KEY (`rolea_in_asso_1n_1n_nn`) REFERENCES `testmodule_a`(`__id`) ON DELETE CASCADE
	,`roleb_in_asso_1n_1n_nn` INT(11) UNSIGNED , FOREIGN KEY (`roleb_in_asso_1n_1n_nn`) REFERENCES `testmodule_b`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_n1_n1_11 (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	,`rolec_in_asso_n1_n1_11` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`rolec_in_asso_n1_n1_11`) REFERENCES `testmodule_c`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_n1_n1_1n (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	,`rolec_in_asso_n1_n1_1n` INT(11) UNSIGNED , FOREIGN KEY (`rolec_in_asso_n1_n1_1n`) REFERENCES `testmodule_c`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_n1_n1_nn (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_nn_nn_11 (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	,`rolec_in_asso_nn_nn_11` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`rolec_in_asso_nn_nn_11`) REFERENCES `testmodule_c`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_nn_nn_1n (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	,`rolec_in_asso_nn_nn_1n` INT(11) UNSIGNED , FOREIGN KEY (`rolec_in_asso_nn_nn_1n`) REFERENCES `testmodule_c`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_nn_nn_n1 (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_11_1n_n1 (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	,`rolea_in_asso_11_1n_n1` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`rolea_in_asso_11_1n_n1`) REFERENCES `testmodule_a`(`__id`) ON DELETE CASCADE
	,`roleb_in_asso_11_1n_n1` INT(11) UNSIGNED , FOREIGN KEY (`roleb_in_asso_11_1n_n1`) REFERENCES `testmodule_b`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_11_1n_nn (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	,`rolea_in_asso_11_1n_nn` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`rolea_in_asso_11_1n_nn`) REFERENCES `testmodule_a`(`__id`) ON DELETE CASCADE
	,`roleb_in_asso_11_1n_nn` INT(11) UNSIGNED , FOREIGN KEY (`roleb_in_asso_11_1n_nn`) REFERENCES `testmodule_b`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_11_n1_nn (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	,`rolea_in_asso_11_n1_nn` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`rolea_in_asso_11_n1_nn`) REFERENCES `testmodule_a`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_asso_1n_n1_nn (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	,`rolea_in_asso_1n_n1_nn` INT(11) UNSIGNED , FOREIGN KEY (`rolea_in_asso_1n_n1_nn`) REFERENCES `testmodule_a`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE testmodule_xasso (
	`__id` INT(11) UNSIGNED NOT NULL, FOREIGN KEY (`__id`) REFERENCES `wisss_dto`(`__id`) ON DELETE CASCADE
	,`rolea_in_xasso` INT(11) UNSIGNED , FOREIGN KEY (`rolea_in_xasso`) REFERENCES `testmodule_a`(`__id`) ON DELETE CASCADE
	,`roleb_in_xasso` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`roleb_in_xasso`) REFERENCES `testmodule_b`(`__id`) ON DELETE CASCADE
	,`rolec_in_xasso` INT(11) UNSIGNED  UNIQUE, FOREIGN KEY (`rolec_in_xasso`) REFERENCES `testmodule_c`(`__id`) ON DELETE CASCADE
	
	
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

SET FOREIGN_KEY_CHECKS=1 ;