<?php
/**
 * testmodule_Dto_Asso1111Nn
 * @package data.Module (name: test module)
 */
class testmodule_Dto_Asso1111Nn extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = 'Asso1111Nn';
    const MODULE_NAME = 'testmodule';
    
    /**
	 * @var testmodule_Dto_A
	 */
	protected $rolea_in_asso_11_11_nn ;
    /**
	 * @var testmodule_Dto_B
	 */
	protected $roleb_in_asso_11_11_nn ;
    /**
	 * @var testmodule_Dto_C
	 */
	protected $rolec_in_asso_11_11_nn ;
    
	
	/**
 * setRoleaInAsso1111Nn
 */
public function setRoleaInAsso1111Nn($rolea_in_asso_11_11_nn,$backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_11_11_nn)) {
		$this->rolea_in_asso_11_11_nn->unsetRolebcInAsso1111Nn(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_11_11_nn' ;
		$changes['old_value'] = $this->rolea_in_asso_11_11_nn ;
		$changes['operation'] = 'set' ;
	}
	$this->rolea_in_asso_11_11_nn = $rolea_in_asso_11_11_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_11_11_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->rolea_in_asso_11_11_nn->setRolebcInAsso1111Nn($this,false) ;
	}
}

	
	/**
	 * getRoleaInAsso1111Nn
	 */
	public function getRoleaInAsso1111Nn()
	{
		return $this->rolea_in_asso_11_11_nn ;
	}
	/**
 * setRolebInAsso1111Nn
 */
public function setRolebInAsso1111Nn($roleb_in_asso_11_11_nn,$backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_11_11_nn)) {
		$this->roleb_in_asso_11_11_nn->unsetRoleacInAsso1111Nn(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_11_11_nn' ;
		$changes['old_value'] = $this->roleb_in_asso_11_11_nn ;
		$changes['operation'] = 'set' ;
	}
	$this->roleb_in_asso_11_11_nn = $roleb_in_asso_11_11_nn ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_11_11_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->roleb_in_asso_11_11_nn->setRoleacInAsso1111Nn($this,false) ;
	}
}

	
	/**
	 * getRolebInAsso1111Nn
	 */
	public function getRolebInAsso1111Nn()
	{
		return $this->roleb_in_asso_11_11_nn ;
	}
	/**
 * setListOfRolecInAsso1111Nn
 */
public function setListOfRolecInAsso1111Nn($rolec_in_asso_11_11_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_11_11_nn)) {
		foreach($this->rolec_in_asso_11_11_nn as $item) {
			$item->removeRoleabInAsso1111Nn($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_11_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_11_11_nn ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolec_in_asso_11_11_nn = $rolec_in_asso_11_11_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_11_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolec_in_asso_11_11_nn as $item) {
			$item->addRoleabInAsso1111Nn($this,false) ;
		}
	}
}

/**
 * addRolecInAsso1111Nn
 */
public function addRolecInAsso1111Nn($rolec_in_asso_11_11_nn, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_11_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_11_11_nn ;
		$changes['operation'] = 'add' ;
	}
	$this->rolec_in_asso_11_11_nn[] = $rolec_in_asso_11_11_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_11_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolec_in_asso_11_11_nn->addRoleabInAsso1111Nn($this,false) ;
	}
}

/**
 * removeRolecInAsso1111Nn
 */
public function removeRolecInAsso1111Nn($rolec_in_asso_11_11_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_11_11_nn)) {
		$rolec_in_asso_11_11_nn->removeRoleabInAsso1111Nn($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_11_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_11_11_nn ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolec_in_asso_11_11_nn as $key=>$item) {
		if($item->__sameAs($rolec_in_asso_11_11_nn)) {
			unset($this->rolec_in_asso_11_11_nn[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_11_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolecInAsso1111Nn
 */
public function unsetRolecInAsso1111Nn($backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_11_11_nn)) {
		foreach($this->rolec_in_asso_11_11_nn as $item) {
			$item->removeRoleabInAsso1111Nn($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_11_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_11_11_nn ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolec_in_asso_11_11_nn = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_11_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolecInAsso1111Nn
	 */
	public function getRolecInAsso1111Nn()
	{
		return $this->rolec_in_asso_11_11_nn ;
	}
	
}