<?php
/**
 * testmodule_Dto_Asso111nNn
 * @package data.Module (name: test module)
 */
class testmodule_Dto_Asso111nNn extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = 'Asso111nNn';
    const MODULE_NAME = 'testmodule';
    
    /**
	 * @var testmodule_Dto_A
	 */
	protected $rolea_in_asso_11_1n_nn ;
    /**
	 * @var testmodule_Dto_B
	 */
	protected $roleb_in_asso_11_1n_nn ;
    /**
	 * @var testmodule_Dto_C
	 */
	protected $rolec_in_asso_11_1n_nn ;
    
	
	/**
 * setRoleaInAsso111nNn
 */
public function setRoleaInAsso111nNn($rolea_in_asso_11_1n_nn,$backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_11_1n_nn)) {
		$this->rolea_in_asso_11_1n_nn->unsetRolebcInAsso111nNn(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_11_1n_nn' ;
		$changes['old_value'] = $this->rolea_in_asso_11_1n_nn ;
		$changes['operation'] = 'set' ;
	}
	$this->rolea_in_asso_11_1n_nn = $rolea_in_asso_11_1n_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_11_1n_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->rolea_in_asso_11_1n_nn->setRolebcInAsso111nNn($this,false) ;
	}
}

	
	/**
	 * getRoleaInAsso111nNn
	 */
	public function getRoleaInAsso111nNn()
	{
		return $this->rolea_in_asso_11_1n_nn ;
	}
	/**
 * setRolebInAsso111nNn
 */
public function setRolebInAsso111nNn($roleb_in_asso_11_1n_nn,$backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_11_1n_nn)) {
		$this->roleb_in_asso_11_1n_nn->removeRoleacInAsso111nNn($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_11_1n_nn' ;
		$changes['old_value'] = $this->roleb_in_asso_11_1n_nn ;
		$changes['operation'] = 'set' ;
	}
	$this->roleb_in_asso_11_1n_nn = $roleb_in_asso_11_1n_nn ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_11_1n_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->roleb_in_asso_11_1n_nn->addRoleacInAsso111nNn($this,false) ;
	}
}

	
	/**
	 * getRolebInAsso111nNn
	 */
	public function getRolebInAsso111nNn()
	{
		return $this->roleb_in_asso_11_1n_nn ;
	}
	/**
 * setListOfRolecInAsso111nNn
 */
public function setListOfRolecInAsso111nNn($rolec_in_asso_11_1n_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_11_1n_nn)) {
		foreach($this->rolec_in_asso_11_1n_nn as $item) {
			$item->removeRoleabInAsso111nNn($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_1n_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_11_1n_nn ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolec_in_asso_11_1n_nn = $rolec_in_asso_11_1n_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_1n_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolec_in_asso_11_1n_nn as $item) {
			$item->addRoleabInAsso111nNn($this,false) ;
		}
	}
}

/**
 * addRolecInAsso111nNn
 */
public function addRolecInAsso111nNn($rolec_in_asso_11_1n_nn, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_1n_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_11_1n_nn ;
		$changes['operation'] = 'add' ;
	}
	$this->rolec_in_asso_11_1n_nn[] = $rolec_in_asso_11_1n_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_1n_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolec_in_asso_11_1n_nn->addRoleabInAsso111nNn($this,false) ;
	}
}

/**
 * removeRolecInAsso111nNn
 */
public function removeRolecInAsso111nNn($rolec_in_asso_11_1n_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_11_1n_nn)) {
		$rolec_in_asso_11_1n_nn->removeRoleabInAsso111nNn($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_1n_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_11_1n_nn ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolec_in_asso_11_1n_nn as $key=>$item) {
		if($item->__sameAs($rolec_in_asso_11_1n_nn)) {
			unset($this->rolec_in_asso_11_1n_nn[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_1n_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolecInAsso111nNn
 */
public function unsetRolecInAsso111nNn($backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_11_1n_nn)) {
		foreach($this->rolec_in_asso_11_1n_nn as $item) {
			$item->removeRoleabInAsso111nNn($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_11_1n_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_11_1n_nn ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolec_in_asso_11_1n_nn = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_11_1n_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolecInAsso111nNn
	 */
	public function getRolecInAsso111nNn()
	{
		return $this->rolec_in_asso_11_1n_nn ;
	}
	
}