<?php
/**
 * testmodule_Dto_Asso11WithAttributes
 * @package data.Module (name: test module)
 */
class testmodule_Dto_Asso11WithAttributes extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = 'Asso11WithAttributes';
    const MODULE_NAME = 'testmodule';
    
    /**
	 * @var testmodule_Dto_A
	 */
	protected $rolea_in_asso_1_1_wa ;
    /**
	 * @var testmodule_Dto_B
	 */
	protected $roleb_in_asso_1_1_wa ;
    
	/**
	 * @var String
	 */
	protected $attr ;
	
	/**
 * setRoleaInAsso11Wa
 */
public function setRoleaInAsso11Wa($rolea_in_asso_1_1_wa, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_1_1_wa' ;
		$changes['old_value'] = $this->rolea_in_asso_1_1_wa ;
		$changes['operation'] = Wisss_Change::OPERATION_SET ;
	}
	$this->rolea_in_asso_1_1_wa = $rolea_in_asso_1_1_wa ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_1_1_wa ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}
	
	/**
	 * getRoleaInAsso11Wa
	 */
	public function getRoleaInAsso11Wa()
	{
		return $this->rolea_in_asso_1_1_wa ;
	}
	/**
 * setRolebInAsso11Wa
 */
public function setRolebInAsso11Wa($roleb_in_asso_1_1_wa, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_1_1_wa' ;
		$changes['old_value'] = $this->roleb_in_asso_1_1_wa ;
		$changes['operation'] = Wisss_Change::OPERATION_SET ;
	}
	$this->roleb_in_asso_1_1_wa = $roleb_in_asso_1_1_wa ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_1_1_wa ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}
	
	/**
	 * getRolebInAsso11Wa
	 */
	public function getRolebInAsso11Wa()
	{
		return $this->roleb_in_asso_1_1_wa ;
	}
	
	/**
 * setAttr
 */
public function setAttr($attr, $notify=true)
{
	if($notify) {
		$changes = new Wisss_Change() ;
		$changes->setAttribute('attr') ;
		$changes->setOld($this->attr) ;
		$changes->setOperation(Wisss_Change::OPERATION_SET) ;
	}
	$this->attr = $attr ;
	if($notify) {
		$changes->setNew($attr) ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getAttr
	 */
	public function getAttr()
	{
		return $this->attr ;
	}

}