<?php
/**
 * testmodule_Dto_Asso1n1nNn
 * @package data.Module (name: test module)
 */
class testmodule_Dto_Asso1n1nNn extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = 'Asso1n1nNn';
    const MODULE_NAME = 'testmodule';
    
    /**
	 * @var testmodule_Dto_A
	 */
	protected $rolea_in_asso_1n_1n_nn ;
    /**
	 * @var testmodule_Dto_B
	 */
	protected $roleb_in_asso_1n_1n_nn ;
    /**
	 * @var testmodule_Dto_C
	 */
	protected $rolec_in_asso_1n_1n_nn ;
    
	
	/**
 * setRoleaInAsso1n1nNn
 */
public function setRoleaInAsso1n1nNn($rolea_in_asso_1n_1n_nn,$backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_1n_1n_nn)) {
		$this->rolea_in_asso_1n_1n_nn->removeRolebcInAsso1n1nNn($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_1n_1n_nn' ;
		$changes['old_value'] = $this->rolea_in_asso_1n_1n_nn ;
		$changes['operation'] = 'set' ;
	}
	$this->rolea_in_asso_1n_1n_nn = $rolea_in_asso_1n_1n_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_1n_1n_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->rolea_in_asso_1n_1n_nn->addRolebcInAsso1n1nNn($this,false) ;
	}
}

	
	/**
	 * getRoleaInAsso1n1nNn
	 */
	public function getRoleaInAsso1n1nNn()
	{
		return $this->rolea_in_asso_1n_1n_nn ;
	}
	/**
 * setRolebInAsso1n1nNn
 */
public function setRolebInAsso1n1nNn($roleb_in_asso_1n_1n_nn,$backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_1n_1n_nn)) {
		$this->roleb_in_asso_1n_1n_nn->removeRoleacInAsso1n1nNn($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_1n_1n_nn' ;
		$changes['old_value'] = $this->roleb_in_asso_1n_1n_nn ;
		$changes['operation'] = 'set' ;
	}
	$this->roleb_in_asso_1n_1n_nn = $roleb_in_asso_1n_1n_nn ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_1n_1n_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->roleb_in_asso_1n_1n_nn->addRoleacInAsso1n1nNn($this,false) ;
	}
}

	
	/**
	 * getRolebInAsso1n1nNn
	 */
	public function getRolebInAsso1n1nNn()
	{
		return $this->roleb_in_asso_1n_1n_nn ;
	}
	/**
 * setListOfRolecInAsso1n1nNn
 */
public function setListOfRolecInAsso1n1nNn($rolec_in_asso_1n_1n_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_1n_1n_nn)) {
		foreach($this->rolec_in_asso_1n_1n_nn as $item) {
			$item->removeRoleabInAsso1n1nNn($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_1n_1n_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_1n_1n_nn ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolec_in_asso_1n_1n_nn = $rolec_in_asso_1n_1n_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_1n_1n_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolec_in_asso_1n_1n_nn as $item) {
			$item->addRoleabInAsso1n1nNn($this,false) ;
		}
	}
}

/**
 * addRolecInAsso1n1nNn
 */
public function addRolecInAsso1n1nNn($rolec_in_asso_1n_1n_nn, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_1n_1n_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_1n_1n_nn ;
		$changes['operation'] = 'add' ;
	}
	$this->rolec_in_asso_1n_1n_nn[] = $rolec_in_asso_1n_1n_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_1n_1n_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolec_in_asso_1n_1n_nn->addRoleabInAsso1n1nNn($this,false) ;
	}
}

/**
 * removeRolecInAsso1n1nNn
 */
public function removeRolecInAsso1n1nNn($rolec_in_asso_1n_1n_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_1n_1n_nn)) {
		$rolec_in_asso_1n_1n_nn->removeRoleabInAsso1n1nNn($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_1n_1n_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_1n_1n_nn ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolec_in_asso_1n_1n_nn as $key=>$item) {
		if($item->__sameAs($rolec_in_asso_1n_1n_nn)) {
			unset($this->rolec_in_asso_1n_1n_nn[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_1n_1n_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolecInAsso1n1nNn
 */
public function unsetRolecInAsso1n1nNn($backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_1n_1n_nn)) {
		foreach($this->rolec_in_asso_1n_1n_nn as $item) {
			$item->removeRoleabInAsso1n1nNn($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_1n_1n_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_1n_1n_nn ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolec_in_asso_1n_1n_nn = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_1n_1n_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolecInAsso1n1nNn
	 */
	public function getRolecInAsso1n1nNn()
	{
		return $this->rolec_in_asso_1n_1n_nn ;
	}
	
}