<?php
/**
 * testmodule_Dto_AssoN1N1Nn
 * @package data.Module (name: test module)
 */
class testmodule_Dto_AssoN1N1Nn extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = 'AssoN1N1Nn';
    const MODULE_NAME = 'testmodule';
    
    /**
	 * @var testmodule_Dto_A
	 */
	protected $rolea_in_asso_n1_n1_nn ;
    /**
	 * @var testmodule_Dto_B
	 */
	protected $roleb_in_asso_n1_n1_nn ;
    /**
	 * @var testmodule_Dto_C
	 */
	protected $rolec_in_asso_n1_n1_nn ;
    
	
	/**
 * setListOfRoleaInAssoN1N1Nn
 */
public function setListOfRoleaInAssoN1N1Nn($rolea_in_asso_n1_n1_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_n1_n1_nn)) {
		foreach($this->rolea_in_asso_n1_n1_nn as $item) {
			$item->unsetRolebcInAssoN1N1Nn(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_n1_n1_nn' ;
		$changes['old_value'] = $this->rolea_in_asso_n1_n1_nn ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolea_in_asso_n1_n1_nn = $rolea_in_asso_n1_n1_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_n1_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolea_in_asso_n1_n1_nn as $item) {
			$item->setRolebcInAssoN1N1Nn($this,false) ;
		}
	}
}

/**
 * addRoleaInAssoN1N1Nn
 */
public function addRoleaInAssoN1N1Nn($rolea_in_asso_n1_n1_nn, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_n1_n1_nn' ;
		$changes['old_value'] = $this->rolea_in_asso_n1_n1_nn ;
		$changes['operation'] = 'add' ;
	}
	$this->rolea_in_asso_n1_n1_nn[] = $rolea_in_asso_n1_n1_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_n1_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolea_in_asso_n1_n1_nn->setRolebcInAssoN1N1Nn($this,false) ;
	}
}

/**
 * removeRoleaInAssoN1N1Nn
 */
public function removeRoleaInAssoN1N1Nn($rolea_in_asso_n1_n1_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_n1_n1_nn)) {
		$rolea_in_asso_n1_n1_nn->unsetRolebcInAssoN1N1Nn(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_n1_n1_nn' ;
		$changes['old_value'] = $this->rolea_in_asso_n1_n1_nn ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolea_in_asso_n1_n1_nn as $key=>$item) {
		if($item->__sameAs($rolea_in_asso_n1_n1_nn)) {
			unset($this->rolea_in_asso_n1_n1_nn[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_n1_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRoleaInAssoN1N1Nn
 */
public function unsetRoleaInAssoN1N1Nn($backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_n1_n1_nn)) {
		foreach($this->rolea_in_asso_n1_n1_nn as $item) {
			$item->unsetRolebcInAssoN1N1Nn(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_n1_n1_nn' ;
		$changes['old_value'] = $this->rolea_in_asso_n1_n1_nn ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolea_in_asso_n1_n1_nn = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_n1_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRoleaInAssoN1N1Nn
	 */
	public function getRoleaInAssoN1N1Nn()
	{
		return $this->rolea_in_asso_n1_n1_nn ;
	}
	/**
 * setListOfRolebInAssoN1N1Nn
 */
public function setListOfRolebInAssoN1N1Nn($roleb_in_asso_n1_n1_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_n1_n1_nn)) {
		foreach($this->roleb_in_asso_n1_n1_nn as $item) {
			$item->unsetRoleacInAssoN1N1Nn(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_n1_n1_nn' ;
		$changes['old_value'] = $this->roleb_in_asso_n1_n1_nn ;
		$changes['operation'] = 'setlist' ;
	}
	$this->roleb_in_asso_n1_n1_nn = $roleb_in_asso_n1_n1_nn ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_n1_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->roleb_in_asso_n1_n1_nn as $item) {
			$item->setRoleacInAssoN1N1Nn($this,false) ;
		}
	}
}

/**
 * addRolebInAssoN1N1Nn
 */
public function addRolebInAssoN1N1Nn($roleb_in_asso_n1_n1_nn, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_n1_n1_nn' ;
		$changes['old_value'] = $this->roleb_in_asso_n1_n1_nn ;
		$changes['operation'] = 'add' ;
	}
	$this->roleb_in_asso_n1_n1_nn[] = $roleb_in_asso_n1_n1_nn ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_n1_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$roleb_in_asso_n1_n1_nn->setRoleacInAssoN1N1Nn($this,false) ;
	}
}

/**
 * removeRolebInAssoN1N1Nn
 */
public function removeRolebInAssoN1N1Nn($roleb_in_asso_n1_n1_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_n1_n1_nn)) {
		$roleb_in_asso_n1_n1_nn->unsetRoleacInAssoN1N1Nn(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_n1_n1_nn' ;
		$changes['old_value'] = $this->roleb_in_asso_n1_n1_nn ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->roleb_in_asso_n1_n1_nn as $key=>$item) {
		if($item->__sameAs($roleb_in_asso_n1_n1_nn)) {
			unset($this->roleb_in_asso_n1_n1_nn[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_n1_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolebInAssoN1N1Nn
 */
public function unsetRolebInAssoN1N1Nn($backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_n1_n1_nn)) {
		foreach($this->roleb_in_asso_n1_n1_nn as $item) {
			$item->unsetRoleacInAssoN1N1Nn(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_n1_n1_nn' ;
		$changes['old_value'] = $this->roleb_in_asso_n1_n1_nn ;
		$changes['operation'] = 'unset' ;
	}
	$this->roleb_in_asso_n1_n1_nn = array() ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_n1_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolebInAssoN1N1Nn
	 */
	public function getRolebInAssoN1N1Nn()
	{
		return $this->roleb_in_asso_n1_n1_nn ;
	}
	/**
 * setListOfRolecInAssoN1N1Nn
 */
public function setListOfRolecInAssoN1N1Nn($rolec_in_asso_n1_n1_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_n1_n1_nn)) {
		foreach($this->rolec_in_asso_n1_n1_nn as $item) {
			$item->removeRoleabInAssoN1N1Nn($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_n1_n1_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_n1_n1_nn ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolec_in_asso_n1_n1_nn = $rolec_in_asso_n1_n1_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_n1_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolec_in_asso_n1_n1_nn as $item) {
			$item->addRoleabInAssoN1N1Nn($this,false) ;
		}
	}
}

/**
 * addRolecInAssoN1N1Nn
 */
public function addRolecInAssoN1N1Nn($rolec_in_asso_n1_n1_nn, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_n1_n1_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_n1_n1_nn ;
		$changes['operation'] = 'add' ;
	}
	$this->rolec_in_asso_n1_n1_nn[] = $rolec_in_asso_n1_n1_nn ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_n1_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolec_in_asso_n1_n1_nn->addRoleabInAssoN1N1Nn($this,false) ;
	}
}

/**
 * removeRolecInAssoN1N1Nn
 */
public function removeRolecInAssoN1N1Nn($rolec_in_asso_n1_n1_nn, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_n1_n1_nn)) {
		$rolec_in_asso_n1_n1_nn->removeRoleabInAssoN1N1Nn($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_n1_n1_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_n1_n1_nn ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolec_in_asso_n1_n1_nn as $key=>$item) {
		if($item->__sameAs($rolec_in_asso_n1_n1_nn)) {
			unset($this->rolec_in_asso_n1_n1_nn[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_n1_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolecInAssoN1N1Nn
 */
public function unsetRolecInAssoN1N1Nn($backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_n1_n1_nn)) {
		foreach($this->rolec_in_asso_n1_n1_nn as $item) {
			$item->removeRoleabInAssoN1N1Nn($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_n1_n1_nn' ;
		$changes['old_value'] = $this->rolec_in_asso_n1_n1_nn ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolec_in_asso_n1_n1_nn = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_n1_n1_nn ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolecInAssoN1N1Nn
	 */
	public function getRolecInAssoN1N1Nn()
	{
		return $this->rolec_in_asso_n1_n1_nn ;
	}
	
}