<?php
/**
 * testmodule_Dto_AssoNnNn11
 * @package data.Module (name: test module)
 */
class testmodule_Dto_AssoNnNn11 extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = 'AssoNnNn11';
    const MODULE_NAME = 'testmodule';
    
    /**
	 * @var testmodule_Dto_A
	 */
	protected $rolea_in_asso_nn_nn_11 ;
    /**
	 * @var testmodule_Dto_B
	 */
	protected $roleb_in_asso_nn_nn_11 ;
    /**
	 * @var testmodule_Dto_C
	 */
	protected $rolec_in_asso_nn_nn_11 ;
    
	
	/**
 * setListOfRoleaInAssoNnNn11
 */
public function setListOfRoleaInAssoNnNn11($rolea_in_asso_nn_nn_11, $backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_nn_nn_11)) {
		foreach($this->rolea_in_asso_nn_nn_11 as $item) {
			$item->removeRolebcInAssoNnNn11($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_nn_nn_11' ;
		$changes['old_value'] = $this->rolea_in_asso_nn_nn_11 ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolea_in_asso_nn_nn_11 = $rolea_in_asso_nn_nn_11 ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_nn_nn_11 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolea_in_asso_nn_nn_11 as $item) {
			$item->addRolebcInAssoNnNn11($this,false) ;
		}
	}
}

/**
 * addRoleaInAssoNnNn11
 */
public function addRoleaInAssoNnNn11($rolea_in_asso_nn_nn_11, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_nn_nn_11' ;
		$changes['old_value'] = $this->rolea_in_asso_nn_nn_11 ;
		$changes['operation'] = 'add' ;
	}
	$this->rolea_in_asso_nn_nn_11[] = $rolea_in_asso_nn_nn_11 ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_nn_nn_11 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolea_in_asso_nn_nn_11->addRolebcInAssoNnNn11($this,false) ;
	}
}

/**
 * removeRoleaInAssoNnNn11
 */
public function removeRoleaInAssoNnNn11($rolea_in_asso_nn_nn_11, $backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_nn_nn_11)) {
		$rolea_in_asso_nn_nn_11->removeRolebcInAssoNnNn11($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_nn_nn_11' ;
		$changes['old_value'] = $this->rolea_in_asso_nn_nn_11 ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolea_in_asso_nn_nn_11 as $key=>$item) {
		if($item->__sameAs($rolea_in_asso_nn_nn_11)) {
			unset($this->rolea_in_asso_nn_nn_11[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_nn_nn_11 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRoleaInAssoNnNn11
 */
public function unsetRoleaInAssoNnNn11($backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_nn_nn_11)) {
		foreach($this->rolea_in_asso_nn_nn_11 as $item) {
			$item->removeRolebcInAssoNnNn11($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_nn_nn_11' ;
		$changes['old_value'] = $this->rolea_in_asso_nn_nn_11 ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolea_in_asso_nn_nn_11 = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_nn_nn_11 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRoleaInAssoNnNn11
	 */
	public function getRoleaInAssoNnNn11()
	{
		return $this->rolea_in_asso_nn_nn_11 ;
	}
	/**
 * setListOfRolebInAssoNnNn11
 */
public function setListOfRolebInAssoNnNn11($roleb_in_asso_nn_nn_11, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_nn_nn_11)) {
		foreach($this->roleb_in_asso_nn_nn_11 as $item) {
			$item->removeRoleacInAssoNnNn11($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_nn_nn_11' ;
		$changes['old_value'] = $this->roleb_in_asso_nn_nn_11 ;
		$changes['operation'] = 'setlist' ;
	}
	$this->roleb_in_asso_nn_nn_11 = $roleb_in_asso_nn_nn_11 ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_nn_nn_11 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->roleb_in_asso_nn_nn_11 as $item) {
			$item->addRoleacInAssoNnNn11($this,false) ;
		}
	}
}

/**
 * addRolebInAssoNnNn11
 */
public function addRolebInAssoNnNn11($roleb_in_asso_nn_nn_11, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_nn_nn_11' ;
		$changes['old_value'] = $this->roleb_in_asso_nn_nn_11 ;
		$changes['operation'] = 'add' ;
	}
	$this->roleb_in_asso_nn_nn_11[] = $roleb_in_asso_nn_nn_11 ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_nn_nn_11 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$roleb_in_asso_nn_nn_11->addRoleacInAssoNnNn11($this,false) ;
	}
}

/**
 * removeRolebInAssoNnNn11
 */
public function removeRolebInAssoNnNn11($roleb_in_asso_nn_nn_11, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_nn_nn_11)) {
		$roleb_in_asso_nn_nn_11->removeRoleacInAssoNnNn11($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_nn_nn_11' ;
		$changes['old_value'] = $this->roleb_in_asso_nn_nn_11 ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->roleb_in_asso_nn_nn_11 as $key=>$item) {
		if($item->__sameAs($roleb_in_asso_nn_nn_11)) {
			unset($this->roleb_in_asso_nn_nn_11[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_nn_nn_11 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolebInAssoNnNn11
 */
public function unsetRolebInAssoNnNn11($backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_nn_nn_11)) {
		foreach($this->roleb_in_asso_nn_nn_11 as $item) {
			$item->removeRoleacInAssoNnNn11($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_nn_nn_11' ;
		$changes['old_value'] = $this->roleb_in_asso_nn_nn_11 ;
		$changes['operation'] = 'unset' ;
	}
	$this->roleb_in_asso_nn_nn_11 = array() ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_nn_nn_11 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolebInAssoNnNn11
	 */
	public function getRolebInAssoNnNn11()
	{
		return $this->roleb_in_asso_nn_nn_11 ;
	}
	/**
 * setRolecInAssoNnNn11
 */
public function setRolecInAssoNnNn11($rolec_in_asso_nn_nn_11,$backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_nn_nn_11)) {
		$this->rolec_in_asso_nn_nn_11->unsetRoleabInAssoNnNn11(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_nn_nn_11' ;
		$changes['old_value'] = $this->rolec_in_asso_nn_nn_11 ;
		$changes['operation'] = 'set' ;
	}
	$this->rolec_in_asso_nn_nn_11 = $rolec_in_asso_nn_nn_11 ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_nn_nn_11 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->rolec_in_asso_nn_nn_11->setRoleabInAssoNnNn11($this,false) ;
	}
}

	
	/**
	 * getRolecInAssoNnNn11
	 */
	public function getRolecInAssoNnNn11()
	{
		return $this->rolec_in_asso_nn_nn_11 ;
	}
	
}