<?php
/**
 * testmodule_Dto_AssoNnNnN1
 * @package data.Module (name: test module)
 */
class testmodule_Dto_AssoNnNnN1 extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = 'AssoNnNnN1';
    const MODULE_NAME = 'testmodule';
    
    /**
	 * @var testmodule_Dto_A
	 */
	protected $rolea_in_asso_nn_nn_n1 ;
    /**
	 * @var testmodule_Dto_B
	 */
	protected $roleb_in_asso_nn_nn_n1 ;
    /**
	 * @var testmodule_Dto_C
	 */
	protected $rolec_in_asso_nn_nn_n1 ;
    
	
	/**
 * setListOfRoleaInAssoNnNnN1
 */
public function setListOfRoleaInAssoNnNnN1($rolea_in_asso_nn_nn_n1, $backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_nn_nn_n1)) {
		foreach($this->rolea_in_asso_nn_nn_n1 as $item) {
			$item->removeRolebcInAssoNnNnN1($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_nn_nn_n1' ;
		$changes['old_value'] = $this->rolea_in_asso_nn_nn_n1 ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolea_in_asso_nn_nn_n1 = $rolea_in_asso_nn_nn_n1 ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_nn_nn_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolea_in_asso_nn_nn_n1 as $item) {
			$item->addRolebcInAssoNnNnN1($this,false) ;
		}
	}
}

/**
 * addRoleaInAssoNnNnN1
 */
public function addRoleaInAssoNnNnN1($rolea_in_asso_nn_nn_n1, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_nn_nn_n1' ;
		$changes['old_value'] = $this->rolea_in_asso_nn_nn_n1 ;
		$changes['operation'] = 'add' ;
	}
	$this->rolea_in_asso_nn_nn_n1[] = $rolea_in_asso_nn_nn_n1 ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_nn_nn_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolea_in_asso_nn_nn_n1->addRolebcInAssoNnNnN1($this,false) ;
	}
}

/**
 * removeRoleaInAssoNnNnN1
 */
public function removeRoleaInAssoNnNnN1($rolea_in_asso_nn_nn_n1, $backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_nn_nn_n1)) {
		$rolea_in_asso_nn_nn_n1->removeRolebcInAssoNnNnN1($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_nn_nn_n1' ;
		$changes['old_value'] = $this->rolea_in_asso_nn_nn_n1 ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolea_in_asso_nn_nn_n1 as $key=>$item) {
		if($item->__sameAs($rolea_in_asso_nn_nn_n1)) {
			unset($this->rolea_in_asso_nn_nn_n1[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_nn_nn_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRoleaInAssoNnNnN1
 */
public function unsetRoleaInAssoNnNnN1($backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_asso_nn_nn_n1)) {
		foreach($this->rolea_in_asso_nn_nn_n1 as $item) {
			$item->removeRolebcInAssoNnNnN1($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_asso_nn_nn_n1' ;
		$changes['old_value'] = $this->rolea_in_asso_nn_nn_n1 ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolea_in_asso_nn_nn_n1 = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_asso_nn_nn_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRoleaInAssoNnNnN1
	 */
	public function getRoleaInAssoNnNnN1()
	{
		return $this->rolea_in_asso_nn_nn_n1 ;
	}
	/**
 * setListOfRolebInAssoNnNnN1
 */
public function setListOfRolebInAssoNnNnN1($roleb_in_asso_nn_nn_n1, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_nn_nn_n1)) {
		foreach($this->roleb_in_asso_nn_nn_n1 as $item) {
			$item->removeRoleacInAssoNnNnN1($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_nn_nn_n1' ;
		$changes['old_value'] = $this->roleb_in_asso_nn_nn_n1 ;
		$changes['operation'] = 'setlist' ;
	}
	$this->roleb_in_asso_nn_nn_n1 = $roleb_in_asso_nn_nn_n1 ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_nn_nn_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->roleb_in_asso_nn_nn_n1 as $item) {
			$item->addRoleacInAssoNnNnN1($this,false) ;
		}
	}
}

/**
 * addRolebInAssoNnNnN1
 */
public function addRolebInAssoNnNnN1($roleb_in_asso_nn_nn_n1, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_nn_nn_n1' ;
		$changes['old_value'] = $this->roleb_in_asso_nn_nn_n1 ;
		$changes['operation'] = 'add' ;
	}
	$this->roleb_in_asso_nn_nn_n1[] = $roleb_in_asso_nn_nn_n1 ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_nn_nn_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$roleb_in_asso_nn_nn_n1->addRoleacInAssoNnNnN1($this,false) ;
	}
}

/**
 * removeRolebInAssoNnNnN1
 */
public function removeRolebInAssoNnNnN1($roleb_in_asso_nn_nn_n1, $backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_nn_nn_n1)) {
		$roleb_in_asso_nn_nn_n1->removeRoleacInAssoNnNnN1($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_nn_nn_n1' ;
		$changes['old_value'] = $this->roleb_in_asso_nn_nn_n1 ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->roleb_in_asso_nn_nn_n1 as $key=>$item) {
		if($item->__sameAs($roleb_in_asso_nn_nn_n1)) {
			unset($this->roleb_in_asso_nn_nn_n1[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_nn_nn_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolebInAssoNnNnN1
 */
public function unsetRolebInAssoNnNnN1($backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_asso_nn_nn_n1)) {
		foreach($this->roleb_in_asso_nn_nn_n1 as $item) {
			$item->removeRoleacInAssoNnNnN1($this,false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_asso_nn_nn_n1' ;
		$changes['old_value'] = $this->roleb_in_asso_nn_nn_n1 ;
		$changes['operation'] = 'unset' ;
	}
	$this->roleb_in_asso_nn_nn_n1 = array() ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_asso_nn_nn_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolebInAssoNnNnN1
	 */
	public function getRolebInAssoNnNnN1()
	{
		return $this->roleb_in_asso_nn_nn_n1 ;
	}
	/**
 * setListOfRolecInAssoNnNnN1
 */
public function setListOfRolecInAssoNnNnN1($rolec_in_asso_nn_nn_n1, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_nn_nn_n1)) {
		foreach($this->rolec_in_asso_nn_nn_n1 as $item) {
			$item->unsetRoleabInAssoNnNnN1(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_nn_nn_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_nn_nn_n1 ;
		$changes['operation'] = 'setlist' ;
	}
	$this->rolec_in_asso_nn_nn_n1 = $rolec_in_asso_nn_nn_n1 ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_nn_nn_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		foreach($this->rolec_in_asso_nn_nn_n1 as $item) {
			$item->setRoleabInAssoNnNnN1($this,false) ;
		}
	}
}

/**
 * addRolecInAssoNnNnN1
 */
public function addRolecInAssoNnNnN1($rolec_in_asso_nn_nn_n1, $backref=true, $notify=true)
{
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_nn_nn_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_nn_nn_n1 ;
		$changes['operation'] = 'add' ;
	}
	$this->rolec_in_asso_nn_nn_n1[] = $rolec_in_asso_nn_nn_n1 ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_nn_nn_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$rolec_in_asso_nn_nn_n1->setRoleabInAssoNnNnN1($this,false) ;
	}
}

/**
 * removeRolecInAssoNnNnN1
 */
public function removeRolecInAssoNnNnN1($rolec_in_asso_nn_nn_n1, $backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_nn_nn_n1)) {
		$rolec_in_asso_nn_nn_n1->unsetRoleabInAssoNnNnN1(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_nn_nn_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_nn_nn_n1 ;
		$changes['operation'] = 'remove' ;
	}
	foreach($this->rolec_in_asso_nn_nn_n1 as $key=>$item) {
		if($item->__sameAs($rolec_in_asso_nn_nn_n1)) {
			unset($this->rolec_in_asso_nn_nn_n1[$key]) ;
		}
	}
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_nn_nn_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

/**
 * unsetRolecInAssoNnNnN1
 */
public function unsetRolecInAssoNnNnN1($backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_asso_nn_nn_n1)) {
		foreach($this->rolec_in_asso_nn_nn_n1 as $item) {
			$item->unsetRoleabInAssoNnNnN1(false) ;
		}
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_asso_nn_nn_n1' ;
		$changes['old_value'] = $this->rolec_in_asso_nn_nn_n1 ;
		$changes['operation'] = 'unset' ;
	}
	$this->rolec_in_asso_nn_nn_n1 = array() ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_asso_nn_nn_n1 ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
}

	
	/**
	 * getRolecInAssoNnNnN1
	 */
	public function getRolecInAssoNnNnN1()
	{
		return $this->rolec_in_asso_nn_nn_n1 ;
	}
	
}