<?php
/**
 * testmodule_Dto_Xasso
 * @package data.Module (name: test module)
 */
class testmodule_Dto_Xasso extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = 'Xasso';
    const MODULE_NAME = 'testmodule';
    
    /**
	 * @var testmodule_Dto_A
	 */
	protected $rolea_in_xasso ;
    /**
	 * @var testmodule_Dto_B
	 */
	protected $roleb_in_xasso ;
    /**
	 * @var testmodule_Dto_C
	 */
	protected $rolec_in_xasso ;
    
	
	/**
 * setRoleaInXasso
 */
public function setRoleaInXasso($rolea_in_xasso,$backref=true, $notify=true)
{
	if($backref && isset($this->rolea_in_xasso)) {
		$this->rolea_in_xasso->removeRolebcInXasso($this,false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolea_in_xasso' ;
		$changes['old_value'] = $this->rolea_in_xasso ;
		$changes['operation'] = 'set' ;
	}
	$this->rolea_in_xasso = $rolea_in_xasso ;
	if($notify) {
		$changes['new_value'] = $this->rolea_in_xasso ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->rolea_in_xasso->addRolebcInXasso($this,false) ;
	}
}

	
	/**
	 * getRoleaInXasso
	 */
	public function getRoleaInXasso()
	{
		return $this->rolea_in_xasso ;
	}
	/**
 * setRolebInXasso
 */
public function setRolebInXasso($roleb_in_xasso,$backref=true, $notify=true)
{
	if($backref && isset($this->roleb_in_xasso)) {
		$this->roleb_in_xasso->unsetRoleacInXasso(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'roleb_in_xasso' ;
		$changes['old_value'] = $this->roleb_in_xasso ;
		$changes['operation'] = 'set' ;
	}
	$this->roleb_in_xasso = $roleb_in_xasso ;
	if($notify) {
		$changes['new_value'] = $this->roleb_in_xasso ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->roleb_in_xasso->setRoleacInXasso($this,false) ;
	}
}

	
	/**
	 * getRolebInXasso
	 */
	public function getRolebInXasso()
	{
		return $this->roleb_in_xasso ;
	}
	/**
 * setRolecInXasso
 */
public function setRolecInXasso($rolec_in_xasso,$backref=true, $notify=true)
{
	if($backref && isset($this->rolec_in_xasso)) {
		$this->rolec_in_xasso->unsetRoleabInXasso(false) ;
	}
	if($notify) {
		$changes = array() ;
		$changes['attribute'] = 'rolec_in_xasso' ;
		$changes['old_value'] = $this->rolec_in_xasso ;
		$changes['operation'] = 'set' ;
	}
	$this->rolec_in_xasso = $rolec_in_xasso ;
	if($notify) {
		$changes['new_value'] = $this->rolec_in_xasso ;
		$this->setChanged() ;
		$this->notifyObservers($changes) ;
	}
	if($backref) {
		$this->rolec_in_xasso->setRoleabInXasso($this,false) ;
	}
}

	
	/**
	 * getRolecInXasso
	 */
	public function getRolecInXasso()
	{
		return $this->rolec_in_xasso ;
	}
	
}