<%
metamodel http://www.acceleo.org/module/wisss/data

import services.NamingServices
import general.class_type
import general.type
import modules.dto.class_dto
%>

<%script type="data.BinaryAssociation" name="dto" file="<%file%>"%>
<?php
/**
 * <%PhpDtoClassName()%>
 * @package <%module%>
 */
class <%PhpDtoClassName()%> extends Wisss_Dto_Abstract
{
	/**
     * information from model
     */
    const CLASS_NAME = '<%ClassName()%>';
    const MODULE_NAME = '<%module.ModuleName()%>';
    
    <%for (association_ends){%>
    /**
	 * @var <%type.phpType%>
	 */
	protected $<%AttributeName()%> ;
    <%}%>
    
	<%for (attributes){%>
	/**
	 * @var <%type.phpType%>
	 */
	protected $<%AttributeName()%> ;
	<%}%>
	
	<%for (association_ends){%>
	<%setter%>
	
	<%getter%>
	<%}%>
	
	<%for (attributes){%>
	<%setter%>
	
	<%getter%>
	<%}%>
}

<%script type="BinaryAssociation" name="file"%>
<%if (attributes){%>modules-available/<%module.DirName()%>/Dto/<%FileName()%>.php<%}%>

<%script type="AssociationEnd" name="setter"%>
/**
 * set<%name.toCamelCase()%>
 */
public function set<%name.toCamelCase()%>(<%toPhpVariable%>, $notify=true)
{
	if($notify) {
		<%beforeChange%>
		$changes['operation'] = Wisss_Change::OPERATION_SET ;
	}
	$this-><%AttributeName()%> = <%toPhpVariable()%> ;
	if($notify) {
		<%afterChange%>
	}
}

<%script type="AssociationEnd" name="beforeChange"%>
$changes = array() ;
$changes['attribute'] = '<%AttributeName()%>' ;
$changes['old_value'] = $this-><%AttributeName()%> ;
<%script type="AssociationEnd" name="afterChange"%>
$changes['new_value'] = $this-><%AttributeName()%> ;
$this->setChanged() ;
$this->notifyObservers($changes) ;

<%script type="AssociationEnd" name="getter"%>
/**
 * get<%name.toCamelCase()%>
 */
public function get<%name.toCamelCase()%>()
{
	return $this-><%AttributeName()%> ;
}
