/*
  Copyright © 2007 Makina Corpus
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the GNU Public License v2.0
  which accompanies this distribution, and is available at
  http://www.gnu.org/licenses/gpl.txt
  You can apply any license to the files generated with this template
  and Acceleo.

@author  Francois Gaudin <francois.gaudin@makina-corpus.com> 
*/

package services;

import wisss.data.AssociationEnd;
import wisss.data.BinaryAssociation;

public class SqlServices {
	public boolean implyForeignKeyForAssoc(AssociationEnd end) {
		AssociationServices assoservice = new AssociationServices() ;
		if(end.getUpper_bound() == -1 && assoservice.getOppositeEnd(end).getUpper_bound() == 1 && end.getAssociation().getAttributes().size() == 0) {
			return true ;
		} else if (end.getUpper_bound() == 1 && assoservice.getOppositeEnd(end).getUpper_bound() == 1 && assoservice.getOppositeEnd(end).isContainer()) {
			return true ;
		} else if (end.getUpper_bound() == 1 && assoservice.getOppositeEnd(end).getUpper_bound() == 1 && end.getLower_bound() == 0 && assoservice.getOppositeEnd(end).getLower_bound() == 1 && !end.isContainer()) {
			return true ;
		} else if (end.getUpper_bound() == 1 && assoservice.getOppositeEnd(end).getUpper_bound() == 1 && end.getName().compareTo(assoservice.getOppositeEnd(end).getName()) <= 0 && !end.isContainer()) {
			return true ;
		}
		return false ;
	}
	
	public boolean implyJoinTableForAssoc(BinaryAssociation asso) {
		if((((AssociationEnd)asso.getAssociation_ends().get(0)).getUpper_bound() == -1 &&  ((AssociationEnd)asso.getAssociation_ends().get(1)).getUpper_bound() == -1) || asso.getAttributes().size() != 0) {
			return true ;
		}
		return false ;
	}
}