/*
  Copyright © 2007 Makina Corpus
  All rights reserved.  This program and the accompanying materials
  are made available under the terms of the GNU Public License v2.0
  which accompanies this distribution, and is available at
  http://www.gnu.org/licenses/gpl.txt
  You can apply any license to the files generated with this template
  and Acceleo.

@author  Francois Gaudin <francois.gaudin@makina-corpus.com> 
*/

package services;

import java.util.Random;

import org.eclipse.emf.ecore.EObject;


public class TestServices {
	public String generateString(EObject o,int length) {
		Random ran = new Random();
		StringBuffer randomString = new StringBuffer() ;
		for(int i=0;i<length;i++) {
			char character = (char)(32+ran.nextInt(127-32));
			randomString.append(Character.toString(character)) ;
		}
		return randomString.toString() ;
	}
	
	public String generateSqlString(EObject o,int length) {
		String str = this.generateString(o, length) ;
		str = str.replaceAll("[\"%'`$]", "_") ;
		return str ;
	}
	
	public int generateInt(EObject o) {
		Random ran = new Random();
		return ran.nextInt() ;
	}
}