<%
metamodel http://www.acceleo.org/module/wisss/webapp

import services.NamingServices
%>

<%script type="webapp.Webapp" name="integrity" file="tests/data/mysql/test_integrity.php"%>
<?php
require_once 'PHPUnit/Framework.php';
require_once 'PHPUnit/TextUI/TestRunner.php';
require_once 'data/mysql/integrity.php' ;

class MysqlIntegrityTestSuite extends PHPUnit_Framework_TestSuite
{
	public static function main()
    {
        PHPUnit_TextUI_TestRunner::run(self::suite());
    }
    
    protected function setUp()
    {
        require_once 'Zend/Config/Ini.php';
		$GLOBALS['config'] = new Zend_Config_Ini('test.conf', 'database');
		require_once 'Zend/Db.php' ;
		$GLOBALS['db'] = Zend_Db::factory($GLOBALS['config']);
		$queries = explode(';',file_get_contents($GLOBALS['config']->install_files.'/mysql_install.sql')) ;
		foreach($queries as $query) {
		$escaped_query = trim($query) ;
			if(!empty($escaped_query)) {
				$GLOBALS['db']->query($escaped_query) ;
			}
		}
    }
 
 	public static function suite()
 	{
 		$suite = new MysqlIntegrityTestSuite('MysqlTest') ;
		return $suite ;
 	}
 
    protected function tearDown()
    {
        $queries = explode(';',file_get_contents($this->config->install_files.'/mysql_uninstall.sql')) ;
		foreach($queries as $query) {
		$escaped_query = trim($query) ;
			if(!empty($escaped_query)) {
				$this->db->query($escaped_query) ;
			}
		}
    }
}

MysqlIntegrityTestSuite::main() ;
?>