<%
metamodel http://www.obeo.fr/dsl/mindmap
import services.StringServices
import services.ListServices
%>


<%script type="Topic" name="header"%>
<?xml version="1.0"?>
<html>
	<head>
		<title><%eContainer().title%></title>
		<meta http-equiv="content-type" content="text/html; charset=utf-8" />
		<style type="text/css" media="screen">
		      @import url("../css/screen.css");
		</style>
	</head>
	<body>
       <div id="page">
		<div id="container">
			<div id="header">				
			    <%navigation(self)%>							
				<div id="currentSlide">
					<h1 class="slideTitle"><%title%></h1>
				</div>
			</div>
			

<%script type="Topic" name="navigation"%>
				<div id="navigation">
					<%sections(args(0))%>
					<%subsections(args(0))%>
				</div>

<%script type="Topic" name="sections"%>
<div id="sections">
 <ul>
	<%for (eContainer.findRootTopic.subTopics.target){%>
		<%if (self == args(0).getMySection()){%>
			<li id="currentsection">
		<%}else{%>
	        <li>
		<%}%>
		<%if (subTopics.nSize > 0){%>
	        <a href="<%subTopics.nFirst().target.filename%>"><%title%></a>
		<%}else{%>
	        <%title%>
		<%}%>
	 </li>
	<%}%>
 </ul>
</div>

<%script type="Topic" name="subsections"%>
<div id="subsections">
	<ul>
	<%for (parentTopic.source.subTopics.target){%>
		<%if (self.getMySection == args(0).getMySection){%>
			<%if (self == args(0)){%>
			          <li id="currentsubsection">
			<%}else{%>
			          <li>
			<%}%>
		     <a href="<%filename%>"><%title%></a>
		     </li>
		<%}%>
	<%}%>
	</ul>
</div>

<%script type="Map" name="findRootTopic"%>
<%eAllContents.filter("Topic").select("isRootTopic")%>

<%script type="Topic" name="isRootTopic" post="trim()"%>
<%parentTopic.nSize == 0%>

<%script type="Topic" name="getMySection"%>
<%parentTopic.source%>

<%script type="Topic" name="content"%>
            <div id="content">
             <%for (ownedThreads){%>
	         	<div class="item">
	        		<h2><%title%></h2>
	        		<%for (ownedItems){%>
	        			<p>	
	        			<%content%>				
					    </p>        			
	        		<%}%>        			
				</div>             				
             <%}%>
           <%--now handling subtopics--%>
           <%subTopics.target.itemTopic%>
		    </div>

<%script type="Topic" name="itemTopic"%>
         	<div class="item">
        			<h2><%title%></h2>
        			<%for (ownedThreads){%>
	        			<p>	
	        			<%title%>				
					    </p>        			
        			<%}%>   
        			<!--<%startUserCode%> <%title%> -->
        			<!--<%endUserCode%> <%title%>	-->        			     			
			</div>             				


			
<%script type="Topic" name="footer"%>
<div id="footer">
				<div id="credits">
					<div id="preceding">
					<%if (getAllSubTopics.nIndexOf(self) > 0 && getAllSubTopics.nIndexOf(self) <= getAllSubTopics.nSize  - 1  ){%>
		              <a href="<%previousSlide.filename%>">&nbsp&nbsp&nbsp</a>				
					<%}%>
					</div>
					<span>© 2006 </span>
				</div>
				<div id="titlereminder">
				<span>Acceleo</span>
					<div id="following">
					<%if (getAllSubTopics.nIndexOf(self) >= 0 && getAllSubTopics.nIndexOf(self) < getAllSubTopics.nSize  - 1  ){%>
		              <a href="<%nextSlide.filename%>">&nbsp&nbsp&nbsp</a>				
					<%}%>
					</div>
				</div>                              
			</div>
		</div>

					
     
              </div>
              <div id="footershadow">
          </div>
	</body>
</html>

<%script type="Topic" name="nextSlide" %>
<%getAllSubTopics.nGet(getAllSubTopics.nIndexOf(self) + 1)%>
<%script type="Topic" name="previousSlide" %>
<%getAllSubTopics.nGet(getAllSubTopics.nIndexOf(self)  - 1)%>
<%script type="Topic" name="getAllSubTopics"%>
<%parentTopic.source.parentTopic.source.subTopics.target.subTopics.target%>
<%script type="Topic" name="filename" %>
slide_<%title.noSpecials()%>.html