package org.acceleo.sample.demo.spring.services;


import java.util.Collection;


import org.acceleo.sample.demo.spring.entities.Product;


import org.sharengo.exceptions.TechnicalException;

// Start of user code for import

// End of user code for import

public interface IProductsServices {
		/**
	 * 
	 * @return 
	 */
	public Collection<Product> getListOfProducts() throws TechnicalException;
		/**
	 * 
	 * @param id 
	 * @return 
	 */
	public Product getProduct(String id) throws TechnicalException;
		/**
	 * 
	 * @param product 
	 * @return 
	 */
	public Product addProduct(Product product) throws TechnicalException;
		/**
	 * 
	 * @param product 
	 */
	public void updateProduct(Product product) throws TechnicalException;
		/**
	 * 
	 * @param product 
	 */
	public void removeProduct(Product product) throws TechnicalException;
}